/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 4.05 or later
*(C)*
*(C)* Copyright (c) 1997 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

/*
	Example user function source illustrating use of call back to mvEval()
*/
#define MVCALLBACKS   /*indicates use of call backs; required*/
#include "Userfun.h"

#ifndef MACINTOSH
#define MAINFUN  /*if defined, compile fooeval*/
#ifndef DJGPP
#define INFOFUN  /*if defined, compile arginfo function for fooeval*/
#endif
#define USERFUN fooeval
#define ARGINFO arginfo_fooeval
#else /*MACINTOSH*/

/*
	For PPC MAC, one function must be called main
	For 68K MAC, only one function is reachable per compilation
	project and it must be called main
*/
#ifdef powerc
#define MAINFUN
#define INFOFUN
#define main_fooeval main
#else /*powerc*/
/* define which of the 2 functions this project is for*/
#define WHICHFUN 1

#if WHICHFUN == 1
#define MAINFUN
#else
#define INFOFUN
#endif

#if defined(MAINFUN)
#define main_fooeval main
#else
#define main_info    main
#endif

#endif /*powerc*/
#define USERFUN       main_fooeval
#define USERFUNENTRY  fooeval
#define ARGINFO       main_info
#define ARGINFOENTRY  arginfo_fooeval

#endif /*MACINTOSH*/

#ifdef MAINFUN
void EXPORTED USERFUN(CHARARG(commandarg), CALLBACKLIST(funlist))
{
	char              **commandH = THECOMMAND(commandarg);
	Symbolhandle        result;
	char                line[200];
	sprintftype         sprintf; /*type defined in Userfun.h*/
	
	EnterCode();
	setMvFuns(funlist); /*initializes global duplicate of funlist*/

	sprintf = (sprintftype) mvFindfun("sprintf");

	result = mvEval(commandH);
	
	if (result != (Symbolhandle) 0)
	{
		switch (TYPE(result))
		{
		  case CHAR:
			sprintf(line, "STRINGPTR(result) = '%s'", STRINGPTR(result));
			break;

		  case REAL:
			if (!mvIsmissing(&DATAVALUE(result,0)))
			{
				sprintf(line, "DATAVALUE(result,0) = %.17g",
					  DATAVALUE(result,0));
			}
			else
			{
				sprintf(line, "DATAVALUE(result,0) = MISSING");
			}

			break;

		  case LOGIC:
			sprintf(line, "DATAVALUE(result,0) = %c",
					(DATAVALUE(result,0)) ? 'T' : 'F');
			break;

		  case NULLSYM:
			sprintf(line, "Result is NULL");
			break;

		  default:
			sprintf(line,
					"Type %ld of result not CHARACTER, REAL, LOGICAL, or NULL",
					TYPE(result));
		}
		mvPrint(line);
	}
	else
	{
		mvAlert("ERROR: Command produced error");
		/*tell User() error occurred but no message should be printed*/
		mvSeterror(silentCallbackError);
	}
	ExitCode();
} /*fooeval()*/
#endif /*MAINFUN*/

#ifdef INFOFUN
static long Fooevalarginfo[] =
	  {1, DOESCALLBACK | POINTERUSE | NOSYMBOLARGS, CHARSCALAR};

#ifdef PRAGMAMPWC
#pragma mpwc on
#endif /*PRAGMAMPWC*/

long * EXPORTED ARGINFO(void)
{
	long         *arginfo;

	EnterCode();

	arginfo = Fooevalarginfo;
	CHECK68881(arginfo);
	ExitCode();
	return(arginfo);
}
#ifdef PRAGMAMPW
#pragma mpwc off
#endif /*PRAGMAMPW*/

#endif /*INFOFUN*/

#ifdef powerc
RoutineDescriptor USERFUNENTRY =
   BUILD_ROUTINE_DESCRIPTOR(uppMainEntryProcInfo02, USERFUN);
RoutineDescriptor ARGINFOENTRY =
   BUILD_ROUTINE_DESCRIPTOR(uppArgInfoEntryProcInfo, ARGINFO);
#endif /*powerc*/
