/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 4.05 or later
*(C)*
*(C)* Copyright (c) 1997 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

/*
	Example user function source to compute the inner product of two
	REAL vectors.  Called by User("goo",x,y,asLong(length(x)),result:0)
*/
#include "Userfun.h"

#ifndef MACINTOSH
#define MAINFUN    /*main entry will be compiled*/
#ifndef DJGPP
#define INFOFUN    /*arginfo entry will be compiled*/
#endif /*DJGPP*/
#define USERFUN goo
#define ARGINFO arginfo_goo
#else /*!MACINTOSH*/

/*
	For PPC MAC, one function must be called main
	For 68K MAC, only one function is reachable per compilation
	project and it must be called main
*/
#ifdef powerc
#define MAINFUN    /*main entry will be compiled*/
#define INFOFUN    /*arginfo entry will be compiled*/
#define main_goo main
#else /*powerc*/

/* define which of the 2 functions will be compiled*/
#define WHICHFUN 1  /*must be 1 or 2 */
#if WHICHFUN == 1
#define MAINFUN
#else
#define INFOFUN
#endif

#if defined(MAINFUN)
#define main_goo    main
#else
#define info_goo    main
#endif

#endif /*powerc*/

#define USERFUN      main_goo
#define USERFUNENTRY goo
#define ARGINFO      info_goo
#define ARGINFOENTRY arginfo_goo

#endif /*!MACINTOSH*/

#ifdef MAINFUN
/*
  EXPORTED is _export for Windows compiled by Borland C/C++ 4.5
  DOUBLEARG(argx) expands as double * argx or double ** argx, and
  similarly for LONGARG(argn)
*/
void EXPORTED USERFUN(DOUBLEARG(argx), DOUBLEARG(argy), LONGARG(argn),
	DOUBLEARG(argresult))
{
/* THEARG(argx) expands as argx or *argx */
	double      *x = THEARG(argx);
	double      *y = THEARG(argy);
	long        *n = THEARG(argn);
	double      *result = THEARG(argresult);
	int          i;

	EnterCode();
	*result = 0.0;
	for (i = 0; i < *n; i++)
	{
		*result += x[i]*y[i];
	}
	ExitCode();
}
#endif /*MAINFUN*/

#ifdef INFOFUN
static long Gooarginfo[] =
{
	4, NOCALLBACK | POINTERUSE | NOSYMBOLARGS,
	NONMISSINGREALVECTOR, NONMISSINGREALVECTOR, LONGSCALAR, REALSCALAR
};

#ifdef PRAGMAMPWC /*PRAGMAMPWC defined only for 68K Mac*/
#pragma mpwc on
#endif /*PRAGMAMPWC*/
long * EXPORTED ARGINFO(void)
{
	long         *arginfo;

	EnterCode();

	arginfo = Gooarginfo;
	CHECK68881(arginfo);

	ExitCode();

	return(arginfo);
}
#ifdef PRAGMAMPWC
#pragma mpwc off
#endif /*PRAGMAMPWC*/
#endif /*INFOFUN*/

#ifdef powerc /*powerc defined means compiling for Power PC */
RoutineDescriptor USERFUNENTRY =
	BUILD_ROUTINE_DESCRIPTOR(uppMainEntryProcInfo04, USERFUN);
RoutineDescriptor ARGINFOENTRY =
	BUILD_ROUTINE_DESCRIPTOR(uppArgInfoEntryProcInfo, ARGINFO);
#endif /*powerc*/
