#include "cpcplatform.h"

#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "buttoncontrols.h"

IMPLEMENT_DYNAMIC_CLASS(wxTextButton,wxButton)

BEGIN_EVENT_TABLE(wxTextButton,wxButton)
    EVT_BUTTON( CPC_DLGCTRL_TEXTBUTTON, wxTextButton::OnClicked )
END_EVENT_TABLE()

wxTextButton::wxTextButton()
{
}

wxTextButton::~wxTextButton()
{     
}

extern const wxChar *wxTextButtonNameStr = wxT("text_button");

void wxTextButton::OnClicked( wxCommandEvent &event )
{
        wxSizer *topsizer;
        wxTextCtrl *text;
        wxDialog dlg(this, -1, wxString(_("About")));

        topsizer = new wxBoxSizer(wxVERTICAL);

        text = new wxTextCtrl(&dlg, -1, _T("This is the log window.\n"), wxDefaultPosition, wxSize(380, 160), wxTE_MULTILINE);
        text -> LoadFile(path);
	text -> SetEditable(FALSE);

        topsizer -> Add(text, 1, wxALL, 10);

        topsizer -> Add(new wxStaticLine(&dlg, -1), 0, wxEXPAND | wxLEFT | wxRIGHT, 10);
                        
        wxButton *bu1 = new wxButton(&dlg, wxID_OK, _("OK"));
        bu1 -> SetDefault();

        topsizer -> Add(bu1, 0, wxALL | wxALIGN_RIGHT, 15);

        dlg.SetAutoLayout(TRUE);
        dlg.SetSizer(topsizer);
        topsizer -> Fit(&dlg);

        dlg.ShowModal();
}


IMPLEMENT_DYNAMIC_CLASS(wxTextButtonXmlHandler,wxXmlResourceHandler)

wxTextButtonXmlHandler::wxTextButtonXmlHandler() 
: wxXmlResourceHandler() 
{
    XRC_ADD_STYLE(wxBU_LEFT);
    XRC_ADD_STYLE(wxBU_RIGHT);
    XRC_ADD_STYLE(wxBU_TOP);
    XRC_ADD_STYLE(wxBU_BOTTOM);
    XRC_ADD_STYLE(wxBU_EXACTFIT);
    AddWindowStyles();
}

wxObject *wxTextButtonXmlHandler::DoCreateResource()
{ 
   XRC_MAKE_INSTANCE(textbutton, wxTextButton)

   textbutton->Create(m_parentAsWindow,
                    CPC_DLGCTRL_TEXTBUTTON,
                    GetText(wxT("label")),
                    GetPosition(), GetSize(),
                    GetStyle(),
                    wxDefaultValidator,
                    GetName());
    textbutton->path = GetText(wxT("path"));

    if (GetBool(wxT("default"), 0))
        textbutton->SetDefault();
    SetupWindow(textbutton);
    
    return textbutton;
}

bool wxTextButtonXmlHandler::CanHandle(wxXmlNode *node)
{
    return IsOfClass(node, wxT("wxTextButton"));
}

IMPLEMENT_DYNAMIC_CLASS(wxHtmlButton,wxButton)

BEGIN_EVENT_TABLE(wxHtmlButton,wxButton)
    EVT_BUTTON( CPC_DLGCTRL_HTMLBUTTON, wxHtmlButton::OnClicked )
END_EVENT_TABLE()

wxHtmlButton::wxHtmlButton()
{
}

wxHtmlButton::~wxHtmlButton()
{     
}

extern const wxChar *wxHtmlButtonNameStr = wxT("html_button");

void wxHtmlButton::OnClicked( wxCommandEvent &event )
{
        wxSizer *topsizer;
        wxHtmlWindow *html;
        wxDialog dlg(this, -1, wxString(_("About")));

        topsizer = new wxBoxSizer(wxVERTICAL);

        html = new wxHtmlWindow(&dlg, -1, wxDefaultPosition, wxSize(380, 160), wxHW_SCROLLBAR_AUTO);
        html -> SetBorders(0);
        html -> LoadPage(url);
        html -> SetSize(html -> GetInternalRepresentation() -> GetWidth(), 
                        html -> GetInternalRepresentation() -> GetHeight());

        topsizer -> Add(html, 1, wxALL, 10);

        topsizer -> Add(new wxStaticLine(&dlg, -1), 0, wxEXPAND | wxLEFT | wxRIGHT, 10);
                        
        wxButton *bu1 = new wxButton(&dlg, wxID_OK, _("OK"));
        bu1 -> SetDefault();

        topsizer -> Add(bu1, 0, wxALL | wxALIGN_RIGHT, 15);

        dlg.SetAutoLayout(TRUE);
        dlg.SetSizer(topsizer);
        topsizer -> Fit(&dlg);

        dlg.ShowModal();
}


IMPLEMENT_DYNAMIC_CLASS(wxHtmlButtonXmlHandler,wxXmlResourceHandler)

wxHtmlButtonXmlHandler::wxHtmlButtonXmlHandler() 
: wxXmlResourceHandler() 
{
    XRC_ADD_STYLE(wxBU_LEFT);
    XRC_ADD_STYLE(wxBU_RIGHT);
    XRC_ADD_STYLE(wxBU_TOP);
    XRC_ADD_STYLE(wxBU_BOTTOM);
    XRC_ADD_STYLE(wxBU_EXACTFIT);
    AddWindowStyles();
}

wxObject *wxHtmlButtonXmlHandler::DoCreateResource()
{ 
   XRC_MAKE_INSTANCE(htmlbutton, wxHtmlButton)

   htmlbutton->Create(m_parentAsWindow,
                    CPC_DLGCTRL_HTMLBUTTON,
                    GetText(wxT("label")),
                    GetPosition(), GetSize(),
                    GetStyle(),
                    wxDefaultValidator,
                    GetName());
    htmlbutton->url = GetText(wxT("url"));

    if (GetBool(wxT("default"), 0))
        htmlbutton->SetDefault();
    SetupWindow(htmlbutton);
    
    return htmlbutton;
}

bool wxHtmlButtonXmlHandler::CanHandle(wxXmlNode *node)
{
    return IsOfClass(node, wxT("wxHtmlButton"));
}
