#ifndef _BUTTONCONTROLS_H_
#define _BUTTONCONTROLS_H_

#include "cpcdefs.h"
#include "wx/wxhtml.h"
#include "wx/button.h"
#include "wx/defs.h"
#include "wx/object.h"
#include "wx/list.h"
#include "wx/control.h"
#include "wx/sizer.h"
#include "wx/statline.h"


#include "wx/xrc/xmlres.h"

WXDLLEXPORT_DATA(extern const wxChar*) wxTextButtonNameStr;

class wxTextButton : public wxButton
{
public:
    wxTextButton();
    wxTextButton(wxWindow *parent, wxWindowID id, const wxString& label,
           const wxPoint& pos = wxDefaultPosition,
           const wxSize& size = wxDefaultSize, long style = 0,
           const wxValidator& validator = wxDefaultValidator,
           const wxString& name = wxTextButtonNameStr)
    {
      Create(parent, id, label, pos, size, style, validator, name);
    }
    virtual ~wxTextButton();
    wxString path;

protected:
    
private:
    void OnClicked( wxCommandEvent &event );
    DECLARE_EVENT_TABLE();
    DECLARE_DYNAMIC_CLASS(wxTextButton)
};


//class WXXMLDLLEXPORT wxTextButtonXmlHandler : public wxXmlResourceHandler
class wxTextButtonXmlHandler : public wxXmlResourceHandler
{
public:
    wxTextButtonXmlHandler();
    virtual wxObject *DoCreateResource();
    virtual bool CanHandle(wxXmlNode *node);
private:
    DECLARE_DYNAMIC_CLASS(wxTextButtonXmlHandler)
};


WXDLLEXPORT_DATA(extern const wxChar*) wxHtmlButtonNameStr;

class wxHtmlButton : public wxButton
{
public:
    wxHtmlButton();
    wxHtmlButton(wxWindow *parent, wxWindowID id, const wxString& label,
           const wxPoint& pos = wxDefaultPosition,
           const wxSize& size = wxDefaultSize, long style = 0,
           const wxValidator& validator = wxDefaultValidator,
           const wxString& name = wxHtmlButtonNameStr)
    {
      Create(parent, id, label, pos, size, style, validator, name);
    }
    virtual ~wxHtmlButton();
    wxString url;

protected:
    
private:
    void OnClicked( wxCommandEvent &event );
    DECLARE_EVENT_TABLE();
    DECLARE_DYNAMIC_CLASS(wxHtmlButton)
};

//class WXXMLDLLEXPORT wxHtmlButtonXmlHandler : public wxXmlResourceHandler
class wxHtmlButtonXmlHandler : public wxXmlResourceHandler
{
public:
    wxHtmlButtonXmlHandler();
    virtual wxObject *DoCreateResource();
    virtual bool CanHandle(wxXmlNode *node);
private:
    DECLARE_DYNAMIC_CLASS(wxHtmlButtonXmlHandler)
};


#endif /* _WX_TEXT_BUTTON_H_BASE_ */
