#ifndef _XMLRESOURCES_H_
#define _XMLRESOURCES_H_

#include "cpcdefs.h"
#include "wx/wxhtml.h"
#include "wx/button.h"
#include "wx/defs.h"
#include "wx/object.h"
#include "wx/list.h"
#include "wx/control.h"
#include "wx/sizer.h"
#include "wx/statline.h"


#include "wx/xrc/xmlres.h"

class cpcDisplayButton : public wxButton
{
public:
	cpcDisplayButton();
	cpcDisplayButton(wxWindow *parent, wxWindowID id, const wxString& label,
	const wxPoint& pos = wxDefaultPosition,
	const wxSize& size = wxDefaultSize, long style = 0);
	~cpcDisplayButton();


	wxSize size;
	wxPoint pos;
	wxString textcontent;
	wxString textfile;
	wxString htmlcontent;
	wxString htmlfile;
	wxString title;

protected:
    
private:
    void OnClicked( wxCommandEvent &event );
    DECLARE_EVENT_TABLE();
    DECLARE_DYNAMIC_CLASS(cpcDisplayButton)
};

class cpcHtmlWindow : public wxHtmlWindow
{
public:
	cpcHtmlWindow();
	cpcHtmlWindow(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition,
	const wxSize& size = wxDefaultSize, long style = wxHW_SCROLLBAR_AUTO);
	~cpcHtmlWindow();

	bool EnableLinks;
	void OnMouseEvent(wxMouseEvent& event);

private:
    DECLARE_EVENT_TABLE();
    DECLARE_DYNAMIC_CLASS(cpcHtmlWindow)
};


class cpcDisplayButtonXmlHandler : public wxXmlResourceHandler
{
public:
    cpcDisplayButtonXmlHandler();
    virtual wxObject *DoCreateResource();
    virtual bool CanHandle(wxXmlNode *node);
private:
    DECLARE_DYNAMIC_CLASS(cpcDisplayButtonXmlHandler)
};

class cpcHtmlControlXmlHandler : public wxXmlResourceHandler
{
public:
    cpcHtmlControlXmlHandler();
    virtual wxObject *DoCreateResource();
    virtual bool CanHandle(wxXmlNode *node);
private:
    DECLARE_DYNAMIC_CLASS(cpcHtmlControlXmlHandler)
};

class cpcTextControlXmlHandler : public wxXmlResourceHandler
{
public:
    cpcTextControlXmlHandler();
    virtual wxObject *DoCreateResource();
    virtual bool CanHandle(wxXmlNode *node);
private:
    DECLARE_DYNAMIC_CLASS(cpcTextControlXmlHandler)
};

#endif
