/*
*(C)* The file is part of the source distribution of Carapace
*(C)* version 0.5 or later
*(C)*
*(C)* Copyright (c) 2000-2005 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* This file is distributed under the GNU General Public License
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifndef CARAPACEDEFSH__
#define CARAPACEDEFSH__

#ifndef OUTLINESIZE
#define OUTLINESIZE 400
#endif /*OUTLINESIZE*/

#define UNDOBUFFERINITIALALLOCATION   2000  /* beginning size for UndoBuffer, can be increased */




/*
	Globals and defines related to undoing and redoing
*/

/* possible values for UndoStatus */
#define DELETEUNDO    1
#define OUTPUTUNDO    2
#define PASTEUNDO     3
#define CUTUNDO       4
#define TYPINGUNDO    5
#define CANTUNDO      0
#define DELETEREDO   -1 /* not currently used */
#define OUTPUTREDO   -2
#define PASTEREDO    -3 /* not currently used */
#define CUTREDO      -4 /* not currently used */
#define TYPINGREDO   -5

/*
	When UndoStatus == OUTPUTUNDO, LastLength is the length of the buffer,
	less 1 for the trailing newline, just before a command line is executed,
	and LastCmdStrPos is the value of CmdStrPos at that time.  
*/



#undef UNDEFINED__


#undef LF
#undef CR
#undef NL
#define LF            10
#define NL            10
#define CR            13

#define EOL_LENGTH 1
#define EOL_STRING "\n"


#define CPC_INTNOTSET       0x00000  /* no interrupt in progress */
#define CPC_INTSET          0x10000  /* interrupt occurred */

extern long        CPC_INTERRUPT;


#define CPC_GRAPHSPERPANEL 4
#define CPC_PANELROWS 2
#define CPC_PANELCOLS 2


#define CPC_LEADING                     0

enum menuCodes
{
CPC_MENU_SEPARATOR     =        5,
CPC_MENU_BREAK,

CPC_FILE_OPEN              =  100,
CPC_FILE_SAVEWINDOW,
CPC_FILE_SAVEWINDOWAS,
CPC_FILE_PAGESETUP,
CPC_FILE_PRINTSELECTION,
CPC_FILE_INTERRUPT,
CPC_FILE_GOON,
CPC_FILE_RESTOREWORKSPACE,
CPC_FILE_SAVEWORKSPACE,
CPC_FILE_SAVEWORKSPACEAS,
CPC_FILE_PREFERENCES,
CPC_FILE_QUIT,
CPC_FILE_FASTQUIT,

CPC_EDIT_UNDO            =    120,
CPC_EDIT_CUT,
CPC_EDIT_COPY,
CPC_EDIT_PASTE,
CPC_EDIT_COPYTOEND,
CPC_EDIT_DUMPTEXT,
CPC_EDIT_EXECUTE,
CPC_EDIT_UPHISTORY,
CPC_EDIT_DOWNHISTORY,

CPC_WINDOWS_HIDE          =   130,
CPC_WINDOWS_CLOSE,
CPC_WINDOWS_NEWWINDOW,
CPC_WINDOWS_GRAPH,
CPC_WINDOWS_GOTOTOP,
CPC_WINDOWS_GOTOEND,
CPC_WINDOWS_PAGEUP,
CPC_WINDOWS_PAGEDOWN,
CPC_WINDOWS_TEXTWINDOW,
CPC_WINDOWS_TEXTWFONT,
CPC_WINDOWS_TEXTWFCOLOR,
CPC_WINDOWS_TEXTWBCOLOR,
CPC_WINDOWS_GOTOCOMMANDPOINT,
CPC_WINDOWS_FASTCLOSE,
CPC_WINDOWS_DIALOGS,
CPC_WINDOWS_SHOWMATCH,
CPC_WINDOWS_SHOWERROR,
CPC_WINDOWS_ZOOMIN,
CPC_WINDOWS_ZOOMOUT,
CPC_WINDOWS_FIT,
CPC_WINDOWS_FITPRESERVE,
CPC_WINDOWS_SETASPECT,
CPC_WINDOWS_REVERT,

CPC_HELP_ABOUT             =  200,
CPC_HELP_HELP,
CPC_HELP_FORWARD,
CPC_HELP_BACK,
CPC_HELP_OPEN,
CPC_HELP_TOOLBAR,

CPC_DIALOGS_HISTORYSLIDER  =  220,
CPC_DIALOGS_HISTORYSPINNER,
CPC_DIALOGS_HISTORYCOUNTER,
CPC_DIALOGS_EXECUTEBUTTON,
CPC_DIALOGS_BACKBUTTON,
CPC_DIALOGS_FORWARDBUTTON,
CPC_DIALOGS_CLEARBUTTON,
CPC_DIALOGS_UNDOBUTTON,
CPC_DIALOGS_INTERRUPTBUTTON,
CPC_DIALOGS_COMMANDWINDOW,
CPC_DIALOGS_OPENMATCHES,
CPC_DIALOGS_RUNNING,
CPC_DIALOGS_SYNTAXERROR,

CPC_GRAPHICS_PAGESETUP     =  300,
CPC_GRAPHICS_PRINT,
CPC_GRAPHICS_HIDE,
CPC_GRAPHICS_CLOSE,
CPC_GRAPHICS_EPSPRINT,

CPC_GUI_FILESELECTION   =   400,
CPC_GUI_PROCESSCOMMAND,
CPC_GUI_FLUSHBUFFER,
CPC_GUI_SETHISTORYINDEX,
CPC_GUI_NEWTEXTFRAME,
CPC_GUI_NEWSTATICGRAPH,
CPC_GUI_SETCLIPBOARD,

CPC_SERVER_MAIN = 450,
CPC_SERVER_BACK,
CPC_SERVER_INTR,
CPC_SOCKET_MAIN,
CPC_SOCKET_BACK,
CPC_SOCKET_INTR,

CPC_TEXT_WINDOWS_BASE   =      500,
CPC_GRAPH_WINDOWS_BASE  =      1000,
CPC_DIALOG_WINDOWS_BASE =      1500,
};


enum dialogsandcontrolsCodes
{
CPC_DLGCTRL_HTMLBUTTON = 100,
CPC_DLGCTRL_TEXTBUTTON,
CPC_DLGCTRL_LISTCLICK,
};
 

#define CPC_IDLE      0
#define CPC_RUNNING   1
#define CPC_DONE      2

enum staticgraphCodes
{
CPC_SG_STRUCTURETYPE = 1,
CPC_SG_STRINGTYPE,
};
 
#endif /*CARAPACEDEFSH__*/
