/*
*(C)* The file is part of the source distribution of Carapace
*(C)* version 0.5 or later
*(C)*
*(C)* Copyright (c) 2000-2005 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* This file is distributed under the GNU General Public License
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/


#ifndef CARAPACEINTERFACEH__
#define CARAPACEINTERFACEH__

enum commandCodes
{
	/* quitting constants */
	CPC_EXIT_FASTFORCEQUIT  =  0,     /* just die, no recourse */
	CPC_EXIT_SAVEFORCEQUIT,           /* must quit, but can save */
	CPC_EXIT_SAVECANCANCEL,           /* can save or cancel */
	CPC_EXIT_NOQUIT,

	/* command codes for setting callback functions */
	CPC_CB_INPUTREADY = 1000,
	CPC_CB_PROCESSCOMMAND,
	CPC_CB_PROCESSMENUCOMMAND,
	CPC_CB_CLEANUP,
	CPC_CB_INTERRUPTCLEANUP,
	CPC_CB_QUITCLEANUP,
	CPC_CB_INITIALIZER,
	CPC_CB_WINDOWCLOSED,
	CPC_CB_SGMOUSECLICK,
	CPC_CB_SETPREFSFILEPATH,

	/* io codes */
	CPC_IO_SETPROMPT = 1100,
	CPC_IO_SWALLOWOUTPUT,
	CPC_IO_BUFFEREDPRINT,
	CPC_IO_FLUSHBUFFER,
	CPC_IO_GETCLIPTEXTLENGTH,
	CPC_IO_GETCLIPTEXT,
	CPC_IO_SETCLIPTEXT,
	CPC_IO_ALERT,
	CPC_IO_BEEP,
	CPC_IO_SETCMDWINDFROMFILE,
	CPC_IO_SHOWCMDWINDOW,
	CPC_IO_USEA4PAPER,
	CPC_IO_GETRESOURCEFILE,
	CPC_IO_GETPREFSFILE,
	CPC_IO_PARENMATCH,
	CPC_IO_SYNTAXERROR,
	CPC_IO_FILENAMEFROMPATH,
	CPC_IO_PATHONLY,
	CPC_IO_NEWWINDOW,
	CPC_IO_YES,
	CPC_IO_NO,
	CPC_IO_CANCEL,
	CPC_IO_INTERRUPTED,
	CPC_IO_PRIMARYSELECTION,
	CPC_IO_GETPROGRAMROOT,  
	CPC_IO_EXPANDFILENAME,
	CPC_IO_VALIDFILENAME,
	CPC_IO_SPLASH,
	CPC_IO_GIFTYPE,
	CPC_IO_JPEGTYPE,
	CPC_IO_PNGTYPE,
	CPC_IO_XPMTYPE,
	CPC_IO_PUSHCOMMAND,


	/* history codes */
	CPC_HS_ADDTOHISTORY = 1200,
	CPC_HS_RESETHISTORY,
	CPC_HS_GETHISTORYLENGTH,
	CPC_HS_GETHISTORYLINE,
	CPC_HS_GETHISTORYLINELENGTH,
	CPC_HS_SETHISTORYLENGTH,

	/* standard dialogs */
	CPC_DLG_GETFILENAME = 1300,
	CPC_DLG_GETFILENAMESAVE,
	CPC_DLG_GETFILENAMEREAD,
	CPC_DLG_GETDIRNAME,
	CPC_DLG_GETTEXTFROMUSER,
	CPC_DLG_YESNOCANCELMESSAGE,
	CPC_DLG_YESNOMESSAGE,
	CPC_DLG_OKMESSAGE,
	CPC_DLG_HELPFRAME,

	/* user menus */
	CPC_MENU_SETUPUSERMENUS,
	CPC_MENU_GETMENURESOURCELENGTH,
	CPC_MENU_GETMENURESOURCE,

	/* user ModalDialog*/
	CPC_MDLG_SETUPUSERMDLGS,
	CPC_MDLG_GETLASTMDLGOUTPUTLENGTH,
	CPC_MDLG_GETLASTMDLGOUTPUT,

	/* Dynamic data */
	// The following was Written on Feb 26,2005
	CPC_DYN_ADDDATAOBJECT,
	CPC_DYN_MAKEPERSISTENTDATAOBJECT,
	CPC_DYN_DELETEDATAOBJECT,
	CPC_DYN_GETDATAOBJECTVALUE,
	CPC_DYN_SETDATAOBJECTVALUE,
	CPC_DYN_ADDVIEWER,
	CPC_DYN_SETVIEWERDATA,
	CPC_DYN_DELETEVIEWER,
	CPC_DYN_GETVIEWERSTATE,
	CPC_DYN_SETVIEWERSTATE,
	CPC_DYN_REDRAW,

	CPC_DYN_INSERTDATAOBJECTROW,
	CPC_DYN_APPENDDATAOBJECTROW,
	CPC_DYN_CHANGEDATAOBJECTROW,
	CPC_DYN_DELETEDATAOBJECTROW,
	CPC_DYN_INSERTDATAOBJECTCOL,
	CPC_DYN_APPENDDATAOBJECTCOL,
	CPC_DYN_CHANGEDATAOBJECTCOL,
	CPC_DYN_DELETEDATAOBJECTCOL,
	CPC_DYN_SETDATAOBJECTELEMENT,
	CPC_DYN_GETDATAOBJECTPROPERTY,   // appended on March 21,2005
	// The above was Written on Feb 26,2005

	CPC_DYN_SETUPDIALOG,
	CPC_DYN_COLORSMALL,
	CPC_DYN_COLORMEDIUM,
	CPC_DYN_COLORLARGE,
	CPC_DYN_GLYPH,


	/* static graphics commands */

	CPC_SG_NEWGRAPH,
	CPC_SG_GRAPHICSPAUSE,
	CPC_SG_NEWPENNAME,
	CPC_SG_NEWPENRGB,
	CPC_SG_NEWBRUSHNAME,
	CPC_SG_NEWBRUSHRGB,
	CPC_SG_SETBACKGROUNDNAME,
	CPC_SG_SETBACKGROUNDRGB,
	CPC_SG_SETFOREGROUNDNAME,
	CPC_SG_SETFOREGROUNDRGB,
	CPC_SG_SETFONT,
	CPC_SG_SETFONTNAME,
	CPC_SG_DRAWLINE,
	CPC_SG_DRAWTEXT,
	CPC_SG_DRAWTEXTUP,
	CPC_SG_DRAWTEXTDOWN,
	CPC_SG_GETCHARWIDTH,
	CPC_SG_GETCHARHEIGHT,
	CPC_SG_GETTEXTWIDTH,
	CPC_SG_SETHORTRANS,
	CPC_SG_SETVERTTRANS,
	CPC_SG_DOPAINT,
	CPC_SG_SAVESTATE,
	CPC_SG_RESTORESTATE,
	CPC_SG_OPENPOSTSCRIPTFILE,
	CPC_SG_OPENPOSTSCRIPTPAGE,
	CPC_SG_CLOSEPOSTSCRIPTFILE,
	CPC_SG_CLOSEPOSTSCRIPTPAGE,
	CPC_SG_XPARMS,
	CPC_SG_YPARMS,
	CPC_SG_DODRAW,

	CPC_SG_AXISLINEAR,
	CPC_SG_AXISLOG10,
	CPC_SG_AXISLOG2,
	CPC_SG_AXISLOGE,
	CPC_SG_AXISRECIPROCAL,

	CPC_SG_LEFTTOP,
	CPC_SG_CENTERTOP,
	CPC_SG_RIGHTTOP,
	CPC_SG_LEFTBASELINE,
	CPC_SG_CENTERBASELINE,
	CPC_SG_RIGHTBASELINE,
	CPC_SG_LEFTBOTTOM,
	CPC_SG_CENTERBOTTOM,
	CPC_SG_RIGHTBOTTOM,

	CPC_SG_SOLID,
	CPC_SG_DOT,
	CPC_SG_LONG_DASH,
	CPC_SG_SHORT_DASH,
	CPC_SG_DOT_DASH,

	CPC_SG_DEFAULT,  
	CPC_SG_DECORATIVE,
	CPC_SG_ROMAN,
	CPC_SG_SCRIPT,
	CPC_SG_SWISS,
	CPC_SG_MODERN,
	CPC_SG_TELETYPE,  
	CPC_SG_SYMBOL,
 
	CPC_SG_NORMAL,
	CPC_SG_LIGHT,
	CPC_SG_BOLD,
	CPC_SG_ITALIC,
	CPC_SG_SLANT,

	CPC_SG_TRANSPARENT,
	CPC_SG_BDIAGONAL_HATCH,
	CPC_SG_CROSSDIAG_HATCH,
	CPC_SG_FDIAGONAL_HATCH,
	CPC_SG_CROSS_HATCH,
	CPC_SG_HORIZONTAL_HATCH,
	CPC_SG_VERTICAL_HATCH,

	CPC_SG_NONE,
	CPC_SG_CIRCLE,
	CPC_SG_DIAMOND,
	CPC_SG_SQUARE,
	CPC_SG_TRIANGLE,
	CPC_SG_EXE,
	CPC_SG_CROSS,
	CPC_SG_STAR,
	CPC_SG_DINGBAT,

	CPC_SG_SETAFMPATH,

	CPC_SG_CHOOSEFRAME,
	CPC_SG_NOMOUSEREQUEST,
	CPC_SG_MOUSEDONE,
	CPC_SG_MOUSEPOINT,
	CPC_SG_MOUSESEGMENT,
	CPC_SG_MOUSEBOX,
	CPC_SG_MOUSERESTART,
	CPC_SG_MOUSELEAVE,
	CPC_SG_MOUSEQUIT,
	CPC_SG_MOUSEINTERRUPT,
	CPC_SG_CLEARMOUSETRACKS,


	CPC_TAILENDCHARLIE
};

enum pointStyles
{
	CPC_SG_FILLED = 1,
	CPC_SG_LEFT = 2,
	CPC_SG_RIGHT = 4,
	CPC_SG_UP = 8,
	CPC_SG_DOWN = 16
};

enum windowTypes
{
	CPC_WINDOWTYPE_COMMAND = 1,
	CPC_WINDOWTYPE_GRAPH,
	CPC_WINDOWTYPE_FIT,
	CPC_WINDOWTYPE_FITASPECT,
	CPC_WINDOWTYPE_BESTFIT
};

enum colorCodes
{
	CPC_AQUAMARINE = 1,
	CPC_BLACK,
	CPC_BLUE,
	CPC_BLUE_VIOLET,
	CPC_BROWN,
	CPC_CADET_BLUE,
	CPC_CORAL,
	CPC_CORNFLOWER_BLUE,
	CPC_CYAN,
	CPC_DARK_GREY,
	CPC_DARK_GREEN,
	CPC_DARK_OLIVE_GREEN,
	CPC_DARK_ORCHID,
	CPC_DARK_SLATE_BLUE,
	CPC_DARK_SLATE_GREY,
	CPC_DARK_TURQUOISE,
	CPC_DIM_GREY,
	CPC_FIREBRICK,
	CPC_FOREST_GREEN,
	CPC_GOLD,
	CPC_GOLDENROD,
	CPC_GREY,
	CPC_GREEN,
	CPC_GREEN_YELLOW,
	CPC_INDIAN_RED,
	CPC_KHAKI,
	CPC_LIGHT_BLUE,
	CPC_LIGHT_GREY,
	CPC_LIGHT_STEEL_BLUE,
	CPC_LIME_GREEN,
	CPC_MAGENTA,
	CPC_MAROON,
	CPC_MEDIUM_AQUAMARINE,
	CPC_MEDIUM_BLUE,
	CPC_MEDIUM_FOREST_GREEN,
	CPC_MEDIUM_GOLDENROD,
	CPC_MEDIUM_ORCHID,
	CPC_MEDIUM_SEA_GREEN,
	CPC_MEDIUM_SLATE_BLUE,
	CPC_MEDIUM_SPRING_GREEN,
	CPC_MEDIUM_TURQUOISE,
	CPC_MEDIUM_VIOLET_RED,
	CPC_MIDNIGHT_BLUE,
	CPC_NAVY,
	CPC_ORANGE,
	CPC_ORANGE_RED,
	CPC_ORCHID,
	CPC_PALE_GREEN,
	CPC_PINK,
	CPC_PLUM,
	CPC_PURPLE,
	CPC_RED,
	CPC_SALMON,
	CPC_SEA_GREEN,
	CPC_SIENNA,
	CPC_SKY_BLUE,
	CPC_SLATE_BLUE,
	CPC_SPRING_GREEN,
	CPC_STEEL_BLUE,
	CPC_TAN,
	CPC_THISTLE,
	CPC_TURQUOISE,
	CPC_VIOLET,
	CPC_VIOLET_RED,
	CPC_WHEAT,
	CPC_WHITE,
	CPC_YELLOW,
	CPC_YELLOW_GREEN

};

#define CPC_SWALLOW_NOTHING  0
#define CPC_SWALLOW_FORCEIT  1
#define CPC_SWALLOW_PRINTOUT 2
#define CPC_SWALLOW_COMMANDS 4
#define CPC_SWALLOW_BOTH     6

#define CPC_INPUTREADY       0

enum errorCodes
{
	CPC_NOERROR = 0,
	CPC_ERROR_INITFAILURE,
	CPC_ERROR_UNINITIALIZED,
	CPC_ERROR_BADCODE,
	CPC_ERROR_NULLPOINTER,
	CPC_ERROR_CODEMATCH,
	CPC_ERROR_INTERNALNULLPOINTER,
	CPC_ERROR_STRINGTOOSHORT,
	CPC_ERROR_DIDNOTSETCLIP,
	CPC_ERROR_CANCELLED,
	CPC_ERROR_NOHISTORY,
	CPC_ERROR_CANTOPENWINDOW,
	CPC_ERROR_BADWINDOW,
	CPC_ERROR_BADMENUBAR,
	CPC_ERROR_MOUSE,
	CPC_ERROR_XMLERROR,
	CPC_ERROR_UNSUPPORTEDBITMAPTYPE,

	//the following was written on March 6,2005
	//Dynamic Interaction error code
	CPC_ERROR_ADDDATAOBJCTFAILURE,
	CPC_ERROR_MAKEPERSISTENTFAILURE,
	CPC_ERROR_DELETEDATAOBJECTFAILURE,
	CPC_ERROR_GETDATAOBJECTFAILURE,
	CPC_ERROR_SETDATAOBJECTFAILURE,
	CPC_ERROR_ADDVIEWERFAILURE,
	CPC_ERROR_SETVIEWERDATAFAILURE,
	CPC_ERROR_DELETEVIEWERFAILURE,
	CPC_ERROR_GETVIEWERSTATEFAILURE,
	CPC_ERROR_SETVIEWERSTATEFAILURE,
	CPC_ERROR_REDRAWFAILURE,

	CPC_ERROR_INSERTROWFAILURE,
	CPC_ERROR_APPENDROWFAILURE,
	CPC_ERROR_CHANGEROWFAILURE,
	CPC_ERROR_DELETEROWFAILURE,
	CPC_ERROR_INSERTCOLFAILURE,
	CPC_ERROR_APPENDCOLFAILURE,
	CPC_ERROR_CHANGECOLFAILURE,
	CPC_ERROR_DELETECOLFAILURE,
	CPC_ERROR_SETELEMENTFAILURE,
	CPC_ERROR_GETPROPERTYFAILURE,  // append on March 21,2005
        //the above was written on March 6,2005

	CPC_ERROR_NODIALOGINRESOURCE

};

typedef struct cpc_callback
{
	long    type;
	union 
	{
		unsigned int (*inputReady)(const char *, void *, int);
		int (*processCommand)(const char *);
		void (*cleanUp)(void);
		void (*interruptCleanUp)(void);
		int (*quitCleanUp)(int);
		int (*initializer)(int, char **);
		void (*windowClosed)(int,int);
		char *string;
	} callback;
} cpc_callback, *cpc_callback_ptr;

	
typedef struct cpc_io
{
	long    type;
	long    length;
	long    parm;
	char   *string;
	char   *string2;
	FILE   *fp;
} cpc_io, *cpc_io_ptr;

typedef struct cpc_stddlg
{
	long    type;
	long    length;
	char   *string;
	char   *message;
	char   *title;
	char   *param1;  /* GETTEXTFROMUSER	default text
	                  * GETFILENAME         default path
		 	  * **MESSAGE           message window title
	                  */
	char   *param2;  /* GETFILENAME         default file name
	                  */
	char   *param3;  /* GETFILENAME         default extension
	                  */
	char   *param4;  /* GETFILENAME         default wildcard
	                  */
} cpc_stddlg, *cpc_stddlg_ptr;

typedef struct DbjValue
{
	long DataType;
	char* name;
	long RowsNumber;
	long ColumnNumber;
	char* *StrArray;
	int StrArraySize;
	
	int *IntContentVector;
	double *DoubleContentVector;
	char* *StrContentVector;
	unsigned int *BoolContentVector;
	/*
	union {
        	int *IntContentVector;
        	double *DoubleContentVector;
        	char* *StrContentVector;
        	int *BoolContentVector;
        	};
	*/
} DbjValue, *DbjValue_ptr;

typedef struct ViewerValue
{
	// more members values may be appended.
	DbjValue_ptr state_ptr;
} ViewerValue, *ViewerValue_ptr;

//The following was written on Feb 26,2005
typedef struct cpc_dyn
{
	long type;         //command code
	// double *doubledata;
	char* name;        //keystring of DataObject or Viewer
	DbjValue_ptr DbjParmValue_ptr;
	ViewerValue_ptr ViewerParmValue_ptr;
} cpc_dyn, *cpc_dyn_ptr;

//The above was written on Feb 26,2005


typedef struct cpc_sg
{
	long    type;
	long    graphno;
	long    size;
	long    coords[4];
	long    colorRGB[3];
	long    colorname;
	long    style;
	long    family;
	long    weight;
	char   *string;
	double  dparms[4];
} cpc_sg, *cpc_sg_ptr;

extern int cpc_doio(cpc_io_ptr);
	
extern int cpc_hist(cpc_io_ptr);

extern int cpc_setCallback(cpc_callback_ptr);

extern int cpc_dostddlg(cpc_stddlg_ptr);

extern int cpc_initcallbacks(int, char **);

extern int cpc_usermenus(cpc_io_ptr);

extern int cpc_doDialogs(cpc_io_ptr);

extern int cpc_doDyc(cpc_dyn_ptr); //appended on Feb 26,2005

extern int cpc_dosg(cpc_sg_ptr);

extern int cpc_TestForInterrupt(void);


#endif /*CARAPACEINTERFACEH__*/
