
#include "wx/wxprec.h"



#ifdef __BORLANDC__
    #pragma hdrstop
#endif

// for all others, include the necessary headers (this file is usually all you
// need because it includes almost all "standard" wxWidgets headers)
#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include "wx/ffile.h"
#include "wx/print.h"
#include "wx/printdlg.h"
#include "wx/clipbrd.h"
#include "wx/paper.h"

#ifdef __WXMSW__
#undef UNIX
#endif
#include "carapace.h"
#include "viewers.h"
#include "dataobject.h"

template <class T> 
vector<T> ptrToVector(T* t,int length)
{
	vector<T> vec;
	int i;
	for(i=0; i<length; i++ )
		vec.push_back(t[i]);
	return vec;
}

template <class T> 
T* VectorToptr(vector<T> vectort, T* t)
{
  int vectorsize,i;
  vectorsize = vectort.size();
  for (i = 0;i < vectorsize; i++) 
  	t[i] = vectort[i];
  return t;
}

wxString ChptrtoWxStr(char *str)
{
	return wxString(str);
}

void WxStrtoChptr(wxString wxstr, char *deststr)
{
	strcpy(deststr, wxstr.c_str());
}

void ChptrVectoWxStrVec(char *StrVec[], int StrVecLen, vector<wxString>& wxStrVec)
{
	
	int i;

	for (i = 0; i < StrVecLen; i++)
		wxStrVec.push_back(wxString(StrVec[i]));
}

void WxStrVectoChptrVec(char *StrVec[], vector<wxString> wxStrVec)
{
	int i,StrVecLen;	
	
	StrVecLen = wxStrVec.size();
	for(i = 0; i< StrVecLen; i++) {
		if (i > 0)
			StrVec[i] = StrVec[i-1] + strlen((wxStrVec[i-1]).c_str()) + 1;
		WxStrtoChptr(wxStrVec[i], StrVec[i]);
	}
}

void UInttoBool(unsigned int *intp, bool *boolp, int size)
{
	int i;
	for (i = 0; i< size; i++)
	  if (intp[i] > 0)
			boolp[i] = true;
		else
			boolp[i] = false;
}

void BooltoUInt(unsigned int *intp, bool *boolp, int size)
{
	int i;
	for (i = 0; i< size; i++)
	  if (boolp[i])
			intp[i] = 1;
		else
			intp[i] = 0;
}


Element::Element(int v) {
	type=INTT;
	int* tp=new int;
	(*tp)=v;
	val=(void*)tp;
}
	
Element::Element(double v) {
	type=DOULBET;
	double* tp=new double;
	(*tp)=v;
	val=(void*)tp;
}

Element::Element(wxString v) {
	type=STRINGT;
	wxString* tp=new wxString;
	(*tp)=v;
	val=(void*)tp;
}	
	
Element::Element(bool v) {
	type=LOGICT;
	bool* tp=new bool;
	(*tp)=v;
	val=(void*)tp;
}	

//the following was written on Feb 12,2005
void Element::GetValue(int& RtValue) {
	RtValue = *((int*)val);
	return;
}	
	
void Element::GetValue(double& RtValue) {
	RtValue = *((double*)val);
	return;
}
	
void Element::GetValue(wxString& RtValue) {
	RtValue = *((wxString*)val);
	return;
}
void Element::GetValue(bool& RtValue) {
	RtValue = *((bool*)val);
	return;
}

void Element::SetValue(int Value) {
	*((int*)val) = Value;
	return;
}	
	
void Element::SetValue(double Value) {
	*((double*)val) = Value;
	return;
}
	
void Element::SetValue(wxString Value) {
	*((wxString*)val) = Value;
	return;
}
void Element::SetValue(bool Value) {
	*((bool*)val) = Value;
	return;
}

ostream& operator<<(ostream& os,Element& e) {
	int ValueInt;
	double ValueDt;
	wxString ValueStr;
	bool   ValueBl;
	
	switch (e.type) {
	case INTT:
//		os<<e.getInt();
		e.GetValue(ValueInt);
		os<<ValueInt;
		break;
	case DOULBET:
		e.GetValue(ValueDt);
		os<<ValueDt;
		break;
	case STRINGT:
		e.GetValue(ValueStr);
		os<<ValueStr;
		break;
	case LOGICT:
		e.GetValue(ValueBl);
		os<<ValueBl;
		break;			
	default:
		break;
	}
	return os;
}

//template< class T >
DataObject::DataObject()
{
	type = UNDEFT;
	rows = 0;
	cols = 0;
	label = "";
	persistent = FALSE;
	modifiedBy = NULL;
}

//template< class T >
DataObject::DataObject(wxString& str, int row, int col, vector<Element> &vec, Type t)
{
	type = t;
	label = str;
	rows = row;
	cols = col;
	content = vec;		
	persistent = FALSE;
	modifiedBy = NULL;
}

DataObject::DataObject(wxString& str, int row, int col, vector<int> &vec, Type t)
{
	type = t;
	type = INTT;
	label = str;
	rows = row;
	cols = col;
	//content = IntVtoEleV(vec);	
	IntVtoEleV(vec,content);	
	persistent = FALSE;
	modifiedBy = NULL;
}

DataObject::DataObject(wxString& str, int row, int col, vector<double> &vec, Type t)
{
	type = t;	
	type = DOULBET;
	label = str;
	rows = row;
	cols = col;
  //content = DoubleVtoEleV(vec);
	DoubleVtoEleV(vec,content);
	persistent = FALSE;
	modifiedBy = NULL;
}

DataObject::DataObject(wxString& str, int row, int col, vector<wxString> &vec, Type t)
{
	type = t;	
	type = STRINGT;
	label = str;
	rows = row;
	cols = col;
 // content = StringVtoEleV(vec);	
  StringVtoEleV(vec,content);	
	persistent = FALSE;
	modifiedBy = NULL;
}

DataObject::DataObject(wxString& str, int row, int col, vector<bool> &vec, Type t)
{
	type = t;	
	type = LOGICT;
	label = str;
	rows = row;
	cols = col;
  //content = BoolVtoEleV(vec);	
  BoolVtoEleV(vec,content);	
	persistent = FALSE;
	modifiedBy = NULL;
}


DataObject::DataObject(wxString& str, int row, int col, int *contvec, Type t)
{
	/*
	int i,veclength;
	
	type = INTT;
	label = str;
	rows = row;
	cols = col;
	persistent = FALSE;
	veclength = row*col;
	for (i = 0; i < veclength; i++)
		content.push_back(Element(contvec[i]));
	*/
	type = t;	
	type = INTT;
	label = str;
	rows = row;
	cols = col;
	vector<int> vec1;
	int len;
	persistent = FALSE;
	
	len = row*col;
	vec1 = ptrToVector(contvec,len);
	IntVtoEleV(vec1,content);			
	modifiedBy = NULL;
}

DataObject::DataObject(wxString& str, int row, int col, double *contvec, Type t)
{
	/*
	int i,veclength;
	
	type = DOULBET;
	label = str;
	rows = row;
	cols = col;
	veclength = row*col;
	persistent = FALSE;
	for (i = 0; i < veclength; i++)
		content.push_back(Element(contvec[i]));
	*/
	type = t;	
	type = DOULBET;
	label = str;
	rows = row;
	cols = col;
	vector<double> vec1;
	int len;
	persistent = FALSE;
	
	len = row*col;
	vec1 = ptrToVector(contvec,len);
	DoubleVtoEleV(vec1,content);			
	modifiedBy = NULL;
}

DataObject::DataObject(wxString& str, int row, int col, char *contvec[], Type t)
{
	/*
	int i,veclength;
	
	type = STRINGT;
	label = str;
	rows = row;
	cols = col;
	veclength = row*col;
	persistent = FALSE;
	for (i = 0; i < veclength; i++)
		content.push_back(Element(contvec[i]));
	*/
	type = t;	
	type = STRINGT;
	label = str;
	rows = row;
	cols = col;
	vector<wxString> vec1;
	int len;
	persistent = FALSE;
	
	len = row*col;
	ChptrVectoWxStrVec(contvec, len, vec1);
	StringVtoEleV(vec1,content);			
	modifiedBy = NULL;
}

DataObject::DataObject(wxString& str, int row, int col, bool *contvec, Type t)
{
	/*
	int i,veclength;
	
	type = LOGICT;
	label = str;
	rows = row;
	cols = col;
	veclength = row*col;
	persistent = FALSE;
	for (i = 0; i < veclength; i++)
		content.push_back(Element(contvec[i]));
	*/
	type = t;	
	type = LOGICT;
	label = str;
	rows = row;
	cols = col;
	vector<bool> vec1;
	int len;
	persistent = FALSE;
	
	len = row*col;
	vec1 = ptrToVector(contvec,len);
	BoolVtoEleV(vec1,content);			
	modifiedBy = NULL;
}

//template< class T >
DataObject::~DataObject()
{
}


//add *length* rows before *where*th rows
//template< class T >
bool DataObject::insertRow(vector<int> &newrows, int where)
{
	vector<Element> newrowsElmt;
//	newrowsElmt = IntVtoEleV(newrows);
	IntVtoEleV(newrows,newrowsElmt);
	int length = newrowsElmt.size();
	assert(length==cols); 
	assert((where<rows)&&(where>=0));
	
	for (int j = cols-1; j >= 0; j--)
		{ 
			vector<Element>::iterator p = content.begin();
			content.insert(p+(rows*j+where),newrowsElmt[j]);
		}
	rows++;
	
	printCont();
	
	return true;
}

bool DataObject::insertRow(vector<double> &newrows, int where)
{
	vector<Element> newrowsElmt;
//	newrowsElmt = DoubleVtoEleV(newrows);
	DoubleVtoEleV(newrows, newrowsElmt);
	int length = newrowsElmt.size();
	assert(length==cols); 
	assert((where<rows)&&(where>=0));
	
	for (int j = cols-1; j >= 0; j--)
		{ 
			vector<Element>::iterator p = content.begin();
			//cout<<((rows+k-1)*(j-1)+(where-1))<<" here\n";
			content.insert(p+(rows*j+where),newrowsElmt[j]);
		}
	rows++;
	
	printCont();
	
	return true;
}

bool DataObject::insertRow(vector<wxString> &newrows, int where)
{
	vector<Element> newrowsElmt;
//	newrowsElmt = StringVtoEleV(newrows);
  StringVtoEleV(newrows,newrowsElmt);
	int length = newrowsElmt.size();
	assert(length==cols); 
	assert((where<rows)&&(where>=0));
	
	for (int j = cols-1; j >= 0; j--)
		{ 
			vector<Element>::iterator p = content.begin();
			//cout<<((rows+k-1)*(j-1)+(where-1))<<" here\n";
			content.insert(p+(rows*j+where),newrowsElmt[j]);
		}
	rows++;
	
	printCont();
	
	return true;
}

bool DataObject::insertRow(vector<bool> &newrows, int where)
{
	vector<Element> newrowsElmt;
	//newrowsElmt = BoolVtoEleV(newrows);
	BoolVtoEleV(newrows,newrowsElmt);
	int length = newrowsElmt.size();
	assert(length==cols); 
	assert((where<rows)&&(where>=0));
	
	for (int j = cols-1; j >= 0; j--)
		{ 
			vector<Element>::iterator p = content.begin();
			//cout<<((rows+k-1)*(j-1)+(where-1))<<" here\n";
			content.insert(p+(rows*j+where),newrowsElmt[j]);
		}
	rows++;
	
	printCont();
	
	return true;
}

bool DataObject::insertRow(int *newrowct, int where)
{
	vector<int> newrowvec;
	newrowvec =  ptrToVector(newrowct,cols);
	return(insertRow(newrowvec, where));	
}

bool DataObject::insertRow(double *newrowct, int where)
{
	vector<double> newrowvec;
	newrowvec =  ptrToVector(newrowct,cols);
	return(insertRow(newrowvec, where));	
}

bool DataObject::insertRow(char *newrowct[], int where)
{
	vector<wxString> newrowvec;
	ChptrVectoWxStrVec(newrowct, cols, newrowvec);
	return(insertRow(newrowvec, where));	
}

bool DataObject::insertRow(bool *newrowct, int where)
{
	vector<bool> newrowvec;
	newrowvec =  ptrToVector(newrowct,cols);
	return(insertRow(newrowvec, where));	
}

//add *length* rows after the origonal data
//template<class T>

bool DataObject::appendRow(vector<int> &newrows )
{	
	vector<Element> newrowsElmt;
	//newrowsElmt = IntVtoEleV(newrows);
	IntVtoEleV(newrows,newrowsElmt);
	content.push_back(newrowsElmt[cols-1]);
	
	int where = rows; 
	for (int j = cols-2; j >= 0; j--)
		{ 
			vector<Element>::iterator p = content.begin();
			//cout<<((rows+k-1)*(j-1)+(where-1))<<" here\n";
			content.insert(p+(rows*j+where),newrowsElmt[j]);
		}
	rows++;
	
	printCont();
	
	return true;
}

bool DataObject::appendRow(vector<double> &newrows )
{	
	vector<Element> newrowsElmt;
//	newrowsElmt = DoubleVtoEleV(newrows);
	DoubleVtoEleV(newrows,newrowsElmt);
	content.push_back(newrowsElmt[cols-1]);
	
	int where = rows; 
	for (int j = cols-2; j >= 0; j--)
		{ 
			vector<Element>::iterator p = content.begin();
			//cout<<((rows+k-1)*(j-1)+(where-1))<<" here\n";
			content.insert(p+(rows*j+where),newrowsElmt[j]);
		}
	rows++;
	
	printCont();
	
	return true;
}

bool DataObject::appendRow(vector<wxString> &newrows )
{	
	vector<Element> newrowsElmt;
	//newrowsElmt = StringVtoEleV(newrows);
	StringVtoEleV(newrows,newrowsElmt);
	content.push_back(newrowsElmt[cols-1]);
	
	int where = rows; 
	for (int j = cols-2; j >= 0; j--)
		{ 
			vector<Element>::iterator p = content.begin();
			//cout<<((rows+k-1)*(j-1)+(where-1))<<" here\n";
			content.insert(p+(rows*j+where),newrowsElmt[j]);
		}
	rows++;
	
	printCont();
	
	return true;
}

bool DataObject::appendRow(vector<bool> &newrows )
{	
	vector<Element> newrowsElmt;
//	newrowsElmt = BoolVtoEleV(newrows);
	BoolVtoEleV(newrows,newrowsElmt);
	content.push_back(newrowsElmt[cols-1]);
	
	int where = rows; 
	for (int j = cols-2; j >= 0; j--)
		{ 
			vector<Element>::iterator p = content.begin();
			//cout<<((rows+k-1)*(j-1)+(where-1))<<" here\n";
			content.insert(p+(rows*j+where),newrowsElmt[j]);
		}
	rows++;
	
	printCont();
	
	return true;
}

bool DataObject::appendRow(int *newrowct)
{
	vector<int> newrowvec;
	newrowvec =  ptrToVector(newrowct,cols);
	return(appendRow(newrowvec));
}	 

bool DataObject::appendRow(double *newrowct)
{
	vector<double> newrowvec;
	newrowvec =  ptrToVector(newrowct,cols);
	return(appendRow(newrowvec));
}	

bool DataObject::appendRow(char *newrowct[])
{
	vector<wxString> newrowvec;
	ChptrVectoWxStrVec(newrowct, cols, newrowvec);
	return(appendRow(newrowvec));
}	

bool DataObject::appendRow(bool *newrowct)
{
	vector<bool> newrowvec;
	newrowvec =  ptrToVector(newrowct,cols);
	return(appendRow(newrowvec));
}	

//template< class T >
bool DataObject::changeRow(vector<int> &newrows, int where)
{
	vector<Element> newrowsElmt;
//	newrowsElmt = IntVtoEleV(newrows);
	IntVtoEleV(newrows,newrowsElmt);
	int length=newrowsElmt.size();
	assert( length == cols );
	assert( (where <rows) && ( where >=0) );
	
	for ( int j = 0; j < cols; j++)
		{		
			content[where+j*rows] = newrowsElmt[j];
		}
		
	printCont();
	
	return true;
}

bool DataObject::changeRow(vector<double> &newrows, int where)
{
	vector<Element> newrowsElmt;
//	newrowsElmt = DoubleVtoEleV(newrows);
	DoubleVtoEleV(newrows,newrowsElmt);
	int length=newrowsElmt.size();
	assert( length == cols );
	assert( (where <rows) && ( where >=0) );
	
	for ( int j = 0; j < cols; j++)
		{		
			content[where+j*rows] = newrowsElmt[j];
		}
		
	printCont();
	
	return true;
}

bool DataObject::changeRow(vector<wxString> &newrows, int where)
{
	vector<Element> newrowsElmt;
	//newrowsElmt = StringVtoEleV(newrows);
	StringVtoEleV(newrows,newrowsElmt);
	int length=newrowsElmt.size();
	assert( length == cols );
	assert( (where <rows) && ( where >=0) );
	
	for ( int j = 0; j < cols; j++)
		{		
			content[where+j*rows] = newrowsElmt[j];
		}
		
	printCont();
	
	return true;
}

bool DataObject::changeRow(vector<bool> &newrows, int where)
{
	vector<Element> newrowsElmt;
//	newrowsElmt = BoolVtoEleV(newrows);
	BoolVtoEleV(newrows,newrowsElmt);
	int length=newrowsElmt.size();
	assert( length == cols );
	assert( (where <rows) && ( where >=0) );
	
	for ( int j = 0; j < cols; j++)
		{		
			content[where+j*rows] = newrowsElmt[j];
		}
		
	printCont();
	
	return true;
}

bool DataObject::changeRow(int *newrowct, int where)
{
	vector<int> newrowvec;
	newrowvec =  ptrToVector(newrowct,cols);
	return(changeRow(newrowvec, where));	
}

bool DataObject::changeRow(double *newrowct, int where)
{
	vector<double> newrowvec;
	newrowvec =  ptrToVector(newrowct,cols);
	return(changeRow(newrowvec, where));	
}

bool DataObject::changeRow(char *newrowct[], int where)
{
	vector<wxString> newrowvec;
	ChptrVectoWxStrVec(newrowct, cols, newrowvec);
	return(changeRow(newrowvec, where));	
}

bool DataObject::changeRow(bool *newrowct, int where)
{
	vector<bool> newrowvec;
	newrowvec =  ptrToVector(newrowct,cols);
	return(changeRow(newrowvec, where));	
}

//template< class T >
bool DataObject::deleteRow(int where)
{
	assert((where<rows) && (where>=0));
	vector<Element>::iterator p = content.begin();
	for (int j = cols -1; j >= 0; j--)
		content.erase(p+(rows*j+where));
	rows--;
	
	printCont();		
	
	return true;
}	

//template< class T >
bool DataObject::insertCol(vector<int> &newcols, int where)
{
	vector<Element> newcolsElmt;
	//newcolsElmt = IntVtoEleV(newcols);
	IntVtoEleV(newcols,newcolsElmt);
	int length = newcolsElmt.size();
	assert(length==rows); 
	assert((where < cols) && (where >= 0));
	
	vector<Element> :: iterator p = content.begin(); 
	content.insert(p+where*rows,newcolsElmt.begin(),newcolsElmt.end());
	cols++;
	
	printCont();
	
	return true;
}	

bool DataObject::insertCol(vector<double> &newcols, int where)
{
	vector<Element> newcolsElmt;
	//newcolsElmt = DoubleVtoEleV(newcols);	
	DoubleVtoEleV(newcols,newcolsElmt);
	int length = newcolsElmt.size();
	assert(length==rows); 
	assert((where < cols) && (where >= 0));
	
	vector<Element> :: iterator p = content.begin(); 
	content.insert(p+where*rows,newcolsElmt.begin(),newcolsElmt.end());
	cols++;
	
	printCont();
	
	return true;
}	

bool DataObject::insertCol(vector<wxString> &newcols, int where)
{
	vector<Element> newcolsElmt;
	//newcolsElmt = StringVtoEleV(newcols);	
	StringVtoEleV(newcols,newcolsElmt);	
	int length = newcolsElmt.size();
	assert(length==rows); 
	assert((where < cols) && (where >= 0));
	
	vector<Element> :: iterator p = content.begin(); 
	content.insert(p+where*rows,newcolsElmt.begin(),newcolsElmt.end());
	cols++;
	
	printCont();
	
	return true;
}	

bool DataObject::insertCol(vector<bool> &newcols, int where)
{
	vector<Element> newcolsElmt;
	//newcolsElmt = BoolVtoEleV(newcols);	
	BoolVtoEleV(newcols,newcolsElmt);	
	int length = newcolsElmt.size();
	assert(length==rows); 
	assert((where < cols) && (where >= 0));
	
	vector<Element> :: iterator p = content.begin(); 
	content.insert(p+where*rows,newcolsElmt.begin(),newcolsElmt.end());
	cols++;
	
	printCont();
	
	return true;
}	

bool DataObject::insertCol(int *newcolct, int where)
{
	vector<int> newcolvec;
	newcolvec =  ptrToVector(newcolct,rows);
	return(insertCol(newcolvec, where));	
}

bool DataObject::insertCol(double *newcolct, int where)
{
	vector<double> newcolvec;
	newcolvec =  ptrToVector(newcolct,rows);
	return(insertCol(newcolvec, where));	
}

bool DataObject::insertCol(char *newcolct[], int where)
{
	vector<wxString> newcolvec;
	ChptrVectoWxStrVec(newcolct, rows, newcolvec);
	return(insertCol(newcolvec, where));	
}

bool DataObject::insertCol(bool *newcolct, int where)
{
	vector<bool> newcolvec;
	newcolvec =  ptrToVector(newcolct,rows);
	return(insertCol(newcolvec, where));	
}

//template< class T >
bool DataObject::appendCol(vector<int> &newcols)
{
	vector<Element> newcolsElmt;
	//newcolsElmt = IntVtoEleV(newcols);	
	IntVtoEleV(newcols,newcolsElmt);
	int length=newcolsElmt.size();
	assert( length == rows);
	
	for (int j=0; j<rows; j++)
		content.push_back(newcolsElmt[j]);
	cols++;
	
	printCont();
	
	return true;
}

bool DataObject::appendCol(vector<double> &newcols)
{
	vector<Element> newcolsElmt;
	//newcolsElmt = DoubleVtoEleV(newcols);	
	DoubleVtoEleV(newcols,newcolsElmt);	
	int length=newcolsElmt.size();
	assert( length == rows);
	
	for (int j=0; j<rows; j++)
		content.push_back(newcolsElmt[j]);
	cols++;
	
	printCont();
	
	return true;
}

bool DataObject::appendCol(vector<wxString> &newcols)
{
	vector<Element> newcolsElmt;
//	newcolsElmt = StringVtoEleV(newcols);	
	StringVtoEleV(newcols,newcolsElmt);	
	int length=newcolsElmt.size();
	assert( length == rows);
	
	for (int j=0; j<rows; j++)
		content.push_back(newcolsElmt[j]);
	cols++;
	
	printCont();
	
	return true;
}

bool DataObject::appendCol(vector<bool> &newcols)
{
	vector<Element> newcolsElmt;
	//newcolsElmt = BoolVtoEleV(newcols);	
	BoolVtoEleV(newcols,newcolsElmt);	
	int length=newcolsElmt.size();
	assert( length == rows);
	
	for (int j=0; j<rows; j++)
		content.push_back(newcolsElmt[j]);
	cols++;
	
	printCont();
	
	return true;
}

bool DataObject::appendCol(int *newcolct)
{
	vector<int> newcolvec;
	newcolvec =  ptrToVector(newcolct,rows);
	return(appendCol(newcolvec));
}	 

bool DataObject::appendCol(double *newcolct)
{
	vector<double> newcolvec;
	newcolvec =  ptrToVector(newcolct,rows);
	return(appendCol(newcolvec));
}	

bool DataObject::appendCol(char *newcolct[])
{
	vector<wxString> newcolvec;
	ChptrVectoWxStrVec(newcolct, rows, newcolvec);
	return(appendCol(newcolvec));
}	

bool DataObject::appendCol(bool *newcolct)
{
	vector<bool> newcolvec;
	newcolvec =  ptrToVector(newcolct,rows);
	return(appendCol(newcolvec));
}	

//template< class T >
bool DataObject::changeCol(vector<int> &newcols,int where)
{
	vector<Element> newcolsElmt;
	//newcolsElmt = IntVtoEleV(newcols);	
	IntVtoEleV(newcols,newcolsElmt);
	int length=newcolsElmt.size();
	assert( length == rows );
	assert( (where<cols) && (where>=0) );
	
	for (int j=0; j<rows; j++)
		content[where*rows+j]=newcolsElmt[j];
	
	printCont();
	
	return true;
}

bool DataObject::changeCol(vector<double> &newcols,int where)
{
	vector<Element> newcolsElmt;
//	newcolsElmt = DoubleVtoEleV(newcols);
	DoubleVtoEleV(newcols,newcolsElmt);
	int length=newcolsElmt.size();
	assert( length == rows );
	assert( (where<cols) && (where>=0) );
	
	for (int j=0; j<rows; j++)
		content[where*rows+j]=newcolsElmt[j];
	
	printCont();
	
	return true;
}

bool DataObject::changeCol(vector<wxString> &newcols,int where)
{
	vector<Element> newcolsElmt;
	//newcolsElmt = StringVtoEleV(newcols);	
	StringVtoEleV(newcols,newcolsElmt);	
	int length=newcolsElmt.size();
	assert( length == rows );
	assert( (where<cols) && (where>=0) );
	
	for (int j=0; j<rows; j++)
		content[where*rows+j]=newcolsElmt[j];
	
	printCont();
	
	return true;
}

bool DataObject::changeCol(vector<bool> &newcols,int where)
{
	vector<Element> newcolsElmt;
//	newcolsElmt = BoolVtoEleV(newcols);	
	BoolVtoEleV(newcols,newcolsElmt);
	int length=newcolsElmt.size();
	assert( length == rows );
	assert( (where<cols) && (where>=0) );
	
	for (int j=0; j<rows; j++)
		content[where*rows+j]=newcolsElmt[j];
	
	printCont();
	
	return true;
}

bool DataObject::changeCol(int *newcolct, int where)
{
	vector<int> newcolvec;
	newcolvec =  ptrToVector(newcolct,rows);
	return(changeCol(newcolvec, where));	
}

bool DataObject::changeCol(double *newcolct, int where)
{
	vector<double> newcolvec;
	newcolvec =  ptrToVector(newcolct,rows);
	return(changeCol(newcolvec, where));	
}

bool DataObject::changeCol(char *newcolct[], int where)
{
	vector<wxString> newcolvec;
	ChptrVectoWxStrVec(newcolct, rows, newcolvec);
	return(changeCol(newcolvec, where));	
}

bool DataObject::changeCol(bool *newcolct, int where)
{
	vector<bool> newcolvec;
	newcolvec =  ptrToVector(newcolct,rows);
	return(changeCol(newcolvec, where));	
}

//template< class T >
bool DataObject::deleteCol( int where )
{
	assert( (where<cols) && (where>=0) );
	
	vector<Element> :: iterator p = content.begin(); 
	content.erase( p+where*rows,p+(where+1)*rows );
	
	cols--;
	
	printCont();
	
	return true;
}

//template< class T >
bool DataObject::setValue(Element &value, int row, int col )
{
	assert( (row<rows)&&(row>=0) );
	assert( (col<cols)&&(col>=0) );
	
	content[col*rows+row] = value;

	printCont();
	
	return true;
}

bool DataObject::setValue(int newvalue, int row, int col)
{
	Element newElemt(newvalue);
	return(setValue(newElemt, row, col));
}

bool DataObject::setValue(double newvalue, int row, int col)
{
	Element newElemt(newvalue);
	return(setValue(newElemt, row, col));
}

bool DataObject::setValue(char *newvalue, int row, int col)
{
	Element newElemt(ChptrtoWxStr(newvalue));
	return(setValue(newElemt, row, col));
}

bool DataObject::setValue(bool newvalue, int row, int col)
{
	Element newElemt(newvalue);
	return(setValue(newElemt, row, col));
}






		
//test		
//template<class T>
void  DataObject::print()
{
	cout<< "row:"<< rows << "\n col:" << cols << "\n label" 
		<<label<< "\n" << type << endl;
		
	vector<Element>::iterator p=content.begin();
	while (p!=content.end())
		{
			cout <<*p << " ";
		 	p++;
		 }
		 
	cout << endl;
}	

//template< class T >
void DataObject::printCont()
{
	for (int i =0;i<rows;i++) {
		for (int j=0;j<cols;j++)
			cout<<"\t"<<content[rows*j+i];
		cout<<endl;
	}
}	

void DataObject::IntVtoEleV(vector<int>& vec, vector<Element>& RstVector)
{
	int VectorSize,i;
//	vector<Element> RstVector;
	
	VectorSize = vec.size();
	for (i = 0; i < VectorSize;i++)
		RstVector.push_back(Element(vec[i]));
	return ;
}

void DataObject::DoubleVtoEleV(vector<double>& vec, vector<Element>& RstVector)
{
	int VectorSize,i;
//	vector<Element> RstVector;
	
	VectorSize = vec.size();
	for (i = 0; i < VectorSize;i++)
		RstVector.push_back(Element(vec[i]));
	return ;
}

void DataObject::StringVtoEleV(vector<wxString>& vec, vector<Element>& RstVector)
{
	int VectorSize,i;
//	vector<Element> RstVector;
	
	VectorSize = vec.size();
	for (i = 0; i < VectorSize;i++)
		RstVector.push_back(Element(vec[i]));
	return ;
}

void DataObject::BoolVtoEleV(vector<bool>& vec, vector<Element>& RstVector)
{
	int VectorSize,i;
//	vector<Element> RstVector;
	
	VectorSize = vec.size();
	for (i = 0; i < VectorSize;i++)
		RstVector.push_back(Element(vec[i]));
	return ;
}

DataHash :: DataHash():wxHash(){};



DataHash :: ~DataHash() {};


vector<Element>& DataHash :: getContent(wxString str)
{	
	return (*this)[str].content;
}

int  DataHash :: getRows(wxString str)
{ 
	return (*this)[str].rows;
}

int DataHash :: getCols(wxString str)
{ 
	return (*this)[str].cols;
}

Type DataHash :: getType(wxString str)
{
	return (*this)[str].type;
}

DataObject&  DataHash :: getObject(wxString str)
{
	return (*this)[str];	
}

void DataHash::getVal(wxString str, int id)
{
	cout << (*this)[str].content[id];
}	


/*	
// The following is written on Feb 10,2005	
DataView::DataView()
{
	pViewData = NULL;
}


DataView::DataView(DataHash& DtHash)
{
	pViewData = &DtHash;
	DataHash::iterator p=pViewData->begin();
	while (p != pViewData->end())         //Initialize the DataConnect Table
	{
		 objDVCHash[p->first] = 0;
		 p++;
	}
}	
          
bool DataView::AddConnectDataObject(wxString& keystr)
{
	DataHash::iterator pend =pViewData->end();
	DataHash::iterator pfind = pViewData->find(keystr);
	if (pfind!=pend){
		objDVCHash[keystr] = 0;
		return true;
	}
	else
		return false;
}

bool DataView::DelConnectDataObject(wxString& keystr)
{
	DVConnectHash::iterator pend =objDVCHash.end();
	DVConnectHash::iterator pfind = objDVCHash.find(keystr);
	if (pfind!=pend){
		objDVCHash.erase(pfind);
		return true;
	}
	else
		return false;
}

bool DataView::SetConnectDataObject(wxString& keystr)
{
	DVConnectHash::iterator pend =objDVCHash.end();
	DVConnectHash::iterator pfind = objDVCHash.find(keystr);
	if (pfind!=pend){
		objDVCHash.erase(pfind);
		objDVCHash[keystr] = 1;
		return true;
	}
	else
		return false;
}

bool DataView::ClearConnectDataObject(wxString& keystr)
{
	DVConnectHash::iterator pend =objDVCHash.end();
	DVConnectHash::iterator pfind = objDVCHash.find(keystr);
	if (pfind!=pend){
		objDVCHash.erase(pfind);
		objDVCHash[keystr] = 0;
		return true;
	}
	else
		return false;
}

DataView::~DataView()
{
}	
*/



	

DynamicInteraction::DynamicInteraction()
{
	data = NULL;
	viewers= NULL;
}

DynamicInteraction::DynamicInteraction(DataHash& dh, ViewerHash& vh)
{
	data = &dh;
	viewers = &vh;
	DataHash::iterator p=data->begin();
	ViewerHash::iterator q=viewers->begin();
	while (p != data->end())
	{	
		byData[p->first]=vector<wxString>();   //Initialize the connection table by using dataobject
		p++;
	}
	while (q != viewers->end())
	{
		byViewer[q->first]=vector<wxString>();      //Initialize the connection table by using viewers
		q++;
	}	
}

bool DynamicInteraction::addDataObject(wxString& str,DataObject& datao)
{
		DataHash::iterator pfind=data->find(str);
		DataHash::iterator pend=data->end();
		if (pfind==pend){	
			(*data)[str]=datao;
			byData[str]=vector<wxString>();
			return true;
		}
		else 
			return false;
}

bool DynamicInteraction::addDataObject(wxString& str, int row, int col, vector<int>& DOContent)
{
	DataObject NewDObj(str, row, col, DOContent, INTT);
	if (addDataObject(str, NewDObj))
		return true;
	else
		return false;
	
}

bool DynamicInteraction::addDataObject(wxString& str, int row, int col, vector<double>& DOContent)
{
	DataObject NewDObj(str, row, col, DOContent, DOULBET);
	if (addDataObject(str, NewDObj))
		return true;
	else
		return false;
	
}

bool DynamicInteraction::addDataObject(wxString& str, int row, int col, vector<wxString>& DOContent)
{
	DataObject NewDObj(str, row, col, DOContent, STRINGT);
	if (addDataObject(str, NewDObj))
		return true;
	else
		return false;
	
}

bool DynamicInteraction::addDataObject(wxString& str, int row, int col, vector<bool>& DOContent)
{
	DataObject NewDObj(str, row, col, DOContent, LOGICT);
	if (addDataObject(str, NewDObj))
		return true;
	else
		return false;
	
}

bool DynamicInteraction::addDataObject(wxString& str, int row, int col, int *contvec)
{
	DataObject NewDObj(str, row, col, contvec, INTT);
	if (addDataObject(str, NewDObj))
		return true;
	else
		return false;
	
}

bool DynamicInteraction::addDataObject(wxString& str, int row, int col, double *contvec)
{
	DataObject NewDObj(str, row, col, contvec, DOULBET);
	if (addDataObject(str, NewDObj))
		return true;
	else
		return false;
	
}

bool DynamicInteraction::addDataObject(wxString& str, int row, int col, char *contvec[])
{
	vector<wxString> wxstrvec;
	
	ChptrVectoWxStrVec(contvec, row*col, wxstrvec);
	DataObject NewDObj(str, row, col, wxstrvec, STRINGT);
	if (addDataObject(str, NewDObj))
		return true;
	else
		return false;
	
}

bool DynamicInteraction::addDataObject(wxString& str, int row, int col, bool *contvec)
{
	DataObject NewDObj(str, row, col, contvec, LOGICT);
	if (addDataObject(str, NewDObj))
		return true;
	else
		return false;
	
}

/*
void UInttoBool(unsigned int *intp, bool *boolp, int size)
{
	int i;
	for (i = 0; i< size; i++)
	  if (intp[i] > 0)
			boolp[i] = true;
		else
			boolp[i] = false;
}

void BooltoUInt(unsigned int *intp, bool *boolp, int size)
{
	int i;
	for (i = 0; i< size; i++)
	  if (intp[i] > 0)
			boolp[i] = true;
		else
			boolp[i] = false;
}
*/
bool DynamicInteraction::addDataObject(wxString& str, int row, int col, unsigned int *contvec)
{
	bool *boolp;
	int length;
	
	length = row*col;
	boolp = new bool[length];
	UInttoBool(contvec, boolp, length);
	DataObject NewDObj(str, row, col, boolp, LOGICT);
	delete [] boolp;
	if (addDataObject(str, NewDObj))
		return true;
	else
		return false;
	
}

bool DynamicInteraction::deleteDataObject(wxString& str)
{
	DataHash::iterator pfind=data->find(str);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;

 	Association::iterator qfind=byData.find(str);
	vector<wxString>::iterator ifirst;
	while((ifirst = qfind->second.begin()) !=  qfind->second.end())
	{
		// we iterate this way because the deleteViewer could remove
		// other elements in the list
		deleteViewer(*ifirst);
	}
	updateByData();
	
	data->erase(str); 		//erase from data hash
	byData.erase(qfind); 		//erase from byData Association;
	return true;
}
	
bool DynamicInteraction::MakeDataObjectPersistent(wxString& str)
{
	DataHash::iterator pfind=data->find(str);
	DataHash::iterator pend=data->end();
	assert(pfind!=pend); 
	   /*persistent dataobject should be in datahash. This assert need to be
	   changed into error message box later on*/
	pfind->second.persistent = TRUE;
	return(TRUE);
}
			
			
DataObject& DynamicInteraction::getDataObjectValue(wxString& dtstr)
{
	return (*data)[dtstr];		
}

void DynamicInteraction::getDataObjectContent(wxString& dtstr, int& RowsNumber, int& ColNumber, vector<int>& DOContent)
{
	int ElemtValue;
	int i,ElemtLength;
	DataObject NewDObj;
	NewDObj = getDataObjectValue(dtstr);
	RowsNumber = NewDObj.rows;
	ColNumber = NewDObj.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewDObj.content[i].GetValue(ElemtValue);
		DOContent.push_back(ElemtValue);
	}
}

void DynamicInteraction::getDataObjectContent(wxString& dtstr, int& RowsNumber, int& ColNumber, vector<double>& DOContent)
{
	double ElemtValue;
	int i,ElemtLength;
	DataObject NewDObj;
	NewDObj = getDataObjectValue(dtstr);
	RowsNumber = NewDObj.rows;
	ColNumber = NewDObj.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewDObj.content[i].GetValue(ElemtValue);
		DOContent.push_back(ElemtValue);
	}
}

void DynamicInteraction::getDataObjectContent(wxString& dtstr, int& RowsNumber, int& ColNumber, vector<wxString>& DOContent)
{
	wxString ElemtValue;
	int i,ElemtLength;
	DataObject NewDObj;
	NewDObj = getDataObjectValue(dtstr);
	RowsNumber = NewDObj.rows;
	ColNumber = NewDObj.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewDObj.content[i].GetValue(ElemtValue);
		DOContent.push_back(ElemtValue);
	}
}

void DynamicInteraction::getDataObjectContent(wxString& dtstr, int& RowsNumber, int& ColNumber, vector<bool>& DOContent)
{
	bool ElemtValue;
	int i,ElemtLength;
	DataObject NewDObj;
	NewDObj = getDataObjectValue(dtstr);
	RowsNumber = NewDObj.rows;
	ColNumber = NewDObj.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewDObj.content[i].GetValue(ElemtValue);
		DOContent.push_back(ElemtValue);
	}
}

void DynamicInteraction::getDataObjectContent(wxString& dtstr, int& RowsNumber, int& ColNumber, int *contvec)
{
	/*
	int i,ElemtLength;
	DataObject NewDObj;
	NewDObj = getDataObjectValue(dtstr);
	RowsNumber = NewDObj.rows;
	ColNumber = NewDObj.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewDObj.content[i].GetValue(contvec[i]);
 	}
 	*/
 //	DataObject NewDObj;
 	vector<int> DOcontentvec;
	getDataObjectContent(dtstr, RowsNumber, ColNumber, DOcontentvec);
	VectorToptr(DOcontentvec, contvec); 			 		
}

void DynamicInteraction::getDataObjectContent(wxString& dtstr, int& RowsNumber, int& ColNumber, double *contvec)
{
	/*
	int i,ElemtLength;
	DataObject NewDObj;
	NewDObj = getDataObjectValue(dtstr);
	RowsNumber = NewDObj.rows;
	ColNumber = NewDObj.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewDObj.content[i].GetValue(contvec[i]);
 	}
 	*/
 //	DataObject NewDObj;
 	vector<double> DOcontentvec;
	getDataObjectContent(dtstr, RowsNumber, ColNumber, DOcontentvec);
	VectorToptr(DOcontentvec, contvec); 			 		
}

void DynamicInteraction::getDataObjectContent(wxString& dtstr, int& RowsNumber, int& ColNumber, char *contvec[])
{
	/*
	int i,ElemtLength;
	DataObject NewDObj;
	NewDObj = getDataObjectValue(dtstr);
	RowsNumber = NewDObj.rows;
	ColNumber = NewDObj.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewDObj.content[i].GetValue(contvec[i]);
 	}
 	*/
 	//DataObject NewDObj;
 	vector<wxString> DOcontentvec;
	getDataObjectContent(dtstr, RowsNumber, ColNumber, DOcontentvec);
	WxStrVectoChptrVec(contvec, DOcontentvec);
				 		
}

void DynamicInteraction::getDataObjectContent(wxString& dtstr, int& RowsNumber, int& ColNumber, bool *contvec)
{
	/*
	int i,ElemtLength;
	DataObject NewDObj;
	NewDObj = getDataObjectValue(dtstr);
	RowsNumber = NewDObj.rows;
	ColNumber = NewDObj.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewDObj.content[i].GetValue(contvec[i]);
 	}
 	*/
 //	DataObject NewDObj;
 	vector<bool> DOcontentvec;
	getDataObjectContent(dtstr, RowsNumber, ColNumber, DOcontentvec);
	VectorToptr(DOcontentvec, contvec); 			 		
}

void DynamicInteraction::getDataObjectContent(wxString& dtstr, int& RowsNumber, int& ColNumber, unsigned int *contvec)
{

  bool *boolp;
  int length;
  vector<bool> DOcontentvec;
  
	getDataObjectContent(dtstr, RowsNumber, ColNumber, DOcontentvec);
	length = RowsNumber*ColNumber;
	boolp = new bool[length];
	VectorToptr(DOcontentvec, boolp);
	BooltoUInt(contvec, boolp, length);	
	delete [] boolp;		 		
}

bool DynamicInteraction::setDataObjectValue(DataObject& datao,wxString& str)
{
	DataHash::iterator pfind=data->find(str);
	if (pfind==data->end()) return false;
	else{
		data->erase(pfind);
		(*data)[str]=datao;
		(*data)[str].modifiedBy = (Viewer *) this; // force redraw of viewers that depend
		return true;
	}	
}

bool DynamicInteraction::setDataObjectValue(vector<int>& DOContent, int row, int col,wxString& str)
{
	DataObject NewDObj(str, row, col, DOContent, INTT);
	if (setDataObjectValue(NewDObj, str))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setDataObjectValue(vector<double>& DOContent, int row, int col,wxString& str)
{
	DataObject NewDObj(str, row, col, DOContent, DOULBET);
	if (setDataObjectValue(NewDObj, str))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setDataObjectValue(vector<wxString>& DOContent, int row, int col,wxString& str)
{
	DataObject NewDObj(str, row, col, DOContent, STRINGT);
	if (setDataObjectValue(NewDObj, str))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setDataObjectValue(vector<bool>& DOContent, int row, int col,wxString& str)
{
	DataObject NewDObj(str, row, col, DOContent, LOGICT);
	if (setDataObjectValue(NewDObj, str))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setDataObjectValue(int *contvec, int row, int col,wxString& str)
{
	DataObject NewDObj(str, row, col, contvec, INTT);
	if (setDataObjectValue(NewDObj, str))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setDataObjectValue(double *contvec, int row, int col,wxString& str)
{
	DataObject NewDObj(str, row, col, contvec, DOULBET);
	if (setDataObjectValue(NewDObj, str))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setDataObjectValue(char *contvec[], int row, int col,wxString& str)
{
	DataObject NewDObj(str, row, col, contvec, STRINGT);
	if (setDataObjectValue(NewDObj, str))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setDataObjectValue(bool *contvec, int row, int col,wxString& str)
{
	DataObject NewDObj(str, row, col, contvec, LOGICT);
	if (setDataObjectValue(NewDObj, str))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setDataObjectValue(unsigned int *contvec, int row, int col,wxString& str)
{

	bool *boolp;
	int length;
	
	length = row*col;
	boolp = new bool[length];	
	UInttoBool(contvec, boolp, length);
	DataObject NewDObj(str, row, col, boolp, LOGICT);
	delete [] boolp;
	if (setDataObjectValue(NewDObj, str))
		return true;
	else
		return false;		
}

bool DynamicInteraction::addViewer(wxString& str,Viewer * view)
{
		ViewerHash::iterator pfind=viewers->find(str);
		ViewerHash::iterator pend=viewers->end();
		if (pfind==pend){	
			(*viewers)[str]=view;
			byViewer[str]=vector<wxString>();
			return true;
		}
		else 
			return false;	
}

#if 0
bool DynamicInteraction::addViewer(wxString& str, vector<int>& ViewerState, int row, int col)
{
	DataObject NewViewerState(str, row, col, ViewerState, INTT);	
	Viewer NewViewer;
	NewViewer.state = NewViewerState;
	return (addViewer(str,NewViewer));
}

bool DynamicInteraction::addViewer(wxString& str, vector<double>& ViewerState, int row, int col)
{
	DataObject NewViewerState(str, row, col, ViewerState, DOULBET);	
	Viewer NewViewer;
	NewViewer.state = NewViewerState;
	return (addViewer(str,NewViewer));
}

bool DynamicInteraction::addViewer(wxString& str, vector<wxString>& ViewerState, int row, int col)
{
	DataObject NewViewerState(str, row, col, ViewerState, STRINGT);	
	Viewer NewViewer;
	NewViewer.state = NewViewerState;
	return (addViewer(str,NewViewer));
}

bool DynamicInteraction::addViewer(wxString& str, vector<bool>& ViewerState, int row, int col)
{
	DataObject NewViewerState(str, row, col, ViewerState, LOGICT);	
	Viewer NewViewer;
	NewViewer.state = NewViewerState;
	return (addViewer(str,NewViewer));
}

bool DynamicInteraction::addViewer(wxString& str, int *ViewerState, int row, int col)
{
	DataObject NewViewerState(str, row, col, ViewerState, INTT);	
	Viewer NewViewer;
	NewViewer.state = NewViewerState;
	return (addViewer(str,NewViewer));	
}

bool DynamicInteraction::addViewer(wxString& str, double *ViewerState, int row, int col)
{
	DataObject NewViewerState(str, row, col, ViewerState, DOULBET);	
	Viewer NewViewer;
	NewViewer.state = NewViewerState;
	return (addViewer(str,NewViewer));	
}

bool DynamicInteraction::addViewer(wxString& str, char *ViewerState[], int row, int col)
{
	DataObject NewViewerState(str, row, col, ViewerState, STRINGT);	
	Viewer NewViewer;
	NewViewer.state = NewViewerState;
	return (addViewer(str,NewViewer));	
}

bool DynamicInteraction::addViewer(wxString& str, bool *ViewerState, int row, int col)
{
	DataObject NewViewerState(str, row, col, ViewerState, LOGICT);	
	Viewer NewViewer;
	NewViewer.state = NewViewerState;
	return (addViewer(str,NewViewer));	
}

bool DynamicInteraction::addViewer(wxString& str, unsigned int *ViewerState, int row, int col)
{
	bool *boolp;
	int length;
	
	length = row*col;
	boolp = new bool[length];	
	UInttoBool(ViewerState, boolp, length);	
	DataObject NewViewerState(str, row, col, boolp, LOGICT);	
	delete [] boolp;
	Viewer NewViewer;
	NewViewer.state = NewViewerState;
	return (addViewer(str,NewViewer));	
}
#endif // 0

bool DynamicInteraction::setViewerData(vector<wxString>& dataos,wxString& str)
{
	Association::iterator pfind=byViewer.find(str);
	Association::iterator pend=byViewer.end();
	if (pfind!=pend){		
		byViewer.erase(str);
	}
	byViewer[str]=dataos;
	//update the association related to views;
	//updateByData();
	return true;
}

bool DynamicInteraction::setViewerData(char *dataos[], int dataslength, wxString& str)
{
	vector<wxString> wxstrvec;

	ChptrVectoWxStrVec(dataos,dataslength, wxstrvec);
	return(setViewerData(wxstrvec, str));	
}


bool DynamicInteraction::delistViewer(wxString& str)
{
// all this does is take the Viewer information out of the
// DynamicInteraction object. It does not affect the Viewer
// itself (as a wxWidgets object)
	Association::iterator ptfind=byViewer.find(str);
	Association::iterator ptend=byViewer.end();
	if(ptfind==ptend) return false;
	viewers->erase(str); //remove from viewerhash the viewers reference to deleted dataobject;
	byViewer.erase(str);		
	updateByData();
	return true;
}

bool DynamicInteraction::deleteViewer(wxString& str)
{
	Association::iterator ptfind=byViewer.find(str);
	Association::iterator ptend=byViewer.end();
	if(ptfind==ptend) return false;
// call Close on the containing dialog.  This will do a delist
// of all viewers in the dialog and then remove the dialog
	(*viewers)[str]->Container->DoClose(); 
	return true;
}

DataObject& DynamicInteraction::getViewerState(wxString& str)
{
	return (*viewers)[str]->state;
}

void DynamicInteraction::getViewerStateContent(wxString& str, int& RowsNumber, int& ColNumber, vector<int>& StateContent)
{
	int ElemtValue;
	int i,ElemtLength;
	DataObject NewState;
	NewState = getViewerState(str);
	RowsNumber = NewState.rows;
	ColNumber = NewState.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewState.content[i].GetValue(ElemtValue);
		StateContent.push_back(ElemtValue);
	}		
}

void DynamicInteraction::getViewerStateContent(wxString& str, int& RowsNumber, int& ColNumber, vector<double>& StateContent)
{
	double ElemtValue;
	int i,ElemtLength;
	DataObject NewState;
	NewState = getViewerState(str);
	RowsNumber = NewState.rows;
	ColNumber = NewState.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewState.content[i].GetValue(ElemtValue);
		StateContent.push_back(ElemtValue);
	}		
}

void DynamicInteraction::getViewerStateContent(wxString& str, int& RowsNumber, int& ColNumber, vector<wxString>& StateContent)
{
	wxString ElemtValue;
	int i,ElemtLength;
	DataObject NewState;
	NewState = getViewerState(str);
	RowsNumber = NewState.rows;
	ColNumber = NewState.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewState.content[i].GetValue(ElemtValue);
		StateContent.push_back(ElemtValue);
	}		
}

void DynamicInteraction::getViewerStateContent(wxString& str, int& RowsNumber, int& ColNumber, vector<bool>& StateContent)
{
	bool ElemtValue;
	int i,ElemtLength;
	DataObject NewState;
	NewState = getViewerState(str);
	RowsNumber = NewState.rows;
	ColNumber = NewState.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewState.content[i].GetValue(ElemtValue);
		StateContent.push_back(ElemtValue);
	}		
}

void DynamicInteraction::getViewerStateContent(wxString& str, int& RowsNumber, int& ColNumber, int *ViewerState)
{
	/*
	int i,ElemtLength;
	DataObject NewState;
	NewState = getViewerState(str);
	RowsNumber = NewState.rows;
	ColNumber = NewState.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewState.content[i].GetValue(ViewerState[i]);
	}	
	*/
	vector<int> vsvector;
	getViewerStateContent(str, RowsNumber, ColNumber, vsvector);
	VectorToptr(vsvector, ViewerState);	
}

void DynamicInteraction::getViewerStateContent(wxString& str, int& RowsNumber, int& ColNumber, double *ViewerState)
{
	/*
	int i,ElemtLength;
	DataObject NewState;
	NewState = getViewerState(str);
	RowsNumber = NewState.rows;
	ColNumber = NewState.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewState.content[i].GetValue(ViewerState[i]);
	}	
	*/
	vector<double> vsvector;
	getViewerStateContent(str, RowsNumber, ColNumber, vsvector);
	VectorToptr(vsvector, ViewerState);	
}

void DynamicInteraction::getViewerStateContent(wxString& str, int& RowsNumber, int& ColNumber, char *ViewerState[])
{
	/*
	int i,ElemtLength;
	DataObject NewState;
	NewState = getViewerState(str);
	RowsNumber = NewState.rows;
	ColNumber = NewState.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewState.content[i].GetValue(ViewerState[i]);
	}	
	*/
	vector<wxString> vsvector;
	getViewerStateContent(str, RowsNumber, ColNumber, vsvector);
	WxStrVectoChptrVec(ViewerState, vsvector);
}

void DynamicInteraction::getViewerStateContent(wxString& str, int& RowsNumber, int& ColNumber, bool *ViewerState)
{
	/*
	int i,ElemtLength;
	DataObject NewState;
	NewState = getViewerState(str);
	RowsNumber = NewState.rows;
	ColNumber = NewState.cols;
	ElemtLength = RowsNumber*ColNumber;
	for (i = 0;i < ElemtLength; i++) {
		NewState.content[i].GetValue(ViewerState[i]);
	}	
	*/
	vector<bool> vsvector;
	getViewerStateContent(str, RowsNumber, ColNumber, vsvector);
	VectorToptr(vsvector, ViewerState);	
}

void DynamicInteraction::getViewerStateContent(wxString& str, int& RowsNumber, int& ColNumber, unsigned int *ViewerState)
{
  bool *boolp;
  int length;
	vector<bool> vsvector;
	
	getViewerStateContent(str, RowsNumber, ColNumber, vsvector);
	length = RowsNumber*ColNumber;
	boolp = new bool[length];
	VectorToptr(vsvector, boolp);	
	BooltoUInt(ViewerState, boolp, length);	
	delete [] boolp;
}

bool DynamicInteraction::setViewerState(wxString& str,DataObject& st)
{
	(*viewers)[str]->state=st;
	return true;
}

bool DynamicInteraction::setViewerState(wxString& str, vector<int>& DOContent, int row, int col)
{
	DataObject NewDObj(str, row, col, DOContent, INTT);
	if (setViewerState(str,NewDObj))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setViewerState(wxString& str, vector<double>& DOContent, int row, int col)
{
	DataObject NewDObj(str, row, col, DOContent, DOULBET);
	if (setViewerState(str,NewDObj))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setViewerState(wxString& str, vector<wxString>& DOContent, int row, int col)
{
	DataObject NewDObj(str, row, col, DOContent, STRINGT);
	if (setViewerState(str,NewDObj))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setViewerState(wxString& str, vector<bool>& DOContent, int row, int col)
{
	DataObject NewDObj(str, row, col, DOContent, LOGICT);
	if (setViewerState(str,NewDObj))
		return true;
	else
		return false;		
}

bool DynamicInteraction::setViewerState(wxString& str, int *DOContent, int row, int col)
{
	DataObject NewDObj(str, row, col, DOContent, INTT);
	if (setViewerState(str,NewDObj))
		return true;
	else
		return false;			
}	

bool DynamicInteraction::setViewerState(wxString& str, double *DOContent, int row, int col)
{
	DataObject NewDObj(str, row, col, DOContent, DOULBET);
	if (setViewerState(str,NewDObj))
		return true;
	else
		return false;			
}	

bool DynamicInteraction::setViewerState(wxString& str, char *DOContent[], int row, int col)
{
	DataObject NewDObj(str, row, col, DOContent, STRINGT);
	if (setViewerState(str,NewDObj))
		return true;
	else
		return false;			
}	

bool DynamicInteraction::setViewerState(wxString& str, bool *DOContent, int row, int col)
{
	DataObject NewDObj(str, row, col, DOContent, LOGICT);
	if (setViewerState(str,NewDObj))
		return true;
	else
		return false;			
}	

bool DynamicInteraction::setViewerState(wxString& str, unsigned int *DOContent, int row, int col)
{
	bool *boolp;
	int length;
	
	length = row*col;
	boolp = new bool[length];	
	UInttoBool(DOContent, boolp, length);	
	DataObject NewDObj(str, row, col, boolp, LOGICT);
	delete [] boolp;
	if (setViewerState(str,NewDObj))
		return true;
	else
		return false;			
}	

void DynamicInteraction::doRedraw(void)
{
	DataHash::iterator p=data->begin();
	DataHash::iterator pend=data->end();
	while(p != pend)
	{
		if(p->second.modifiedBy != NULL)
		{
			// if modified, redraw things that depend on it
			redrawByNamedData(p->second.label);
		}
		p++;
	}
}

void DynamicInteraction::redrawByNamedData(wxString name)
{
	Viewer *thismodifier = (*data)[name].modifiedBy;

	vector<wxString>::iterator iter=byData[name].begin();
	while(iter!=byData[name].end())
	{
		(*viewers)[*iter]->draw((*data)[name]);
		iter++;
	}	
	if(thismodifier == (*data)[name].modifiedBy)
	{
		// null this out unless someone else updated it
		(*data)[name].modifiedBy = NULL;
	}
}

#if 0
bool DynamicInteraction::redraw(wxString& str)
{
	(*viewers)[str]->draw();
	return true;
}
#endif

//update the association due to the change of datakey
bool DynamicInteraction::updateByData()
{	Association::iterator p=byData.begin();
	Association::iterator thisp;
	vector<wxString>::iterator iter;
	Association::iterator q;
	long refcount;
	while(p!=byData.end())
	{
		byData[p->first].clear();
		refcount = 0;
		q=byViewer.begin();
		while(q!=byViewer.end())
		{
			iter=(q->second).begin();
			while(iter!=(q->second).end()) 
			{
				if ((*iter)==(p->first))
				{
					byData[p->first].push_back(q->first);
					refcount++;
				}
				iter++;
			}
			q++;	
		}
		thisp = p;
		p++;
		if(refcount == 0 && !(*data)[thisp->first].persistent)
		{
			// delete if unreferenced and not persistent
			data->erase(thisp->first);     //erase from data hash
        		byData.erase(thisp->first);    //erase from byData Association;
		}
	}
	return true;
}

// The following was written on Feb 26,2005	

bool DynamicInteraction::InsertDataObjectRow(wxString& keystr,vector<int>& newrowvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertRow(newrowvt, where));		
}	

bool DynamicInteraction::InsertDataObjectRow(wxString& keystr,vector<double>& newrowvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertRow(newrowvt, where));		
}	

bool DynamicInteraction::InsertDataObjectRow(wxString& keystr,vector<wxString>& newrowvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertRow(newrowvt, where));		
}	

bool DynamicInteraction::InsertDataObjectRow(wxString& keystr,vector<bool>& newrowvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertRow(newrowvt, where));		
}	

bool DynamicInteraction::InsertDataObjectRow(wxString& keystr,int *newrowct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertRow(newrowct, where));		
}	

bool DynamicInteraction::InsertDataObjectRow(wxString& keystr, double *newrowct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertRow(newrowct, where));		
}	

bool DynamicInteraction::InsertDataObjectRow(wxString& keystr,char *newrowct[], int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertRow(newrowct, where));		
}	

bool DynamicInteraction::InsertDataObjectRow(wxString& keystr,bool *newrowct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertRow(newrowct, where));		
}	

bool DynamicInteraction::InsertDataObjectRow(wxString& keystr,unsigned int *newrowct, int where)
{
	bool *boolp;
	int length;	
	bool issuc;
	
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	length = (*data)[keystr].cols;	
	boolp = new bool[length];	
	UInttoBool(newrowct, boolp, length);		
	issuc =(*data)[keystr].insertRow(boolp, where);	
	delete [] boolp;
	return issuc;
}	

bool DynamicInteraction::AppendDataObjectRow(wxString& keystr,vector<int>& newrowvt)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendRow(newrowvt));		
}

bool DynamicInteraction::AppendDataObjectRow(wxString& keystr,vector<double>& newrowvt)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendRow(newrowvt));		
}

bool DynamicInteraction::AppendDataObjectRow(wxString& keystr,vector<wxString>& newrowvt)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendRow(newrowvt));		
}

bool DynamicInteraction::AppendDataObjectRow(wxString& keystr,vector<bool>& newrowvt)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendRow(newrowvt));		
}

bool DynamicInteraction::AppendDataObjectRow(wxString& keystr,int *newrowct)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendRow(newrowct));		
}

bool DynamicInteraction::AppendDataObjectRow(wxString& keystr, double *newrowct)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendRow(newrowct));		
}

bool DynamicInteraction::AppendDataObjectRow(wxString& keystr,char *newrowct[])
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendRow(newrowct));		
}

bool DynamicInteraction::AppendDataObjectRow(wxString& keystr, bool *newrowct)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendRow(newrowct));		
}

bool DynamicInteraction::AppendDataObjectRow(wxString& keystr, unsigned int *newrowct)
{
	bool *boolp;
	int length;	
	bool issuc;	
	
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	length = (*data)[keystr].cols;	
	boolp = new bool[length];	
	UInttoBool(newrowct, boolp, length);				
	issuc = ((*data)[keystr].appendRow(boolp));	
	delete [] boolp;
	return issuc;	
}

bool DynamicInteraction::ChangeDataObjectRow(wxString& keystr,vector<int>& newrowvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeRow(newrowvt, where));		
}	

bool DynamicInteraction::ChangeDataObjectRow(wxString& keystr,vector<double>& newrowvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeRow(newrowvt, where));		
}	

bool DynamicInteraction::ChangeDataObjectRow(wxString& keystr,vector<wxString>& newrowvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeRow(newrowvt, where));		
}	

bool DynamicInteraction::ChangeDataObjectRow(wxString& keystr,vector<bool>& newrowvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeRow(newrowvt, where));		
}	

bool DynamicInteraction::ChangeDataObjectRow(wxString& keystr,int *newrowct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeRow(newrowct, where));		
}	

bool DynamicInteraction::ChangeDataObjectRow(wxString& keystr, double *newrowct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeRow(newrowct, where));		
}	

bool DynamicInteraction::ChangeDataObjectRow(wxString& keystr,char *newrowct[], int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeRow(newrowct, where));		
}	

bool DynamicInteraction::ChangeDataObjectRow(wxString& keystr,bool *newrowct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeRow(newrowct, where));		
}	

bool DynamicInteraction::ChangeDataObjectRow(wxString& keystr,unsigned int *newrowct, int where)
{
	bool *boolp;
	int length;	
	bool issuc;	
		
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	length = (*data)[keystr].cols;	
	boolp = new bool[length];	
	UInttoBool(newrowct, boolp, length);	
	issuc = ((*data)[keystr].changeRow(boolp, where));
	delete [] boolp;
	return issuc;		
}	

bool DynamicInteraction::DeleteDataObjectRow(wxString& keystr, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].deleteRow(where));		
}

bool DynamicInteraction::InsertDataObjectCol(wxString& keystr,vector<int>& newcolvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertCol(newcolvt, where));		
}	

bool DynamicInteraction::InsertDataObjectCol(wxString& keystr,vector<double>& newcolvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertCol(newcolvt, where));		
}	

bool DynamicInteraction::InsertDataObjectCol(wxString& keystr,vector<wxString>& newcolvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertCol(newcolvt, where));		
}	

bool DynamicInteraction::InsertDataObjectCol(wxString& keystr,vector<bool>& newcolvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertCol(newcolvt, where));		
}	

bool DynamicInteraction::InsertDataObjectCol(wxString& keystr,int *newcolct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertCol(newcolct, where));		
}	

bool DynamicInteraction::InsertDataObjectCol(wxString& keystr, double *newcolct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertCol(newcolct, where));		
}	

bool DynamicInteraction::InsertDataObjectCol(wxString& keystr,char *newcolct[], int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertCol(newcolct, where));		
}	

bool DynamicInteraction::InsertDataObjectCol(wxString& keystr,bool *newcolct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].insertCol(newcolct, where));		
}	

bool DynamicInteraction::InsertDataObjectCol(wxString& keystr,unsigned int *newcolct, int where)
{
	bool *boolp;
	int length;	
	bool issuc;	
		
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	length = (*data)[keystr].rows;	
	boolp = new bool[length];	
	UInttoBool(newcolct, boolp, length);	
	issuc = ((*data)[keystr].insertCol(boolp, where));	
	delete [] boolp;
	return issuc;	
}	

bool DynamicInteraction::AppendDataObjectCol(wxString& keystr,vector<int>& newcolvt)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendCol(newcolvt));		
}

bool DynamicInteraction::AppendDataObjectCol(wxString& keystr,vector<double>& newcolvt)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendCol(newcolvt));		
}

bool DynamicInteraction::AppendDataObjectCol(wxString& keystr,vector<wxString>& newcolvt)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendCol(newcolvt));		
}

bool DynamicInteraction::AppendDataObjectCol(wxString& keystr,vector<bool>& newcolvt)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendCol(newcolvt));		
}

bool DynamicInteraction::AppendDataObjectCol(wxString& keystr,int *newcolct)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendCol(newcolct));		
}

bool DynamicInteraction::AppendDataObjectCol(wxString& keystr, double *newcolct)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendCol(newcolct));		
}

bool DynamicInteraction::AppendDataObjectCol(wxString& keystr,char *newcolct[])
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendCol(newcolct));		
}

bool DynamicInteraction::AppendDataObjectCol(wxString& keystr, bool *newcolct)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].appendCol(newcolct));		
}	

bool DynamicInteraction::AppendDataObjectCol(wxString& keystr, unsigned int *newcolct)
{
	bool *boolp;
	int length;	
	bool issuc;	
		
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	length = (*data)[keystr].rows;	
	boolp = new bool[length];	
	UInttoBool(newcolct, boolp, length);		
	issuc = ((*data)[keystr].appendCol(boolp));	
	delete [] boolp;
	return issuc;	
}	

bool DynamicInteraction::ChangeDataObjectCol(wxString& keystr,vector<int>& newcolvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeCol(newcolvt, where));		
}	

bool DynamicInteraction::ChangeDataObjectCol(wxString& keystr,vector<double>& newcolvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeCol(newcolvt, where));		
}	

bool DynamicInteraction::ChangeDataObjectCol(wxString& keystr,vector<wxString>& newcolvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeCol(newcolvt, where));		
}	

bool DynamicInteraction::ChangeDataObjectCol(wxString& keystr,vector<bool>& newcolvt, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeCol(newcolvt, where));		
}	

bool DynamicInteraction::ChangeDataObjectCol(wxString& keystr,int *newcolct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeCol(newcolct, where));		
}	

bool DynamicInteraction::ChangeDataObjectCol(wxString& keystr, double *newcolct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeCol(newcolct, where));		
}	

bool DynamicInteraction::ChangeDataObjectCol(wxString& keystr,char *newcolct[], int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeCol(newcolct, where));		
}	

bool DynamicInteraction::ChangeDataObjectCol(wxString& keystr,bool *newcolct, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].changeCol(newcolct, where));		
}	

bool DynamicInteraction::ChangeDataObjectCol(wxString& keystr,unsigned int *newcolct, int where)
{
	bool *boolp;
	int length;	
	bool issuc;	
		
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	length = (*data)[keystr].rows;	
	boolp = new bool[length];	
	UInttoBool(newcolct, boolp, length);			
	issuc = ((*data)[keystr].changeCol(boolp, where));
	delete [] boolp;
	return issuc;
			
}	

bool DynamicInteraction::DeleteDataObjectCol(wxString& keystr, int where)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	return((*data)[keystr].deleteCol(where));		
}

bool DynamicInteraction::SetDataObjectElement(wxString& keystr, int newvalue, int row, int col)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	(*data)[keystr].modifiedBy = (Viewer *) this; // force redraw of viewers that depend
	return((*data)[keystr].setValue(newvalue, row, col));		
}

bool DynamicInteraction::SetDataObjectElement(wxString& keystr, double newvalue, int row, int col)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	(*data)[keystr].modifiedBy = (Viewer *) this; // force redraw of viewers that depend
	return((*data)[keystr].setValue(newvalue, row, col));		
}

bool DynamicInteraction::SetDataObjectElement(wxString& keystr, char *newvalue, int row, int col)
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	(*data)[keystr].modifiedBy = (Viewer *) this; // force redraw of viewers that depend
	return((*data)[keystr].setValue(newvalue, row, col));		
}

bool DynamicInteraction::SetDataObjectElement(wxString& keystr, bool newvalue, int row, int col)	
{
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	(*data)[keystr].modifiedBy = (Viewer *) this; // force redraw of viewers that depend
	return((*data)[keystr].setValue(newvalue, row, col));		
}	

bool DynamicInteraction::SetDataObjectElement(wxString& keystr, unsigned int newvalue, int row, int col)	
{
	bool newvaluebool;
	
	DataHash::iterator pfind=data->find(keystr);
	DataHash::iterator pend=data->end();
	if (pfind == pend) return false;
	if (newvalue > 0)
	 	newvaluebool = 1;
	else
		newvaluebool = 0;
	(*data)[keystr].modifiedBy = (Viewer *) this; // force redraw of viewers that depend	
	return((*data)[keystr].setValue(newvaluebool, row, col));		
}

bool DynamicInteraction::getDataObjectProperty(wxString& str, int& row, int& col, int& datatype)
{
	int i;
	wxString strvalue;
	DataHash::iterator pfind=data->find(str);
	if (pfind==data->end()) return false;
	else{		
	 if (((*data)[str]).type != STRINGT) {
		row = ((*data)[str]).rows;
		col = ((*data)[str]).cols;
		datatype = ((*data)[str]).type;
		return true;
		}
	 if (((*data)[str]).type == STRINGT) {
	 	datatype = ((*data)[str]).type;
		row = ((*data)[str]).rows * ((*data)[str]).cols;  //The number of string
		col = 0;
		for (i = 0;i < row; i++) {
			((*data)[str]).content[i].GetValue(strvalue);
			col += strlen(strvalue.c_str()); 
			}
		col = col + row;                        // Total size of all the string ,include '\0'
		return true;
		}		
		return false;
	}		
}

