/*
*(C)* The file is part of the source distribution of Carapace
*(C)* version 0.5 or later
*(C)*
*(C)* Copyright (c) 2000-2005 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* This file is distributed under the GNU General Public License
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#include "cpcplatform.h"



// For compilers that support precompilation, includes "wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "wx/print.h"
#include "wx/printdlg.h"


#include <math.h>

#include "carapace.h"

#include "wx/image.h"

#undef UNDEFINED

#include "bitmaps/wforward.xpm"
#include "bitmaps/wback.xpm"
#include "bitmaps/open.xpm"

BEGIN_EVENT_TABLE(CarapaceHelpFrame, wxFrame)
	EVT_MENU(CPC_HELP_FORWARD, CarapaceHelpFrame::Forward)
	EVT_MENU(CPC_HELP_BACK, CarapaceHelpFrame::Back)
	EVT_MENU(CPC_HELP_OPEN, CarapaceHelpFrame::Open)
END_EVENT_TABLE()


// FIX
void CarapaceHelpFrame::SetSourceFile(wxString& file)
{
	if(html)
	{
		html->LoadPage(file);
	}
}


CarapaceHelpFrame::CarapaceHelpFrame(wxWindow *frame, wxString& file) 
	: wxFrame(NULL,-1,"test help",wxPoint(50, 50), 
	thisApp->Preferences->hWindowSize)
{
	wxInitAllImageHandlers();

	CreateStatusBar(1);
	html = new wxHtmlWindow(this);
	html->SetRelatedFrame(this, "%s");
	html->SetRelatedStatusBar(0);
	html->ReadCustomization(wxConfig::Get());
	html->LoadPage(file);

	LastDirectory = wxPathOnly(file);

	long style = wxNO_BORDER | wxTB_FLAT | wxTB_HORIZONTAL;
	wxToolBarBase  *toolbar;
	toolbar = CreateToolBar(style, CPC_HELP_TOOLBAR);
	toolbar->SetMargins(4,4);

	wxBitmap toolBarBitmaps[8];
	toolBarBitmaps[0] = wxBitmap(open_xpm);
	toolBarBitmaps[1] = wxBitmap(wback_xpm);
	toolBarBitmaps[2] = wxBitmap(wforward_xpm);

	toolbar->AddTool(CPC_HELP_OPEN, toolBarBitmaps[0], CPC_STRING_OPENHTML);
	toolbar->AddTool(CPC_HELP_BACK, toolBarBitmaps[1], CPC_STRING_BACK);
	toolbar->AddTool(CPC_HELP_FORWARD, toolBarBitmaps[2], CPC_STRING_FORWARD);

	toolbar->Realize();

	Show(TRUE);
	
}

CarapaceHelpFrame::~CarapaceHelpFrame(void)
{
	thisApp->HelpFrame = NULL;
}

void CarapaceHelpFrame::OnClose(wxCloseEvent &event)
{
	thisApp->HelpFrame = NULL;
	event.Skip();
}

void CarapaceHelpFrame::Forward(wxCommandEvent &event)
{
	html->HistoryForward();
}

void CarapaceHelpFrame::Back(wxCommandEvent &event)
{
	html->HistoryBack();
}

void CarapaceHelpFrame::Open(wxCommandEvent &event)
{
	//wxString p = wxFileSelector(CPC_STRING_OPENHTML /*"Open HTML document"*/,
	//	 "", "", "", "HTML files|*.htm");
	wxString p = CarapaceFindFile(CPC_STRING_OPENHTML,LastDirectory,
		"","","HTML files (*.html) |*.html|HTM file (*.htm)|*.htm|All files|*",
		wxFILE_MUST_EXIST);
		
	if (p != wxEmptyString)
	{
		html -> LoadPage(p);    
	}
}
