#include "cpcplatform.h"

#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "wx/print.h"
#include "wx/printdlg.h"
#include "wx/generic/dcpsg.h"
#include "wx/clipbrd.h"


#include "carapace.h"
#include "viewers.h"

#undef wxIMPLEMENT_CLASS_COMMON2
#define wxIMPLEMENT_CLASS_COMMON2(name, basename1, basename2, func)           \
    wxIMPLEMENT_CLASS_COMMON(name, basename1, &basename2::ms_classInfo,func)


BEGIN_EVENT_TABLE(ButtonViewer,wxButton)
EVT_RIGHT_DOWN(ButtonViewer::DoPopup)
EVT_MENU_RANGE(1,200000000,ButtonViewer::CatchMenu)
EVT_BUTTON(-1,ButtonViewer::OnButton)
END_EVENT_TABLE()

ButtonViewer::ButtonViewer()
{
	wxButton();
	action = label = NULL;
	actionstring = "";

}

ButtonViewer::~ButtonViewer()
{     
	delete popupmenu;
}

bool ButtonViewer::draw(DataObject& dobj)
{

	wxString buttonlabel;
	wxString tmpstr;
	(*intparms)[0].GetValue(buttonlabel);
	if(GetLabel() == buttonlabel)
	{
		return TRUE;
	}
	SetLabel(buttonlabel);

	// only update something if no one else is trying to update it

/*
	if(label && label->modifiedBy == NULL)
	{
	
		tmpstr = buttonlabel;
		(*label)[0].SetValue(tmpstr);
		label->modifiedBy = this;
	}*/
	ProcessAction();
	return TRUE;
}

void ButtonViewer::OnButton(wxCommandEvent& event)
{
	wxString buttonlabel;
	wxString currlabel;
	wxString tmpstr;
	/*
	(*intparms)[0].GetValue(buttonlabel);
	currlabel = GetLabel();
	if(buttonlabel == currlabel)
	{
		return;
	}
	(*intparms)[0].SetValue(currlabel);
	(*intparms).modifiedBy = this;

	if(label)
	{
		tmpstr = currlabel;
		(*label)[0].SetValue(tmpstr);
		label->modifiedBy = this;
	}
	*/
	ProcessAction();
}


IMPLEMENT_DYNAMIC_CLASS(ButtonViewerXmlHandler,wxXmlResourceHandler)

ButtonViewerXmlHandler::ButtonViewerXmlHandler() 
: wxXmlResourceHandler() 
{
    AddWindowStyles();
}

wxObject *ButtonViewerXmlHandler::DoCreateResource()
{ 
	int rows,cols,i; 
	vector<wxString> svals;
	//vector<double> dvals;
	//vector<bool> bvals;
	//wxString buttonlabel;

	wxString viewername = GetName();
	wxString intname = GetText(wxT("parmsname"));
	wxString actionstring = GetText("action");
	wxString actionname = GetText("actionname");
	wxString labelname = GetText("labelname");
	wxString error;

	DataObject *dobj;

	dobj = GetDynFromName(intname,"parmsname",STRINGT,-1,-1,"ButtonViewer",viewername,TRUE);
	if(dobj == NULL)
	{
		return NULL;
	}
	thisApp->DynamicDataP->getDataObjectContent(intname,rows,cols,svals);
	// svals should contain value, min, and max
	if(svals[0] == "")
	{
		// screwy parameters
		error.Printf(CPC_STRING_VIEWER0012,intname.c_str(),"ButtonViewer",viewername.c_str());
		wxMessageBox(error);
		return NULL;
	}
	// now everything should be ducky
	ButtonViewer *view = new ButtonViewer;
	view->Create(m_parentAsWindow,wxXmlResource::GetXRCID(viewername),svals[0],wxDefaultPosition,wxDefaultSize);
	view->intparms = dobj;
	thisApp->DynamicDataP->addViewer(viewername,(Viewer*) view);
	KludgeView = view;
	CreateChildren(view);

	vector<wxString> viewerdata;
	viewerdata.push_back(intname);

	if(actionstring != "")
	{
		view->actionstring = actionstring;
	}

	dobj = GetDynFromName(actionname,"actionname",STRINGT,-1,-1,
		"ButtonViewer",viewername,FALSE);
	if(dobj != NULL)
	{
		view->action = &(thisApp->DynamicDataP->getDataObjectValue(actionname));
		viewerdata.push_back(actionname);
	}
	view->hidecommand = GetBool("hidecommand",0);
	view->hideoutput = GetBool("hideoutput",0);

	dobj = GetDynFromName(labelname,"labelname",STRINGT,-1,-1,
		"ButtonViewer",viewername,FALSE);
	if(dobj != NULL)
	{
		view->label = &(thisApp->DynamicDataP->getDataObjectValue(labelname));
		viewerdata.push_back(labelname);
	}

	thisApp->DynamicDataP->setViewerData(viewerdata,viewername);
    

	return view;
}

bool ButtonViewerXmlHandler::CanHandle(wxXmlNode *node)
{
    return IsOfClass(node, wxT("ButtonViewer"));
}


