#include "cpcplatform.h"

#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "wx/print.h"
#include "wx/printdlg.h"
#include "wx/generic/dcpsg.h"
#include "wx/clipbrd.h"


#include "carapace.h"
#include "viewers.h"

#undef wxIMPLEMENT_CLASS_COMMON2
#define wxIMPLEMENT_CLASS_COMMON2(name, basename1, basename2, func)           \
    wxIMPLEMENT_CLASS_COMMON(name, basename1, &basename2::ms_classInfo,func)


BEGIN_EVENT_TABLE(CheckboxViewer,wxCheckBox)
EVT_RIGHT_DOWN(CheckboxViewer::DoPopup)
EVT_MENU_RANGE(1,200000000,CheckboxViewer::CatchMenu)
EVT_CHECKBOX(-1, CheckboxViewer::OnCheckbox)
END_EVENT_TABLE()

CheckboxViewer::CheckboxViewer()
{
	wxCheckBox();
	parameters  = action = label = NULL;
	actionstring = "";

}

CheckboxViewer::~CheckboxViewer()
{     
	delete popupmenu;
}

bool CheckboxViewer::draw(DataObject& dobj)
{
	bool dynvalue;
	wxString tmpstr;
	//bool valuechanged = false;
	(*parameters)[0].GetValue(dynvalue);
	if(GetValue() != dynvalue)
	{
		SetValue(dynvalue);
	}
	else 
		return(true);

	// only update something if no one else is trying to update it
/*
	if(label && label->modifiedBy == NULL)
	{	
		tmpstr.Printf("%d",dynvalue);	
		(*label)[0].SetValue(tmpstr);
		label->modifiedBy = this;
	}
*/	
	ProcessAction();
	return TRUE;
}

void CheckboxViewer::OnCheckbox(wxCommandEvent& event)
{
	bool dynvalue;
	wxString tmpstr;
	(*parameters)[0].GetValue(dynvalue);
	if(GetValue() != dynvalue)
	{
		(*parameters)[0].SetValue(GetValue());
		(*parameters).modifiedBy = this;
	}
	else 
		return;
/*
	if(label)
	{	
		tmpstr.Printf("%d",dynvalue);
		(*label)[0].SetValue(tmpstr);
		label->modifiedBy = this;
	}
*/	
	ProcessAction();
}


IMPLEMENT_DYNAMIC_CLASS(CheckboxViewerXmlHandler,wxXmlResourceHandler)

CheckboxViewerXmlHandler::CheckboxViewerXmlHandler() 
: wxXmlResourceHandler() 
{
    AddWindowStyles();
}

wxObject *CheckboxViewerXmlHandler::DoCreateResource()
{ 
	int rows,cols; 
	vector<bool> dvals;
	
	wxString viewername = GetName();
	wxString doname = GetText(wxT("dataname"));
	wxString actionstring = GetText("action");
	wxString actionname = GetText("actionname");
	wxString labelname = GetText("labelname");
	wxString mylabelname;

	wxString error;

	DataObject *dobj;

	dobj = GetDynFromName(labelname,"labelname",STRINGT,-1,-1,"CheckBoxViewer",viewername,false);
	if(dobj == NULL)
	{
		return NULL;
	}
	(*dobj)[0].GetValue(mylabelname);
	
	dobj = GetDynFromName(doname,"dataname",LOGICT,1,1,"CheckBoxViewer",viewername,TRUE);
	if(dobj == NULL)
	{
		return NULL;
	}
	thisApp->DynamicDataP->getDataObjectContent(doname,rows,cols,dvals);
	//thisApp->DynamicDataP->getDataObjectContent(doname,rows,cols,dvals);

	// now everything should be ducky
	
	CheckboxViewer *view = new CheckboxViewer;	
	view->Create(m_parentAsWindow,wxXmlResource::GetXRCID(viewername),mylabelname,wxDefaultPosition,wxDefaultSize);
	view->parameters = dobj;
	view->SetValue(dvals[0]);

	thisApp->DynamicDataP->addViewer(viewername,(Viewer*) view);
	KludgeView = view;
  CreateChildren(view);

	vector<wxString> viewerdata;
	viewerdata.push_back(doname);

	if(actionstring != "")
	{
		view->actionstring = actionstring;
	}

	dobj = GetDynFromName(actionname,"actionname",STRINGT,-1,-1,
		"CheckboxViewer",viewername,FALSE);
	if(dobj != NULL)
	{
		view->action = &(thisApp->DynamicDataP->getDataObjectValue(actionname));
		viewerdata.push_back(actionname);
	}
	view->hidecommand = GetBool("hidecommand",0);
	view->hideoutput = GetBool("hideoutput",0);

	dobj = GetDynFromName(labelname,"labelname",STRINGT,-1,-1,
		"CheckboxViewer",viewername,FALSE);
	if(dobj != NULL)
	{
		view->label = &(thisApp->DynamicDataP->getDataObjectValue(labelname));
		viewerdata.push_back(labelname);
	}

	thisApp->DynamicDataP->setViewerData(viewerdata,viewername);
    

	return view;
}

bool CheckboxViewerXmlHandler::CanHandle(wxXmlNode *node)
{
    return IsOfClass(node, wxT("CheckboxViewer"));
}


