#include "cpcplatform.h"

#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "wx/print.h"
#include "wx/printdlg.h"
#include "wx/generic/dcpsg.h"
#include "wx/clipbrd.h"


#include "carapace.h"
#include "viewers.h"

#undef wxIMPLEMENT_CLASS_COMMON2
#define wxIMPLEMENT_CLASS_COMMON2(name, basename1, basename2, func)           \
    wxIMPLEMENT_CLASS_COMMON(name, basename1, &basename2::ms_classInfo,func)



#if 0
BEGIN_EVENT_TABLE(ListViewer,wxListBox)
EVT_LISTBOX(CPC_DLGCTRL_LISTCLICK, ListViewer::OnListbox)
EVT_RIGHT_DOWN(ListViewer::DoPopup)
EVT_MENU_RANGE(1,200000000,ListViewer::CatchMenu)
END_EVENT_TABLE()

ListViewer::ListViewer()
{
}

ListViewer::~ListViewer()
{     
	delete popupmenu;
}

void ListViewer::OnListbox(wxCommandEvent& event)
{
	long which = event.GetInt();
	long type = event.GetExtraLong();
	long i,n;
	wxArrayInt sel;
	GetSelections(sel);

	n = GetCount();
	DeselectAll();
	for(i=0;i<n;i++)
	{
	//	SetSelection(i,FALSE);
        	(*selected)[i].SetValue(FALSE);
	}
	n = sel.GetCount();
	for(i=0;i<n;i++)
	{
		SetSelection(sel[i]);
	//	SetSelection(sel[i],TRUE);
        	(*selected)[sel[i]].SetValue(TRUE);
	}
	(*selected).modifiedBy = this;
}


bool ListViewer::draw(DataObject& dobj)
{
	bool sel;
	int i;
	for(i=0;i<GetCount();i++)
	{
		(*selected)[i].GetValue(sel);
		SetSelection(i,sel);
	}
	return TRUE;
}

IMPLEMENT_DYNAMIC_CLASS(ListViewerXmlHandler,wxXmlResourceHandler)

ListViewerXmlHandler::ListViewerXmlHandler() 
: wxXmlResourceHandler() 
{
    AddWindowStyles();
}

wxObject *ListViewerXmlHandler::DoCreateResource()
{ 
	int i,rows,cols,type,srows; 
	vector<wxString> lvals;
	vector<bool> svals;
	wxString labelname = GetText(wxT("labelname"));
	wxString selectedname = GetText(wxT("selectedname"));
	wxString viewername = GetName();
	if(labelname == "")
	{
		return NULL;
	}
	if(!thisApp->DynamicDataP->getDataObjectProperty(labelname,rows,cols,type))
	{
		// could not find data by name
		return NULL;
	}
// something may be wrong here, because I was getting back that a
// string had 25 columns, when it was entered with 1.  I need to
// follow up on this
// FIXME
	if(type != STRINGT /*|| cols != 1*/)
	{
		// wrong type or shape
		return NULL;
	}
	thisApp->DynamicDataP->getDataObjectContent(labelname,rows,cols,lvals);
	// dvals should contain value, min, and max
	if(selectedname == "")
	{
		return NULL;
	}
	if(!thisApp->DynamicDataP->getDataObjectProperty(selectedname,srows,cols,type))
	{
		// could not find data by name
		return NULL;
	}
	if(type != LOGICT || cols != 1 || srows != rows)
	{
		// wrong type or shape
		return NULL;
	}
	thisApp->DynamicDataP->getDataObjectContent(selectedname,rows,cols,svals);
	// now everything should be ducky
	ListViewer *view = new ListViewer;
	view->Create(m_parentAsWindow,CPC_DLGCTRL_LISTCLICK,
		//wxXmlResource::GetXRCID(viewername),
		wxDefaultPosition,wxDefaultSize,0,NULL,wxLB_EXTENDED | wxLB_ALWAYS_SB);
	view->labels = &(thisApp->DynamicDataP->getDataObjectValue(labelname));
	view->selected = &(thisApp->DynamicDataP->getDataObjectValue(selectedname));
	for(i=0;i<rows;i++)
	{
		view->Append(lvals[i]);
		view->SetSelection(i,svals[i]);
	}
	KludgeView = view;
	CreateChildren(view);
	thisApp->DynamicDataP->addViewer(viewername,(Viewer*) view);
	vector<wxString> viewerdata;
	viewerdata.push_back(labelname);
	viewerdata.push_back(selectedname);
	thisApp->DynamicDataP->setViewerData(viewerdata,viewername);
    
	return view;
}

bool ListViewerXmlHandler::CanHandle(wxXmlNode *node)
{
    return IsOfClass(node, wxT("ListViewer"));
}
#endif



// this class was originally so that I could change the
// colors in the labels. I can do that, but the highlighted
// colors are outside by control. 



BEGIN_EVENT_TABLE(ListViewer,wxListCtrl)
EVT_LIST_ITEM_SELECTED(CPC_DLGCTRL_LISTCLICK, ListViewer::OnSelected)
EVT_LIST_ITEM_DESELECTED(CPC_DLGCTRL_LISTCLICK, ListViewer::OnDeselected)
EVT_RIGHT_DOWN(ListViewer::DoPopup)
EVT_MENU_RANGE(1,200000000,ListViewer::CatchMenu)
END_EVENT_TABLE()

ListViewer::ListViewer()
{
	selected = NULL;
	highlighted = NULL;
	colors = NULL;
}

ListViewer::~ListViewer()
{     
	delete popupmenu;
}

void ListViewer::OnDeselected(wxListEvent& event)
{
	bool dohigh,thisb;
	long i = event.GetIndex();
	dohigh = FALSE;
	selected->content[i].SetValue(dohigh);
	if(selected != NULL)
	{
		selected->content[i].GetValue(thisb);
		dohigh = dohigh || thisb;
	}
	if(highlighted != NULL)
	{
		highlighted->content[i].GetValue(thisb);
		dohigh = dohigh || thisb;
	}
	if(deleted != NULL)
	{
 		deleted->content[i].GetValue(thisb);
		if(thisb)
		{
			dohigh = FALSE;
		}
	}
	if(dohigh)
	{
		SetItemState(i,wxLIST_STATE_SELECTED, wxLIST_STATE_SELECTED);
	}
	else
	{
		SetItemState(i,0, wxLIST_STATE_SELECTED);
	}
	(*selected).modifiedBy = this;
}

void ListViewer::OnSelected(wxListEvent& event)
{
	bool dohigh,thisb;
	long i = event.GetIndex();
	dohigh = TRUE;
	selected->content[i].SetValue(dohigh);
	dohigh = FALSE;
	if(selected != NULL)
	{
		selected->content[i].GetValue(thisb);
		dohigh = dohigh || thisb;
	}
	if(highlighted != NULL)
	{
		highlighted->content[i].GetValue(thisb);
		dohigh = dohigh || thisb;
	}
	if(deleted != NULL)
	{
 		deleted->content[i].GetValue(thisb);
		if(thisb)
		{
			dohigh = FALSE;
		}
	}
	if(dohigh)
	{
		SetItemState(i,wxLIST_STATE_SELECTED, wxLIST_STATE_SELECTED);
	}
	else
	{
		SetItemState(i,0, wxLIST_STATE_SELECTED);
	}
	(*selected).modifiedBy = this;
}


bool ListViewer::draw(DataObject& dobj)
{
	int i, cgindex;
	bool dohigh,thisb;
	wxString tmpstr;
	if(&dobj == selected || &dobj == highlighted || &dobj == deleted)
	{
		for(i=0;i<rows;i++)
		{
			dohigh = FALSE;
			if(selected != NULL)
			{
				selected->content[i].GetValue(thisb);
				dohigh = dohigh || thisb;
			}
			if(highlighted != NULL)
			{
				highlighted->content[i].GetValue(thisb);
				dohigh = dohigh || thisb;
			}
			if(deleted != NULL)
			{
 				deleted->content[i].GetValue(thisb);
				if(thisb)
				{
					dohigh = FALSE;
				}
			}
			if(dohigh)
			{
				SetItemState(i,wxLIST_STATE_SELECTED, wxLIST_STATE_SELECTED);
			}
			else
			{
				SetItemState(i,0, wxLIST_STATE_SELECTED);
			}
		}
	}
	if(&dobj == colors || &dobj == glyphs || &dobj == deleted)
	{
		int icolor = 67; // default color is white
		int iglyph = 0; // default glyph is none
		for(i=0;i<rows;i++)
		{
			if(colors != NULL)
			{
				colors->content[i].GetValue(icolor);
			}
			if(glyphs != NULL)
			{
				glyphs->content[i].GetValue(iglyph);
			}
			cgindex = iglyph*thisApp->ColorArrayLength+icolor;
			if(deleted != NULL)
			{
 				deleted->content[i].GetValue(thisb);
				if(thisb)
				{
					cgindex = thisApp->ColorArrayLength*thisApp->GlyphArrayLength;
				}
			}
			SetItemImage(i,cgindex);
		}
	}
	if(&dobj == labels)
	{
		for(i=0;i<rows;i++)
		{
			labels->content[i].GetValue(tmpstr);
			SetItemText(i,tmpstr);
		}
		SetColumnWidth(0,wxLIST_AUTOSIZE);
	}
	ProcessAction();
	return TRUE;
}

IMPLEMENT_DYNAMIC_CLASS(ListViewerXmlHandler,wxXmlResourceHandler)

ListViewerXmlHandler::ListViewerXmlHandler() 
: wxXmlResourceHandler() 
{
    AddWindowStyles();
}

wxObject *ListViewerXmlHandler::DoCreateResource()
{ 
	int i,rows,cols,type; 
	int icolor,iglyph,cgindex;
	bool dohigh;
	wxListItem item;
	wxString error;
	vector<wxString> wasted;

	wxString labelname = GetText(wxT("labelname"));
	wxString selectedname = GetText(wxT("selectedname"));
	wxString highlightedname = GetText(wxT("highlightedname"));
	wxString deletedname = GetText(wxT("deletedname"));
	wxString colorindexname = GetText("colorindexname");
	wxString glyphindexname = GetText("glyphindexname");
	wxString actionname = GetText("actionname");
	wxString action = GetText("action");
	wxString viewername = GetName();


	DataObject *ldobj;
	DataObject *sdobj;
	DataObject *hdobj;
	DataObject *ddobj;
	DataObject *cdobj;
	DataObject *gdobj;
	DataObject *adobj;

	ldobj = GetDynFromName(labelname,"labelname",STRINGT,-1,-1,"ListViewer",viewername,TRUE);
	if(ldobj == NULL)
	{
		return NULL;
	}
	thisApp->DynamicDataP->getDataObjectProperty(labelname,rows,cols,type);

	sdobj = GetDynFromName(selectedname,"selectedname",LOGICT,rows,1,"ListViewer",viewername);
	hdobj = GetDynFromName(highlightedname,"highlightedname",LOGICT,rows,1,"ListViewer",viewername);
	ddobj = GetDynFromName(deletedname,"deletedname",LOGICT,rows,1,"ListViewer",viewername);
	cdobj = GetDynFromName(colorindexname,"colorindexname",INTT,rows,1,"ListViewer",viewername);
	gdobj = GetDynFromName(glyphindexname,"glyphindexname",INTT,rows,1,"ListViewer",viewername);
	adobj = GetDynFromName(actionname,"actionname",STRINGT,-1,-1,"ListViewer",viewername);

	if(sdobj == NULL && hdobj == NULL)
	{
		error.Printf(CPC_STRING_VIEWER0013,"selectedname","highlightedname",
			"ListViewer",viewername.c_str());
		return(NULL);
	}


	ListViewer *view = new ListViewer;
	view->Create(m_parentAsWindow,CPC_DLGCTRL_LISTCLICK,
		wxDefaultPosition,wxDefaultSize,wxLC_REPORT|wxLC_NO_HEADER);

        view->hidecommand = GetBool("hidecommand",0);
        view->hideoutput = GetBool("hideoutput",0);

	thisApp->DynamicDataP->addViewer(viewername,(Viewer*) view);
	vector<wxString> viewerdata;
	view->labels = ldobj;
	viewerdata.push_back(labelname);
	thisApp->DynamicDataP->getDataObjectContent(labelname,rows,cols,view->lvals);
	view->rows = rows;

	if((view->selected = sdobj) != NULL)
	{
		viewerdata.push_back(selectedname);
		thisApp->DynamicDataP->getDataObjectContent(selectedname,rows,cols,view->svals);
	}
	if((view->highlighted = hdobj) != NULL)
	{
		viewerdata.push_back(highlightedname);
		thisApp->DynamicDataP->getDataObjectContent(highlightedname,rows,cols,view->hvals);
	}
	if((view->deleted = ddobj) != NULL)
	{
		viewerdata.push_back(deletedname);
		thisApp->DynamicDataP->getDataObjectContent(deletedname,rows,cols,view->dvals);
	}
	if((view->colors = cdobj) != NULL)
	{
		viewerdata.push_back(colorindexname);
		thisApp->DynamicDataP->getDataObjectContent(colorindexname,rows,cols,view->cvals);
	}
	if((view->glyphs = gdobj) != NULL)
	{
		viewerdata.push_back(glyphindexname);
		thisApp->DynamicDataP->getDataObjectContent(glyphindexname,rows,cols,view->gvals);
	}
	if((view->action = adobj) != NULL)
	{
		viewerdata.push_back(actionname);
	}

	KludgeView = view;
	CreateChildren(view);
	view->InsertColumn(0,"");
	view->SetImageList(thisApp->ColorGlyphPatches,wxIMAGE_LIST_SMALL);

	icolor = 67; // default color is white
	iglyph = 0; // default glyph is circle
	item.SetMask(wxLIST_MASK_STATE | wxLIST_MASK_TEXT | wxLIST_MASK_IMAGE);
	item.SetStateMask(wxLIST_STATE_SELECTED);
	for(i=0;i<rows;i++)
	{
		item.SetId(i);
		item.SetText(view->lvals[i]);
		if(cdobj != NULL)
		{
			icolor = view->cvals[i];
		}
		if(gdobj != NULL)
		{
			iglyph = view->gvals[i];
		}
		cgindex = iglyph*thisApp->ColorArrayLength+icolor;
		dohigh = FALSE;
		if(sdobj != NULL)
		{
			dohigh = dohigh || view->svals[i];
		}
		if(hdobj != NULL)
		{
			dohigh = dohigh || view->hvals[i];
		}
		if(ddobj != NULL && view->dvals[i])
		{
			cgindex = thisApp->ColorArrayLength*thisApp->GlyphArrayLength;
			dohigh = FALSE;
		}
		item.SetImage(cgindex);
		
		//view->InsertItem(i,lvals[i],630);
		view->InsertItem(item);
		if(dohigh)
		{
			view->SetItemState(i,wxLIST_STATE_SELECTED, wxLIST_STATE_SELECTED);
		}
		else
		{
			view->SetItemState(i,0, wxLIST_STATE_SELECTED);
		}
	}
	view->SetColumnWidth(0,wxLIST_AUTOSIZE);
	thisApp->DynamicDataP->setViewerData(viewerdata,viewername);
    
	return view;
}

bool ListViewerXmlHandler::CanHandle(wxXmlNode *node)
{
    return IsOfClass(node, wxT("ListViewer"));
}


