#include "cpcplatform.h"

#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "wx/print.h"
#include "wx/printdlg.h"
#include "wx/generic/dcpsg.h"
#include "wx/clipbrd.h"


#include "carapace.h"
#include "viewers.h"

#undef wxIMPLEMENT_CLASS_COMMON2
#define wxIMPLEMENT_CLASS_COMMON2(name, basename1, basename2, func)           \
    wxIMPLEMENT_CLASS_COMMON(name, basename1, &basename2::ms_classInfo,func)

const int maxchoice  = 50;
//The following appended on May 20,2005

BEGIN_EVENT_TABLE(RadioboxViewer,wxRadioBox)
EVT_RIGHT_DOWN(RadioboxViewer::DoPopup)
EVT_MENU_RANGE(1,200000000,RadioboxViewer::CatchMenu)
EVT_RADIOBOX(-1, RadioboxViewer::OnRadiobox)
END_EVENT_TABLE()

RadioboxViewer::RadioboxViewer()
{
	wxRadioBox();
	parameters =  action = label =  NULL;
	actionstring = "";

}

RadioboxViewer::~RadioboxViewer()
{     
	delete popupmenu;
}

bool RadioboxViewer::draw(DataObject& dobj)
{
	
	int dynvalue;
	//bool unchecktocheck;
	wxString tmpstr;
	wxString currentselectnmdt;
	//wxString doname = strdoname;
	//bool valuechanged = false;
	(*parameters)[0].GetValue(dynvalue);
	if(GetSelection() != dynvalue)
	{
		SetSelection(dynvalue);
	}
	else 
		return(true);
	// only update something if no one else is trying to update it
/*
	if(label && label->modifiedBy == NULL)
	{
		tmpstr.Printf("%d",dynvalue);
		
		(*label)[0].SetValue(tmpstr);
		label->modifiedBy = this;
	}
*/	
	ProcessAction();
	return TRUE;
}

void RadioboxViewer::OnRadiobox(wxCommandEvent& event)
{
	int dynvalue,currselvalue;
	wxString tmpstr;
	//wxString currentselectnmdt;
	//wxString doname = strdoname;
	(*parameters)[0].GetValue(dynvalue);
	currselvalue = GetSelection();
	if(currselvalue != dynvalue)
	{
		(*parameters)[0].SetValue(currselvalue);
		(*parameters).modifiedBy = this;
	}
	else 
		return;
/*	
	if(label)
	{		
		tmpstr.Printf("%d",currselvalue);	
		(*label)[0].SetValue(tmpstr);
		label->modifiedBy = this;
	}
*/
	ProcessAction();
}


IMPLEMENT_DYNAMIC_CLASS(RadioboxViewerXmlHandler,wxXmlResourceHandler)

RadioboxViewerXmlHandler::RadioboxViewerXmlHandler() 
: wxXmlResourceHandler() 
{
    AddWindowStyles();
}

wxObject *RadioboxViewerXmlHandler::DoCreateResource()
{ 
	
	int rows,cols; 
	int RadioBoxbuttoncount;
	int i,initselnum;
	vector<int> dvals;
	vector<wxString> choicelabelvals;
  DataObject *radioboxparameters; 
  DataObject *radioboxlabels; 
  wxString choicelabel[maxchoice];  
  

	wxString viewername = GetName();
	wxString doname = GetText(wxT("dataname"));
	wxString actionstring = GetText("action");
	wxString actionname = GetText("actionname");
	wxString labelname = GetText("labelname");
	wxString choicelabeldt =  GetText("choicelabel");   
	wxString mylabelname;
	wxString error;

	DataObject *dobj;
	
	dobj = GetDynFromName(labelname,"labelname",STRINGT,-1,-1,"RadioBoxViewer",viewername,false);
	if(dobj == NULL)
	{
		return NULL;
	}
	(*dobj)[0].GetValue(mylabelname);

	dobj = GetDynFromName(doname,"dataname",INTT,2,1,"RadioboxViewer",viewername,TRUE);
	if(dobj == NULL)
	{
		return NULL;
	}
	radioboxparameters = dobj;
	(*dobj)[1].GetValue(RadioBoxbuttoncount);
	(*dobj)[0].GetValue(initselnum);	
	
	
	// svals should contain value, min, and max
	if(initselnum < 0 || initselnum >= RadioBoxbuttoncount )
	{
		// screwy parameters
		error.Printf(CPC_STRING_VIEWER0012,doname.c_str(),"RadioboxViewer",viewername.c_str());
		wxMessageBox(error);
		return NULL;
	}
	
	dobj = GetDynFromName(choicelabeldt,"choicelabel",STRINGT,-1,-1,"RadioboxViewer",viewername,false);
	if(dobj == NULL)
	{
		return NULL;
	}
	radioboxlabels = dobj;
	thisApp->DynamicDataP->getDataObjectContent(choicelabeldt,rows,cols,choicelabelvals);
	for (i = 0; i< RadioBoxbuttoncount; i++) 
		choicelabel[i] = choicelabelvals[i];	
	// now everything should be ducky
	
	RadioboxViewer *view = new RadioboxViewer;	
	view->Create(m_parentAsWindow,wxXmlResource::GetXRCID(viewername),mylabelname,wxDefaultPosition,wxDefaultSize,RadioBoxbuttoncount,choicelabel);
	view->SetSelection(initselnum);
	view->parameters = radioboxparameters;
	view->parameterLabeldt = radioboxlabels;
	thisApp->DynamicDataP->addViewer(viewername,(Viewer*) view);
	KludgeView = view;
	CreateChildren(view);

	vector<wxString> viewerdata;
	viewerdata.push_back(doname);
	viewerdata.push_back(choicelabeldt);

	if(actionstring != "")
	{
		view->actionstring = actionstring;
	}

	dobj = GetDynFromName(actionname,"actionname",STRINGT,-1,-1,
		"RadioboxViewer",viewername,FALSE);
	if(dobj != NULL)
	{
		view->action = &(thisApp->DynamicDataP->getDataObjectValue(actionname));
		viewerdata.push_back(actionname);
	}
	view->hidecommand = GetBool("hidecommand",0);
	view->hideoutput = GetBool("hideoutput",0);

	dobj = GetDynFromName(labelname,"labelname",STRINGT,-1,-1,
		"RadioboxViewer",viewername,FALSE);
	if(dobj != NULL)
	{
		view->label = dobj;
		viewerdata.push_back(labelname);
	}

	thisApp->DynamicDataP->setViewerData(viewerdata,viewername);
    

	return view;
}

bool RadioboxViewerXmlHandler::CanHandle(wxXmlNode *node)
{
    return IsOfClass(node, wxT("RadioboxViewer"));
}


