#include "cpcplatform.h"

#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "wx/print.h"
#include "wx/printdlg.h"
#include "wx/generic/dcpsg.h"
#include "wx/clipbrd.h"


#include "carapace.h"
#include "viewers.h"

#undef wxIMPLEMENT_CLASS_COMMON2
#define wxIMPLEMENT_CLASS_COMMON2(name, basename1, basename2, func)           \
    wxIMPLEMENT_CLASS_COMMON(name, basename1, &basename2::ms_classInfo,func)



BEGIN_EVENT_TABLE(ScrolledTextViewer,wxTextCtrl)
EVT_RIGHT_DOWN(ScrolledTextViewer::DoPopup)
EVT_MENU_RANGE(1,200000000,ScrolledTextViewer::CatchMenu)
END_EVENT_TABLE()

ScrolledTextViewer::ScrolledTextViewer()
{
	actionstring = "";
	action = NULL;
	hidecommand = FALSE;
	hideoutput = FALSE;
}

ScrolledTextViewer::~ScrolledTextViewer()
{     
	delete popupmenu;
}

bool ScrolledTextViewer::draw(DataObject& dobj)
{
	wxString label;
	(*content)[0].GetValue(label);
	SetValue(label);

	ProcessAction();
	return TRUE;
}

IMPLEMENT_DYNAMIC_CLASS(ScrolledTextViewerXmlHandler,wxXmlResourceHandler)

ScrolledTextViewerXmlHandler::ScrolledTextViewerXmlHandler() 
: wxXmlResourceHandler() 
{
    XRC_ADD_STYLE(wxTE_NO_VSCROLL);
    XRC_ADD_STYLE(wxTE_AUTO_SCROLL);
    XRC_ADD_STYLE(wxTE_PROCESS_ENTER);
    XRC_ADD_STYLE(wxTE_PROCESS_TAB);
    XRC_ADD_STYLE(wxTE_MULTILINE);
    XRC_ADD_STYLE(wxTE_PASSWORD);
    XRC_ADD_STYLE(wxTE_READONLY);
    XRC_ADD_STYLE(wxHSCROLL);
    XRC_ADD_STYLE(wxTE_RICH);
    XRC_ADD_STYLE(wxTE_RICH2);
    XRC_ADD_STYLE(wxTE_AUTO_URL);
    XRC_ADD_STYLE(wxTE_NOHIDESEL);
    XRC_ADD_STYLE(wxTE_LEFT);
    XRC_ADD_STYLE(wxTE_CENTRE);
    XRC_ADD_STYLE(wxTE_RIGHT);
    XRC_ADD_STYLE(wxTE_DONTWRAP);
    XRC_ADD_STYLE(wxTE_LINEWRAP);
    XRC_ADD_STYLE(wxTE_WORDWRAP);

    AddWindowStyles();
}

wxObject *ScrolledTextViewerXmlHandler::DoCreateResource()
{ 
	int rows,cols; 
	wxString contentname = GetText(wxT("contentname"));
	wxString viewername = GetName();
	wxString actionstring = GetText("action");
	wxString actionname = GetText("actionname");
	wxString error;
	vector<wxString> label;

	DataObject *dobj;

	dobj = GetDynFromName(contentname,"contentname",STRINGT,-1,-1,
		"ScrolledTextViewer",viewername,TRUE);
	if(dobj == NULL)
	{
		return NULL;
	}
	thisApp->DynamicDataP->getDataObjectContent(contentname,rows,cols,label);
	ScrolledTextViewer *view = new ScrolledTextViewer;
	view->Create(m_parentAsWindow,wxXmlResource::GetXRCID(viewername),label[0],
                 GetPosition(), GetSize(), GetStyle());

	view->content = dobj;
	KludgeView = view;
	CreateChildren(view);

	vector<wxString> viewerdata;
	viewerdata.push_back(contentname);

	if(actionstring != "")
	{
		view->actionstring = actionstring;
	}

	dobj = GetDynFromName(actionname,"actionname",STRINGT,-1,-1,
		"ScrolledTextViewer",viewername,FALSE);
	if(dobj != NULL)
	{
		view->action = dobj;
		viewerdata.push_back(actionname);
	}

	view->hidecommand = GetBool("hidecommand",0);
	view->hideoutput = GetBool("hideoutput",0);
	if(HasParam("font"))
	{
		view->SetFont(GetFont());
	}
	thisApp->DynamicDataP->addViewer(viewername,(Viewer*) view);
	thisApp->DynamicDataP->setViewerData(viewerdata,viewername);
    
	return view;
}

bool ScrolledTextViewerXmlHandler::CanHandle(wxXmlNode *node)
{
    return IsOfClass(node, wxT("ScrolledTextViewer"));
}




