#include "cpcplatform.h"

#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "wx/print.h"
#include "wx/printdlg.h"
#include "wx/generic/dcpsg.h"
#include "wx/clipbrd.h"


#include "carapace.h"
#include "viewers.h"

#undef wxIMPLEMENT_CLASS_COMMON2
#define wxIMPLEMENT_CLASS_COMMON2(name, basename1, basename2, func)           \
    wxIMPLEMENT_CLASS_COMMON(name, basename1, &basename2::ms_classInfo,func)


BEGIN_EVENT_TABLE(SpinCtrlViewer,wxSpinCtrl)
EVT_RIGHT_DOWN(SpinCtrlViewer::DoPopup)
EVT_MENU_RANGE(1,200000000,SpinCtrlViewer::CatchMenu)
EVT_SPINCTRL  (-1, SpinCtrlViewer::OnSpinCtrl)
EVT_TEXT      (-1, SpinCtrlViewer::OnSpinCtrlText)
END_EVENT_TABLE()

SpinCtrlViewer::SpinCtrlViewer()
{
	wxSpinCtrl();
	intparms = action = label = NULL;
	actionstring = "";

}

SpinCtrlViewer::~SpinCtrlViewer()
{    
	delete popupmenu; 	
}

bool SpinCtrlViewer::draw(DataObject& dobj)
{
	int sval;
	wxString tmpstr;
	(*intparms)[0].GetValue(sval);
	if(GetValue() == sval)
	{
		return TRUE;
	}
	SetValue(sval);

	// only update something if no one else is trying to update it
/*
	if(label && label->modifiedBy == NULL)
	{
	
		tmpstr.Printf("%d",sval);		
		(*label)[0].SetValue(tmpstr);
		label->modifiedBy = this;
	}
	*/
	ProcessAction();
	return TRUE;
}

void SpinCtrlViewer::OnSpinCtrl(wxSpinEvent& event)
{
	int dynvalue, sval;
	wxString tmpstr;
	(*intparms)[0].GetValue(dynvalue);
	sval = GetValue();
	if(sval == dynvalue)
	{
		return;
	}
	(*intparms)[0].SetValue(sval);
	(*intparms).modifiedBy = this;
/*	
	if(label)
	{	
		tmpstr.Printf("%d",sval);
		(*label)[0].SetValue(tmpstr);
		label->modifiedBy = this;
	}*/
	ProcessAction();
}

void SpinCtrlViewer::OnSpinCtrlText(wxCommandEvent& event)
{
	int dynvalue, sval;
	wxString tmpstr;
	(*intparms)[0].GetValue(dynvalue);
	sval = GetValue();
	if(sval == dynvalue)
	{
		return;
	}
	(*intparms)[0].SetValue(sval);
	(*intparms).modifiedBy = this;
/*	
	if(label)
	{	
		tmpstr.Printf("%d",sval);
		(*label)[0].SetValue(tmpstr);
		label->modifiedBy = this;
	}*/
	ProcessAction();	
}


IMPLEMENT_DYNAMIC_CLASS(SpinCtrlViewerXmlHandler,wxXmlResourceHandler)

SpinCtrlViewerXmlHandler::SpinCtrlViewerXmlHandler() 
: wxXmlResourceHandler() 
{
    AddWindowStyles();
}

wxObject *SpinCtrlViewerXmlHandler::DoCreateResource()
{ 
	int rows,cols,i; 
	vector<int> svals;
	vector<double> dvals;
	vector<bool> bvals;

	wxString viewername = GetName();
	wxString intname = GetText(wxT("parmsname"));
	wxString actionstring = GetText("action");
	wxString actionname = GetText("actionname");
	wxString labelname = GetText("labelname");
	wxString error;

	DataObject *dobj;

	dobj = GetDynFromName(intname,"parmsname",INTT,3,1,"SpinCtrlViewer",viewername,TRUE);
	if(dobj == NULL)
	{
		return NULL;
	}
	thisApp->DynamicDataP->getDataObjectContent(intname,rows,cols,svals);
	// svals should contain value, min, and max
	if(svals[0] < svals[1] || svals[0] > svals[2] || svals[2] <= svals[1])
	{
		// screwy parameters
		error.Printf(CPC_STRING_VIEWER0012,intname.c_str(),"SpinCtrlViewer",viewername.c_str());
		wxMessageBox(error);
		return NULL;
	}
	// now everything should be ducky
	SpinCtrlViewer *view = new SpinCtrlViewer;
	view->Create(m_parentAsWindow,wxXmlResource::GetXRCID(viewername),wxEmptyString,wxDefaultPosition,wxSize(100,-1),wxSP_ARROW_KEYS,svals[1],svals[2],svals[0]);
	//view->SetRange(svals[1],svals[2]);
  //view->SetValue(svals[0]);
	view->intparms = dobj;
	thisApp->DynamicDataP->addViewer(viewername,(Viewer*) view);
	KludgeView = view;
	CreateChildren(view);

	vector<wxString> viewerdata;
	viewerdata.push_back(intname);

	if(actionstring != "")
	{
		view->actionstring = actionstring;
	}

	dobj = GetDynFromName(actionname,"actionname",STRINGT,-1,-1,
		"SpinCtrlViewer",viewername,FALSE);
	if(dobj != NULL)
	{
		view->action = &(thisApp->DynamicDataP->getDataObjectValue(actionname));
		viewerdata.push_back(actionname);
	}
	view->hidecommand = GetBool("hidecommand",0);
	view->hideoutput = GetBool("hideoutput",0);

	dobj = GetDynFromName(labelname,"labelname",STRINGT,-1,-1,
		"SpinCtrlViewer",viewername,FALSE);
	if(dobj != NULL)
	{
		view->label = &(thisApp->DynamicDataP->getDataObjectValue(labelname));
		viewerdata.push_back(labelname);
	}

	thisApp->DynamicDataP->setViewerData(viewerdata,viewername);
    

	return view;
}

bool SpinCtrlViewerXmlHandler::CanHandle(wxXmlNode *node)
{
    return IsOfClass(node, wxT("SpinCtrlViewer"));
}


