#include "cpcplatform.h"

#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "wx/print.h"
#include "wx/printdlg.h"
#include "wx/generic/dcpsg.h"
#include "wx/clipbrd.h"


#include "carapace.h"
#include "viewers.h"

#undef wxIMPLEMENT_CLASS_COMMON2
#define wxIMPLEMENT_CLASS_COMMON2(name, basename1, basename2, func)           \
    wxIMPLEMENT_CLASS_COMMON(name, basename1, &basename2::ms_classInfo,func)



BEGIN_EVENT_TABLE(StaticTextViewer,wxStaticText)
EVT_RIGHT_DOWN(StaticTextViewer::DoPopup)
EVT_MENU_RANGE(1,200000000,StaticTextViewer::CatchMenu)
END_EVENT_TABLE()

StaticTextViewer::StaticTextViewer()
{
	actionstring = "";
	action = NULL;
	hidecommand = FALSE;
	hideoutput = FALSE;
}

StaticTextViewer::~StaticTextViewer()
{     
	delete popupmenu;
}

bool StaticTextViewer::draw(DataObject& dobj)
{
	wxString label;
	(*content)[0].GetValue(label);
	SetLabel(label);

	ProcessAction();
	return TRUE;
}

IMPLEMENT_DYNAMIC_CLASS(StaticTextViewerXmlHandler,wxXmlResourceHandler)

StaticTextViewerXmlHandler::StaticTextViewerXmlHandler() 
: wxXmlResourceHandler() 
{
    AddWindowStyles();
}

wxObject *StaticTextViewerXmlHandler::DoCreateResource()
{ 
	int rows,cols; 
	wxString contentname = GetText(wxT("contentname"));
	wxString viewername = GetName();
	wxString actionstring = GetText("action");
	wxString actionname = GetText("actionname");
	wxString error;
	vector<wxString> label;

	DataObject *dobj;

	dobj = GetDynFromName(contentname,"contentname",STRINGT,-1,-1,
		"StaticTextViewer",viewername,TRUE);
	if(dobj == NULL)
	{
		return NULL;
	}
	thisApp->DynamicDataP->getDataObjectContent(contentname,rows,cols,label);
	StaticTextViewer *view = new StaticTextViewer;
	view->Create(m_parentAsWindow,wxXmlResource::GetXRCID(viewername),label[0]);
	//view->content = &(thisApp->DynamicDataP->getDataObjectValue(contentname));
	view->content = dobj;
	KludgeView = view;
	CreateChildren(view);

	vector<wxString> viewerdata;
	viewerdata.push_back(contentname);

	if(actionstring != "")
	{
		view->actionstring = actionstring;
	}

	dobj = GetDynFromName(actionname,"actionname",STRINGT,-1,-1,
		"StaticTextViewer",viewername,FALSE);
	if(dobj != NULL)
	{
		view->action = dobj;
		viewerdata.push_back(actionname);
	}

	view->hidecommand = GetBool("hidecommand",0);
	view->hideoutput = GetBool("hideoutput",0);
	if(HasParam("font"))
	{
		view->SetFont(GetFont());
	}
	thisApp->DynamicDataP->addViewer(viewername,(Viewer*) view);
	thisApp->DynamicDataP->setViewerData(viewerdata,viewername);
    
	return view;
}

bool StaticTextViewerXmlHandler::CanHandle(wxXmlNode *node)
{
    return IsOfClass(node, wxT("StaticTextViewer"));
}




