/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 5.01 or later
*(C)*
*(C)* Copyright (c) 2000-2005 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*                                                                 ^F
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/


#include "../globals.h"

#include "../mvIface.h"

#include "../mvIo.h"

#ifdef SKEL_CARAPACE
#include "cpcinterface.h"
#endif

/*
  Routine to set menus in CARAPACE versions
*/

Symbolhandle    alert(Symbolhandle list)
{
	Symbolhandle    symhString;
	long            nargs = NARGS(list);
	char           *message;
	WHERE("alert");
	
	*OUTSTR = '\0';

	if (nargs != 1)
	{
		badNargs(FUNCNAME, 1);
		goto errorExit;
	}

	symhString = COMPVALUE(list,0);

	message = (char *) 0;
	if (symhString == EmptyArgument || !isCharOrString(symhString) ||
		*(message = STRINGPTR(symhString)) == 0)
	{
		notCharOrString("message");
		goto errorExit;
	}
	
	myAlert(message);
	
	return (NULLSYMBOL);

  errorExit:
	putErrorOUTSTR();
	return (0);
	
} 


