/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 5.00 or later
*(C)*
*(C)* Copyright (c) 2004 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/


#include "../globals.h"

#include "../mvIface.h"

#include "../mvIo.h"

#ifdef SKEL_CARAPACE
#include "cpcinterface.h"
#endif


/*
  push a command onto CARAPACE command list
*/

Symbolhandle    pushcommand(Symbolhandle list)
{
	Symbolhandle    symhString;
	Symbolhandle	result = (Symbolhandle) 0;
	Symbolhandle	name,value;//whx
	long            nargs = NARGS(list);
	char           *command;
	char	       *charptr;
	long		N_objs,comblen,namelen,valuelen;

	WHERE("pushcommand");

	cpc_io          io;

	*OUTSTR = '\0';

	if (nargs != 1)
	{
		badNargs(FUNCNAME, 1);
		goto errorExit;
	}
	
	symhString = COMPVALUE(list,0);

	command = (char *) 0;
	if (symhString == EmptyArgument || !isCharOrString(symhString) ||
		*(command = STRINGPTR(symhString)) == 0)
	{
		notCharOrString("command");
		goto errorExit;
	}
	
        io.type = CPC_IO_PUSHCOMMAND;
        io.string = command;
	io.parm = 0; // show output
	io.length = 0; // show command
        cpc_doio(&io);
	
	return (NULLSYMBOL);

  errorExit:
	putErrorOUTSTR();
	return (0);
	
} 

