/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 5.01 or later
*(C)*
*(C)* Copyright (c) 2000-2005 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*                                                                 ^F
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#include <stdio.h>
extern        void fmyeol(FILE *fp);
extern        void putprompt(char *prompt);
extern        void myAlert(char *msgs);
extern        int mygetosversion(void);
extern        void fmyprint(char *msg,FILE *fp);
extern        char *expandFilename(char *fname);
extern        long okfilename(char *fname);
extern        long isfilename(char *fname);
extern        void fmyflush(FILE *fp);
extern        void mybeep(long n);
extern        FILE * fmyopen(char * fileName, char * mode);
extern        char * findFileByName(char * fileName, char * mode);
extern        int readFromMouse(double /*x*/ [], double /*y*/ [],
                                  int /*op*/, long * /*length*/);

extern        void cpcFree(void * ptr);
extern        void * cpcMalloc(size_t size);

/* unxhandl.c */
void **myFindHandle(void ** /*h*/);
void **myNewHandle(long /*n*/, long /*keepLocked*/);
void myDisposHandle(void **/*name*/);
void **mySetHandleSize(void **/*name*/, long /*newn*/, long /*keepLocked*/);
void **myDupHandle(void **/*name*/, long /*keepLocked*/);
long myValidHandle(void ** /*h*/);
long myGetHandleSize(void **/*h*/);
void myHLock(void **/*h*/);
void myHUnlock(void **/*h*/);
void *myNewPtr(long /*n*/);
void myDisposePtr(void */*p*/);
void setWarehouseLimits(long /*standard*/);
void myInitHandles(void);
void memoryUsage(char * /*where*/);

char **mygetscrap(void);
char *findPlotFile(plotKeyValuesPtr , char * );
void splitPathName(int /*nameOnly*/, char /*fullPathName*/ [],
                                   char /*pathPart*/ [], int /*partLength*/);
void closeBatch(long);


long okpathname(char *);



#define        mvFindFile cpcFindFile
#define        mvFindDir  cpcFindDir

 
typedef struct mvDirInfo
{
        char     dirName[CPCMAXPATHLENGTH + 1];
} mvDirInfo, *mvDirInfoPtr;

extern        char * cpcFindFile(char *, char *, char *, unsigned long, mvDirInfoPtr);
extern        char * cpcFindDir(char *, char *);
 

/*
  Access macros for mvDirInfo structure
  Prototypes:
        char *           getMvDirVolume(mvDirInfoPtr); **not defined**
        char *           getMvDirDirectory(mvDirInfoPtr);
        void             setMvDirVolume(mvDirInfoPtr, char *); **not defined**
        void             setMvDirDirectory(mvDirInfoPtr, char *);
        void             setMvDir(mvDirInfoPtr, mvDirInfoPtr);
*/
 
#define getMvDirDirectory(PTR)   ((PTR)->dirName)
#define setMvDirDirectory(PTR, DIR) \
        (strncpy((PTR)->dirName, DIR, CPCMAXPATHLENGTH),\
         (PTR)->dirName[CPCMAXPATHLENGTH] = '\0')
#define setMvDir(PTR1, PTR2) setMvDirDirectory(PTR1, getMvDirDirectory(PTR2))
 
typedef struct mvFileInfo
{
        mvDirInfo        dirInfo;
        char             fileName[CPCMAXPATHLENGTH+1];
} mvFileInfo, *mvFileInfoPtr;

/*
  Access macros for mvFileInfo structure
  Prototypes:
        mvDirInfoPtr     getMvFileDirInfo(mvFileInfoPtr);
        char *           getMvFileVolume(mvFileInfoPtr); **not defined**
        char *           getMvFileDirectory(mvFileInfoPtr);
        char *           getMvFileName(mvFileInfoPtr);
        void             setMvFileDirInfo(mvFileInfoPtr, mvDirInfoPtr);
        void             setMvFileVolume(mvFileInfoPtr, char *); **not defined**
        void             setMvFileDirectory(mvFileInfoPtr, char *);
        void             setMvFileName(mvFileInfoPtr, char *);
        void             setMvFile(mvFileInfoPtr, mvFileInfoPtr);
*/
#define getMvFileDirInfo(PTR)       (&((PTR)->dirInfo))
#define getMvFileDirectory(PTR)     ((PTR)->dirInfo.dirName)
#define getMvFileName(PTR)          ((PTR)->fileName)
 
#define setMvFileDirInfo(PTR1, PTR2) (setMvDir(&(PTR1)->dirInfo, PTR2))
#define setMvFileDirectory(PTR, DIR) (setMvDirDirectory(PTR->dirInfo, DIR))
#define setMvFileName(PTR, NAME)   (strncpy((PTR)->fileName, NAME, PATHSIZE),\
                (PTR)->fileName[PATHSIZE] = '\0')
#define setMvFile(PTR1, PTR2)           (setMvDir(&PTR1->dirInfo, &PTR2->dirInfo),\
									 setMvFileName(PTR1, getMVFileName(PTR2)))

enum volumeCodes
{
        keepVol,   /* goes with save(), asciisave() */
        restoreVol,
        spoolVol,
        batchVol,
        readVol,
        printVol,
        windowVol,   /* goes with Open and Save Window */
        helpVol,
        plotVol,
        dynloadVol,
        homeVol,
        currentVol,  /*Current directory*/
        lastVol,     /*most recently used by mvFindFile()*/
        nVolumeCodes
};
 
/*
        Following intialized as an array of length nVolumeCodes
        in initializeGlobals() in macMain.c
*/
EXTERN mvDirInfoPtr    MvDirectories INIT((mvDirInfoPtr) 0);

 
/*
  Access macros for MvDirectories (taken from macIface.h; will need to
  be modified for use with wx
  Prototypes
    void               setMvVolID(int, Integer);
        void               setMvDirID(int, LongInt);
        void               setMvDirInfo(int, char *);
        void               copyMvDirInfo(int, mvDirInfoPointer);
        mvDirInfoPointer   getMvDirInfo(int);
        Integer            getMvVolID(int);
        LongInt            getMvDirID(int);
        int                isMvDirInfoSet(int);
*/
 
#define getMvDirInfo(I)       (&MvDirectories[I])
#define setMvDirInfo(I, V)    strcpy(getMvDirInfo(I)->dirName, V)
#define copyMvDirInfo(I, PTR) strcpy(getMvDirInfo(I)->dirName, (PTR)->dirName)
#define isMvDirInfoSet(I)     (getMvDirInfo(I)->dirName[0] != '\0')
