/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 5.00 or later
*(C)*
*(C)* Copyright (c) 2004 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/


#include "../globals.h"

#include "../mvIface.h"

#include "../mvIo.h"

#ifdef SKEL_CARAPACE
#include "cpcinterface.h"
#endif

/*
  Routine to set modaldialogs in CARAPACE versions
*/

Symbolhandle    setmdialog(Symbolhandle list)
{
	Symbolhandle    symhString;
	Symbolhandle	result = (Symbolhandle) 0;
	Symbolhandle	name,value;//whx
	long            nargs = NARGS(list);
	char           *resource;
	char           *modaldialogName;
	char	       *result_str;
	char	       *charptr;
	long		N_objs,comblen,namelen,valuelen;

	WHERE("setmdialog");

	cpc_io          io;

	*OUTSTR = '\0';

	if ((nargs != 2)&&(nargs != 3))
	{
		badNargs(FUNCNAME, 2);
		goto errorExit;
	}
	
	symhString = COMPVALUE(list,0);

	resource = (char *) 0;
	if (symhString == EmptyArgument || !isCharOrString(symhString) ||
		*(resource = STRINGPTR(symhString)) == 0)
	{
		notCharOrString("resource");
		goto errorExit;
	}
	
	symhString = COMPVALUE(list,1);

	modaldialogName = (char *) 0;
	if (symhString == EmptyArgument || !isCharOrString(symhString) ||
		*(modaldialogName = STRINGPTR(symhString)) == 0)
	{
		notCharOrString("modal dialog name");
		goto errorExit;
	}
	
	if(!resource || !modaldialogName)
	{
		sprintf(OUTSTR,"ERROR: resource and modal dialog names must be CHAR in %s()",
				FUNCNAME);
		goto errorExit;
	}
	
        io.type = CPC_MDLG_SETUPUSERMDLGS;
	io.parm = -1; // use the RunningFrame
        io.string = resource;
        io.string2 = modaldialogName;
        cpc_doDialogs(&io);
	
	io.type = CPC_MDLG_GETLASTMDLGOUTPUTLENGTH;
	io.parm = -1; // use the RunningFrame
 	cpc_doDialogs(&io);
	N_objs=io.type; // number of objects

	if(N_objs == 0)
	{
		return(NULLSYMBOL);
	}
	
	// 2*number of elements + length of names + length of values
	comblen= 2*io.type + io.length + io.parm; 
	namelen = io.type + io.length;
	valuelen = io.type + io.parm;

	TMPHANDLE = mygethandle(comblen + 10); // 10 just for safety

	if (TMPHANDLE == (char **) 0)
	{
		goto errorExit;
	}
	io.type = CPC_MDLG_GETLASTMDLGOUTPUT;
	io.parm = -1; // use the RunningFrame
	io.string = *TMPHANDLE;
	cpc_doDialogs(&io);
	result_str=*TMPHANDLE;
			
	result = StrucInstall(SCRATCH, 2);

	name=Makechar(namelen);
	setNDIMS(name,1);
	setDIM(name,1,N_objs);
	setNAME(name,"names");
		
	charptr=STRINGPTR(name);
	{long i;
		for (i=0;i<N_objs;i++)
		{
			strcpy(charptr,result_str);
			result_str = skipStrings(result_str, 1);
			charptr = skipStrings(charptr, 1);
		}
	}	
	COMPVALUE(result,0)=name;
	
	value=Makechar(valuelen);
	setNDIMS(value,1);
	setDIM(value,1,N_objs);
	setNAME(value,"values");

	charptr=STRINGPTR(value);
	{long i;
		for (i=0;i<N_objs;i++)
		{
			strcpy(charptr,result_str);
			result_str = skipStrings(result_str, 1);
			charptr = skipStrings(charptr, 1);
		}
	}	
	COMPVALUE(result,1)=value;
	
	
	return (result);

	return (NULLSYMBOL);

  errorExit:
	putErrorOUTSTR();
	return (0);
	
} 


/*
  Routine to set non-modaldialogs in CARAPACE versions
*/

Symbolhandle    setdialog(Symbolhandle list)
{
	Symbolhandle    symhString;
	Symbolhandle	result = (Symbolhandle) 0;
	Symbolhandle	name,value;//whx
	long            nargs = NARGS(list);
	char           *resource;
	char           *dialogName;
	char	       *result_str;
	char	       *charptr;
	long		N_objs,comblen,namelen,valuelen;

	WHERE("setdialog");

	cpc_io          io;

	*OUTSTR = '\0';

	if (nargs != 2)
	{
		badNargs(FUNCNAME, 2);
		goto errorExit;
	}
	
	symhString = COMPVALUE(list,0);

	resource = (char *) 0;
	if (symhString == EmptyArgument || !isCharOrString(symhString) ||
		*(resource = STRINGPTR(symhString)) == 0)
	{
		notCharOrString("resource");
		goto errorExit;
	}
	
	symhString = COMPVALUE(list,1);

	dialogName = (char *) 0;
	if (symhString == EmptyArgument || !isCharOrString(symhString) ||
		*(dialogName = STRINGPTR(symhString)) == 0)
	{
		notCharOrString("dialog name");
		goto errorExit;
	}
	
        io.type = CPC_DYN_SETUPDIALOG;
	io.parm = -1; // use the RunningFrame
        io.string = resource;
        io.string2 = dialogName;
        cpc_doDialogs(&io);
	
	return (NULLSYMBOL);

  errorExit:
	putErrorOUTSTR();
	return (0);
	
} 

