/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 5.01 or later
*(C)*
*(C)* Copyright (c) 2000-2005 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*                                                                 ^F
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/


#include "../globals.h"

#include "../mvIface.h"

#include "../mvIo.h"

#ifdef SKEL_CARAPACE
#include "cpcinterface.h"
#endif

/*
  Routine to set menus in CARAPACE versions
*/

Symbolhandle    setmenubar(Symbolhandle list)
{
	Symbolhandle    symhString;
	char          **spoolFileName;
	long            nargs = NARGS(list);
	char           *resource;
	char           *menuName;
	WHERE("setmenubar");
	
	cpc_io          io;
	
	*OUTSTR = '\0';

	if (nargs != 2)
	{
		badNargs(FUNCNAME, 2);
		goto errorExit;
	}

	symhString = COMPVALUE(list,0);

	resource = (char *) 0;
	if (symhString == EmptyArgument || !isCharOrString(symhString) ||
		*(resource = STRINGPTR(symhString)) == 0)
	{
		notCharOrString("resource");
		goto errorExit;
	}
	
	symhString = COMPVALUE(list,1);

	menuName = (char *) 0;
	if (symhString == EmptyArgument || !isCharOrString(symhString) ||
		*(menuName = STRINGPTR(symhString)) == 0)
	{
		notCharOrString("menu name");
		goto errorExit;
	}
	
	if(!resource || !menuName)
	{
		sprintf(OUTSTR,"ERROR: resource and menu names must be CHAR in %s()",
				FUNCNAME);
		goto errorExit;
	}

        io.type = CPC_MENU_SETUPUSERMENUS;
	io.parm = -1; // use the RunningFrame
        io.string = resource;
        io.string2 = menuName;
        cpc_usermenus(&io);

	
	return (NULLSYMBOL);

  errorExit:
	putErrorOUTSTR();
	return (0);
	
} 


Symbolhandle    getmenubar(Symbolhandle list)
{

	/* get the menu resource string from a window */

	Symbolhandle    result = (Symbolhandle) 0;
	long            nargs = NARGS(list);
	long            length, needed;
	char           *string;
	WHERE("getmenubar");

	cpc_io          io;


        io.type = CPC_MENU_GETMENURESOURCELENGTH;
	io.parm = -1;  /* use running frame */
        cpc_usermenus(&io);

	
	result = Install(SCRATCH,CHAR);

	if (result == (Symbolhandle) 0)
	{
		goto errorExit;
	}
	TMPHANDLE = mygethandle(io.length + 5);  /* why worry? */
	setSTRING(result, TMPHANDLE);
	if (TMPHANDLE == (char **) 0)
	{
		goto errorExit;
	}

	io.type = CPC_MENU_GETMENURESOURCE;
	io.parm = -1;
	io.length = io.length + 5;
	io.string = *TMPHANDLE;
	cpc_usermenus(&io);

	setNAME(result, SCRATCH);
	setTYPE(result, CHAR);
	setNDIMS(result,1);
	setDIM(result,1,1);
	return (result);

  errorExit:
	putErrorOUTSTR();
	Removesymbol(result);
	return (0);
} 

