# Makefile to install local versions of macanova

MVBIN=/APPS/macanova/bin
MVAUX=/APPS/macanova/auxfiles
#MVBIN=/HOME/faculty/kb/src/macanova/testmake/bin
#MVAUX=/HOME/faculty/kb/src/macanova/testmake/auxfiles
VERSION=4.13
MACANOVA=macanova
MACANOVAWX=macanovawx

INSTALLEDMACANOVA=$(MACANOVA)$(VERSION)
INSTALLEDMACANOVAWX=$(MACANOVAWX)$(VERSION)
INSTALLEDAUXFILES=$(MVAUX)

installmacanova: install.mk
	strip $(MACANOVA)
	cp $(MACANOVA) $(MVBIN)/$(INSTALLEDMACANOVA)
	cd $(MVBIN);rm -f $(MACANOVA);ln -s $(INSTALLEDMACANOVA) $(MACANOVA)
	
installmacanovawx: install.mk
	strip $(MACANOVAWX)
	cp $(MACANOVAWX) $(MVBIN)/$(INSTALLEDMACANOVAWX)
	cd $(MVBIN);rm -f $(MACANOVAWX);ln -s $(INSTALLEDMACANOVAWX) $(MACANOVAWX)
	
installbinaries: installmacanova installmacanovawx

MACROFILE=macanova.mac
INSTALLEDMACROFILE=macanova$(VERSION).mac
OTHERMACROFILES=arima.mac design.mac graphics.mac math.mac\
	mulvar.mac regress.mac tser.mac

HELPFILE=macanova.hlp
INSTALLEDHELPFILE=macanova$(VERSION).hlp
OTHERHELPFILES=design.hlp tser.hlp



installaux: install.mk
	cp $(HELPFILE) $(MVAUX)/$(INSTALLEDHELPFILE)
	cp $(OTHERHELPFILES) $(MVAUX)
	cd $(MVAUX); rm -f $(HELPFILE);ln -s $(INSTALLEDHELPFILE) $(HELPFILE)
	cp $(MACROFILE) $(MVAUX)/$(INSTALLEDMACROFILE)
	cp $(OTHERMACROFILES) $(MVAUX)
	cd $(MVAUX); rm -f $(MACROFILE); ln -s $(INSTALLEDMACROFILE) $(MACROFILE)
	
installall: installmacanova installmacanovawx installaux