/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 4.13 or later
*(C)*
*(C)* Copyright (c) 2003 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

/*
  971126 new file
  030708 moved label-related constant definitions from globdefs.h
*/

#ifndef LABELSH__

#define LABELSH__

/*
  Codes and constants related to labels
  030708 moved to labels.h from globdefs.h
*/

/*return values from checkLabelKey*/
#define LABELSOK        0x00000000UL
#define TOOMANYLABELS   0x00000001UL
#define TOOFEWLABELS    0x00000002UL
#define WRONGSIZELABELS 0x00000004UL
#define LABELSERROR     0x00000008UL
#define WRONGTYPEVECTOR 0x00000018UL
#define WRONGTYPECOMP   0x00000028UL

/*
   control codes for fixupMatlabels()
*/
#define USEROWLABELS    0x00000001UL
#define USECOLLABELS    0x00000002UL
#define USEBOTHLABELS   0x00000003UL /*USEROWLABELS | USECOLLABELS*/


/*
  Prototypes (also in matProto.h)
*/

void getAllLabels(Symbolhandle /*arg*/, char * /*labels*/ [],
			   long /*lengths*/ [], long /*widths*/ []);
char * getOneLabel(Symbolhandle /*symh*/, long /*dimension*/, long /*index*/);
void getMatLabels(Symbolhandle /*arg*/, char * /*rowcol*/ [2],
				  long /*lengths*/ [2]);
char **createLabels(long /*ndims*/, long /*lengths*/ []);
void buildLabels(char ** /*labelsH*/, char * /*labels*/ [], long /*dims*/ [],
				 long /*ndims*/);
char ** growLabels(char ** /*oldlabels*/, long /*length*/);
long expandLabels(char * /*root*/, long /*n*/, char * /*labels*/);
long moveMatLabels(Symbolhandle /*from*/, Symbolhandle /*to*/,
				   unsigned long /*control*/);
long fixupMatLabels(Symbolhandle /*symh*/, unsigned long /*control*/);
long transferLabels(Symbolhandle /*from*/, Symbolhandle /*to*/);
void appendLabels(Symbolhandle /*symh*/, char * /*newLabels*/, long /*jdim*/,
				  long /*expand*/);
void appendNLabels(Symbolhandle /*symh*/, char * /*newLabels*/, long /*jdim*/,
				   long /*startIndex*/, long /*nlabels*/);
long installLabels(Symbolhandle /*symhLabels*/, Symbolhandle /*result*/);
unsigned long checkLabels(Symbolhandle /*symhLabels*/, long /*ndims*/,
						  long /*dims*/ []);
long anyLabels(Symbolhandle /*symh*/);
long sizeOfLabels(Symbolhandle /*symh*/);
long prepPrintLabels(Symbolhandle /*symh*/,
					    char * /*dimLabels*/ [], long /*dimLabelsWidth*/ []);
void putColumnLabels(FILE * /*fp*/, long /*lastdim*/, char * /*labels*/,
					 long /*labelWidth*/, long /*fieldWidth*/,
					 long /*nperLine*/, long /*type*/);
void putRowLabels(FILE * /*fp*/, long /*ndims*/, long /*coord*/ [],
				  long /*labelWidth*/, char * /*labels*/ [],
				  long * /*labelsWidth*/, long /*charData*/);

enum expandCodes
{
	dontExpand = 0,
	doExpand,
	padExpand
};

#endif /*LABELSH__*/
