/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 4.13 or later
*(C)*
*(C)* Copyright (c) 2003 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/
#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"




/*
  Main parser for macanova by G. Oehlert, as modifed by C. Bingham
*/

/*
	Version of 920623 made many changes, here and in yylex.c and Symbol.c
	All names are returned by yylex as VAR unless they are BLTINs or MACROs
	followed by '('.  Thus the parser should never see STRUC, UNDEF, and should
	never see MACRO or BLTIN or BATCH unless followed by '('
	The number of shift/reduce conflicts has been reduced to 13

	930201 Added 'break n' functionality which also is associated with token
	BREAK, and modified yylex so that 'breakall' is equivalent to
	'break WDEPTH'.  When n is a literal positive integer, 'break n' results
	in macanova	breaking out of exactly n enclosing loops.

	930208 Added a[..][..] capability, now 17 shift/reduce errors

	930804 Added operators <-+ <-- <-*, <-/, <-^, <-%%; 23 shift/reduce errors

	931007 Added lines to make use of batch() as an expression illegal.

	931103 Added error checking for left side of <-+, <--, etc; 47 S/R errors

	931110 Communication with Ifsetup() now by return value rather than global

	931228 Found that mainpars.c as directly produced was too large for the
           Mac MPW compiler.  Accordingly, rearranged various cases and used
		   more gotos, to maximize the length of sequences of case statements
           with identical code that could be folded into one another by
           editing of mainpars.c for use on the Macintosh.  The first case
           of a set of, say 3, cases to be folded has a comment of the
		   form 'Mac: fold 3 cases'. Script mainpars.awk for awk uses this
		   to create mainpars.c.mac.new.  This also has the parser tables
		   edited out and put into file mainpars.r.mac.new in a form readable
		   by MPW resource compiler Rez.

		   Note: Some of the folded cases are not identical in mainpars.y, but
		   are translated into identical code by Yacc.  Conversely, some
		   cases that appear to be identical in mainpars.y are translated
		   by Yacc in different ways.
	
	940110 Fixed bug in byname BATCH parenlist

	940119 Found and fixed bug.  yyparse() was telling yylex() to send an
	unnecessary (and harmful) ';' after if(l){..}else{...} and after
	while(l){...} .

	940331 Added bitwise operations BITAND, BITXOR, BITOR, and BITNOT

	940411 Added line to add component ASSIGN  to definition of 'assign',
	in order to generate useful error message.
	Now 48 shift/reduce conflicts

	940630 Implemented if{...}elseif{...}...elseif{...}else{...}
	Now 49 shift/reduce

	941108 Changed precedence of '!' to be lower than EQ, NE, etc

	950207 Added type NULLSYM

	950215 Changed precedence of MATMULT, TRMATMULT, and MATMULTTR to bind
    more tightly than MULT, DIV, and MOD

	950217 New syntax element cmpstatement
	Now 48 shift/reduce

	950411 Fixed bug in elseif ({...} not skipped on F

	950413 Introduced macros SetBreakTarget, SetNextChar, SkipBracketBlock
	and SkipParenBlock for setting YYLEXMESSAGE

	950710 Added parserCopy() to fix bug in interpreting things like
    {b <- 1} + {b <- 2}

	950711 Modified binary operations to apply parserCopy to left-hand operand
	to ensure that, for example, 'b<- 2;b + (b<-3)' has value 5, not 6
	Now 67 shift reduce, all the new ones arising from things like
	expr '+' batch; see definition of badbatch

	950722 Restricted use of parserCopy to eliminate buildup of scratch
	variables.  {b<-1}+{b<-2} again will give the wrong answer.  However,
	if the {...} is really an expanded macro it will give the right answer
	This can still result in the buildup of scratch if the value of a
	macro is not assigned.  Hence, guidelines should suggest that
	macros not returning a value should end with ';;'.  Specifically
	use of parserCopy() was removed at cmpdstatement and added at
	expandedmacro.  Also, parserCopy() no longer copies null variables.

	950724 Added macrobody ('{' '#' cmpdline '}') after modifying 
	Macrosetup() to insert "{#)#macroname" before body of macro and
	changed yylex() to return '#' after an '{' starting string "{#)#"

	950725 Fixed parser error introduced by change of 950711 by eliminating
	many cases of badbatch.  Instead, each left side of a binary operation
	increases global BATCHBLOCKCOUNT by 1 and each right side decreases it.
	If yylex() would otherwise return BATCH when BATCHBLOCKCOUNT > 0, it
	uses yyerror() to print an error message and returns BADTOKEN, instead.
	The number of shift/reduce conflicts went back to 48.

	950804 Added token SEMI1 to represent ';' or newline not immediately
	followed by '}' when BRACKETLEV > 0.  If SEMI1 follows an expression
	or an assignment whose value is a scratch variable, the scratch variable
	is removed so as to control the build up of scratch variables.
	Now 49 S/R conflicts.

	950807 Added check for BLTIN and LIST to parserCopy()
	950808 Added defines for use in Assign()
	950818 Removed END as expr, added END ENDOFL as line (49 S/R conflicts)
	       Changed setupfakefor() to setupfaketokens() and use it for
           repeating while loop, too.
		   Changes made in yylex1() so that syntax elements can be used
		   as keywords and structure component names.

	951130 Added macrobody bracklist to possibilities for subscripted.
	       Now 50 shift/reduce conflicts

	960226 Added operators %/% (MATDIV) and %\% (DIVMAT) at the same level
           of precedence as %*%, %c%, and %C%

	960620 Added check to keep from printing "invisible" symbols (names
           with '_' or '@_'

	961003 Added transpexpr and removed expr   '\'' from from expr1 list
           and then allowed transpexpr bracklist as choice for subscripted
           Now 51 shift/reduce

	961102 Changed POW from left associativity to right.

	961102 Added transfers to setScrName2 at macrobody and expandedmacro
           so that scratch name would be set appropriately.

	961204 Added macro clearNproducts() where appropriate

	970305 Resetting of NLINES taken out of cleanitup

	970324 Modified parser so that '()' is equivalent to NULL except
           after function or macro names. '()' is recognized as a
           nullexpr which is shifted to an expression.

    970611 MDEPTH incremented by yylex() on seeing macro header; parser
           decrements MDEPTH after recognizing macrobody
           doParserCopy() now copies non-scratch invisible variables to
           scratch invisible variables.

    970619 parser is expected to be re-entrant (mainpars.c is post-processed
           by mainpars.sed)
           New tokens INLINEHEAD, OUTLINEHEAD, EVALHEAD signal expanded
           in-line macro, expanded out-of-line macro and evalation string.
		   Uses new global PARSERVALUE to communicate value of evaluated string

    970625 eliminated 1 case each from bracklist ('[' completelist) and
           from brack2list (LEFTBRACK2 expr).
           Now 40 shift/reduce

    970714 added check of new global EVALDEPTH in runCommand() avoid
           unloading a segment that is might be in use
           All types (including MACRO and BLTIN) now defined in globdefs.h
           with new tokens MACROTOKEN and BLTINTOKEN introduced here
           and in yylex().

    971210 changed code to process transpexpr to use runCommand
    971215 Fixed memory leak; now a scratch brack2list is deleted in
           pattern  expr brack2list
           Also added tests so that Unscratch() is not called except
           at INPUTLEVEL 0
           Also made str[[]] syntactically legal with (Symbolhandle) 0
           value so that Extract() can issue an appropriate error message

    980131 Now aborts when batch() finds an error in setting things up.
           Avoids occasional confusing error messages.

    980220 Made change to go with change in Ifsetup() so that for(i,NULL){...}
           just skips compound statement.  Ifsetup() signals NULL by
           returning -1.

    980220 Added new token NEXTREP to implement new syntax element 'next';
           'next' or 'next m' behave the same as 'break' or 'break n'
           except that the target loop is not terminated.
           Still 40 shift/reduce

    990204 Added PopMacroName() and modified cleanitup() to clean up stack
           of macro names

    990420 Fixed bug in cleanitup() leading to an error on the command
           following the termination by an error of an out-of-line macro
           enclosed in {..}

    990705 Changed PopMacroName to PopMacroInfo; also cosmetic changes

	990711 Added new token EXITMACRO to implement new syntax element 'return'
	       In a macro, 'return(expr)' should skip to end of macro, setting
	       its value to expr.  {... 'return;} should skip to end of macro
		   setting its value to NULL
           Still 40 shift/reduce

	991103 Added new element listelement as union of expr and keyword
	       Still 40 shift/reduce

	000127 Fixed memory leak in <<expr>> when expr was a scratch variable

    000202 Made change to plug another memory leak

    000427 Made some static variables automatic and made changes to
           accomodate post-processing of output produced by Berkeley yacc
           (YYBYACC defined)

    000504 Changed name of PARSEMACROARGS to PARSEARGS since it now is
           used in parsing the arguments of functions whose arguments
           are to be transformed to strings like macro arguments.
           PARSEARGSS is now set by <<funcname>>()
           Added new terminal function, combining BLTINTOKEN and byname
           BLTINTOKEN

    000510 Initialize bynameType to 1 in call to Byname()
	001025 Include mvIo.h and clean up LINE in cleanitup()
	001028 Cleanup DlogLineBuffer in cleanitup()
	010617 cleanitup() clears new global RUNNINGHELP and mvhelp.h is now
           included
    010810 ClearSyntaxGlobals clears SQBRACKETLEV
	010811 yyerror() gives macro trace back under control of option 'traceback'
	010825 Replaced (Symbolhandle) 0 by SymbolZero or SymbolError
	020321 cleanitup() now clears model information stack
    020702 Modified so that var[[j]] <- rhs and var$compname <- rhs are legal
    020703 expandedmacro is now an expr but not an expr1
           component now includes component '$' compname
           now 41 shift/reduce
    020709 Further modifed so that var$a$b...$z <- x, var[[1]][[2]]...[[J]]
           or any mixed specification is legal
		   now 42 shift/reduce
    020712 Error Str$a[j] <- x or Str[[i]][j] <- x diagnosed;
           now 43 shift/reduce
    030913 Removed declarartions and definitions of various variables
           and constants used in communicating with yylex(), Macrosetup(),
           Assign(), Subassign(), ...  They are now in mvParse.h which is
           included
    031105 Fixed bug by checking return value of Extract() when extracting
           a structure component
    031214 Fixed potential memory leak in str$a <- RHS

VERSION: 031214   This date is used by mainpars.awk in making macMainpars.r
	
	byacc output modified by mainpars.sed.byacc

*/
#define MAINPARS_Y

#include "globals.h"

#ifdef NOSTDLIBH
char     *getenv (const char *name);
#endif /*NOSTDLIBH*/

#include "mvParse.h"
#include "mvhelp.h"
#if defined(MACINTOSH) || defined(WXWIN)
#include "mvIo.h"
#endif /*MACINTOSH || WXWIN*/

#ifdef MACINTOSH

#ifndef MACIFACEH__
#include "macIface.h"
#endif /*MACIFACEH__*/

#ifdef SEGMENTED
#if defined(MPW) || defined(MW_CW)
#pragma segment Mainpars
#endif /*MPW||MW_CW*/
#endif /*SEGMENTED*/


#define CHECKINTERRUPT	if(INTERRUPT != INTNOTSET) YYERROR

#else /*MACINTOSH*/

#define CHECKINTERRUPT

#endif /*MACINTOSH*/

#define BlockBatch()            (BATCHBLOCKCOUNT++)
#define UnBlockBatch()          (BATCHBLOCKCOUNT--)
#define SkipBracketBlock()      (YYLEXMESSAGE = SKIPBRACKETBLOCK)
#define SkipParenBlock()        (YYLEXMESSAGE = SKIPPARENBLOCK)
#define SetNextChar(C)          (YYLEXMESSAGE = (- (long) (C)))
#define SetBreakTarget(Level)   (YYLEXMESSAGE = \
							     MAXWDEPTH + WHILEBRACKETLEV[Level] + 1)
#define SetNextTarget(Level)    SetBreakTarget(Level)
#define SetReturnTarget(BrLevel) (YYLEXMESSAGE = MAXWDEPTH + BrLevel)

/* the following macros are referenced only by cleanitup() */
#define ClearYylexGlobals()     (BATCHBLOCKCOUNT = 0,\
								 PARSEARGS = 0,\
								 ALTTOKENPTR = (int *) 0,\
                                 ALTINPUTTOKENS[0] = 0,\
								 YYLEXMESSAGE = 0,\
                                 LASTCH = '\0')

#define ClearSyntaxGlobals()    (BRACKETLEV = 0,\
								 PARENLEV = 0,\
                                 SQBRACKETLEV = 0,\
								 MDEPTH = 0,\
								 WDEPTH = 0,\
								 IDEPTH = 0,\
								 MLEVEL = MAXMDEPTH+1)

#define YYSTYPE Symbolhandle 	/* handle to symbol */
#define YYDEBUG 1

#ifdef MACINTOSH
/*
  Set to point to various yacc tables that are normally included in
  mainpars.c
*/
#ifndef YYBYACC
/*
  Pointers to tables produced by HPUX and DEC yacc
*/
extern short *Pyyexca;
extern short *Pyyact;
extern short *Pyypact;
extern short *Pyypgo;
extern short *Pyyr1;
extern short *Pyyr2;
extern short *Pyychk;
extern short *Pyydef;
#else /*YYBYACC*/
/*
  Pointers to tables produced by byacc (Berkeley yacc)
*/
extern short *Pyylhs;
extern short *Pyylen;
extern short *Pyydefred;
extern short *Pyydgoto;
extern short *Pyysindex;
extern short *Pyyrindex;
extern short *Pyygindex;
extern short *Pyytable;
extern short *Pyycheck;
#endif /*YYBYACC*/
#endif /*MACINTOSH*/

/*
  Variables for communicating among different actions

  They may be inserted as local variables by post-yacc processing by
  mainpars.sed
*/
#if (0) /*These are now local variables*/
static long         ParseArgs; /*formerly ParseMacroArgs*/
static int          Op, AssignOp;
#endif /*0*/

#if (0)
static WHERE("yyparse"); /*now added as local variable by mainpars.sed*/
#endif /*0*/

/*
  030913 globals PARSEARGS, YYLEXMESSAGE, LASTCH, BATCHBLOCKCOUNT,
         ALTINPUTTOKENS[], ALTTOKENPTR for communicating with
         yylex() are now in mvParse.h
*/

/*
   End of MacAnova Code before parser instructions
*/

#define MACROTOKEN 257
#define BLTINTOKEN 258
#define NUMBER 259
#define VAR 260
#define END 261
#define IF 262
#define ELSE 263
#define ELSEIF 264
#define WHILE 265
#define FOR 266
#define BREAK 267
#define BREAKALL 268
#define NEXTREP 269
#define EXITMACRO 270
#define BATCH 271
#define ERROR 272
#define FATALERROR 273
#define BADTOKEN 274
#define LEFTANGLE 275
#define RIGHTANGLE 276
#define LEFTBRACK2 277
#define RIGHTBRACK2 278
#define MULT 279
#define ADD 280
#define DIV 281
#define MOD 282
#define SUB 283
#define EXP 284
#define GE 285
#define LE 286
#define GT 287
#define LT 288
#define EQ 289
#define NE 290
#define AND 291
#define OR 292
#define NOT 293
#define ENDOFL 294
#define POW 295
#define MATMULT 296
#define TRMATMULT 297
#define MATMULTTR 298
#define MATDIV 299
#define DIVMAT 300
#define BITAND 301
#define BITXOR 302
#define BITOR 303
#define BITNOT 304
#define SEMI1 305
#define INLINEHEAD 306
#define OUTLINEHEAD 307
#define EVALHEAD 308
#define ASSIGN 309
#define ASSIGN1 310
#define ASSIGNMULT 311
#define ASSIGNADD 312
#define ASSIGNDIV 313
#define ASSIGNSUB 314
#define ASSIGNPOW 315
#define ASSIGNMOD 316
#define UNARYMINUS 317
#define YYERRCODE 256
/* Deleted definition of short yylhs[] */
/* Deleted definition of short yylen[] */
/* Deleted definition of short yydefred[] */
/* Deleted definition of short yydgoto[] */
/* Deleted definition of short yysindex[] */
/* Deleted definition of short yyrindex[] */
/* Deleted definition of short yygindex[] */
#define YYTABLESIZE 6256
/* Deleted definition of short yytable[] */
/* Deleted definition of short yycheck[] */
#define YYFINAL 25
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 317
#if YYDEBUG
static char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,"'$'",0,"'&'","'\\''","'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,
0,0,0,0,0,0,0,0,0,"';'","'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"'{'","'|'","'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"MACROTOKEN","BLTINTOKEN",
"NUMBER","VAR","END","IF","ELSE","ELSEIF","WHILE","FOR","BREAK","BREAKALL",
"NEXTREP","EXITMACRO","BATCH","ERROR","FATALERROR","BADTOKEN","LEFTANGLE",
"RIGHTANGLE","LEFTBRACK2","RIGHTBRACK2","MULT","ADD","DIV","MOD","SUB","EXP",
"GE","LE","GT","LT","EQ","NE","AND","OR","NOT","ENDOFL","POW","MATMULT",
"TRMATMULT","MATMULTTR","MATDIV","DIVMAT","BITAND","BITXOR","BITOR","BITNOT",
"SEMI1","INLINEHEAD","OUTLINEHEAD","EVALHEAD","ASSIGN","ASSIGN1","ASSIGNMULT",
"ASSIGNADD","ASSIGNDIV","ASSIGNSUB","ASSIGNPOW","ASSIGNMOD","UNARYMINUS",
};
static char *yyrule[] = {
"$accept : cmpdline",
"cmpdline : cmpdnobreak",
"cmpdline : cmpdbreak",
"cmpdnobreak : line",
"cmpdnobreak : cmpdnobreak line",
"cmpdbreak : break",
"cmpdbreak : cmpdnobreak break",
"cmpdstatement : '{' cmpdline '}'",
"evaluatedstring : '{' EVALHEAD cmpdline '}'",
"macrobody : '{' INLINEHEAD cmpdline '}'",
"macrobody : '{' OUTLINEHEAD cmpdline '}'",
"line : ENDOFL",
"line : SEMI1",
"line : ';'",
"line : assgn ENDOFL",
"line : assgn ';'",
"line : assgn SEMI1",
"line : batch ENDOFL",
"line : batch SEMI1",
"line : batch ';'",
"line : evaluatedstring ENDOFL",
"line : expr ENDOFL",
"line : expr ';'",
"line : expr SEMI1",
"line : badbatch",
"line : expr ERROR",
"line : ERROR",
"line : error",
"line : END ENDOFL",
"$$1 :",
"break : BREAK $$1 ';'",
"$$2 :",
"break : NEXTREP $$2 ';'",
"$$3 :",
"break : EXITMACRO '(' ')' $$3 ';'",
"$$4 :",
"break : EXITMACRO '(' expr ')' $$4 ';'",
"$$5 :",
"assgn : expr1 ASSIGN $$5 expr",
"$$6 :",
"assgn : component ASSIGN $$6 expr",
"assgn : component bracklist ASSIGN",
"$$7 :",
"assgn : VAR bracklist ASSIGN $$7 expr",
"$$8 :",
"assgn : '(' expr ')' bracklist ASSIGN $$8 expr",
"$$9 :",
"assgn : functionvalue bracklist ASSIGN $$9 expr",
"$$10 :",
"assgn : byname VAR bracklist ASSIGN $$10 expr",
"assgn : expr1 ASSIGNADD expr",
"assgn : expr1 ASSIGNSUB expr",
"assgn : expr1 ASSIGNMULT expr",
"assgn : expr1 ASSIGNDIV expr",
"assgn : expr1 ASSIGNMOD expr",
"assgn : expr1 ASSIGNPOW expr",
"assgn : '(' expr ')' bracklist assignop",
"assgn : functionvalue bracklist assignop",
"assgn : byname VAR bracklist assignop",
"assgn : VAR bracklist assignop",
"assignop : ASSIGNADD",
"assignop : ASSIGNSUB",
"assignop : ASSIGNMULT",
"assignop : ASSIGNDIV",
"assignop : ASSIGNMOD",
"assignop : ASSIGNPOW",
"batch : BATCH parenlist",
"batch : byname BATCH parenlist",
"keyword : compname ASSIGN1 expr",
"function : BLTINTOKEN",
"function : byname BLTINTOKEN",
"functionvalue : function parenlist",
"component : expr '$' compname",
"component : component '$' compname",
"component : expr brack2list",
"component : component brack2list",
"transpexpr : expr '\\''",
"nullexpr : '(' ')'",
"expr1 : functionvalue",
"expr1 : missingrparen",
"expr1 : VAR",
"expr1 : byname VAR",
"expr1 : nullexpr",
"$$11 :",
"expr1 : expr '+' $$11 expr",
"$$12 :",
"expr1 : expr '-' $$12 expr",
"$$13 :",
"expr1 : expr '*' $$13 expr",
"$$14 :",
"expr1 : expr MATMULT $$14 expr",
"$$15 :",
"expr1 : expr TRMATMULT $$15 expr",
"$$16 :",
"expr1 : expr MATMULTTR $$16 expr",
"$$17 :",
"expr1 : expr MATDIV $$17 expr",
"$$18 :",
"expr1 : expr DIVMAT $$18 expr",
"$$19 :",
"expr1 : expr '/' $$19 expr",
"$$20 :",
"expr1 : expr MOD $$20 expr",
"$$21 :",
"expr1 : expr POW $$21 expr",
"$$22 :",
"expr1 : expr BITOR $$22 expr",
"$$23 :",
"expr1 : expr BITXOR $$23 expr",
"$$24 :",
"expr1 : expr BITAND $$24 expr",
"expr1 : '(' expr ')'",
"expr1 : '-' expr",
"expr1 : '+' expr",
"expr1 : BITNOT expr",
"$$25 :",
"expr1 : expr '=' $$25 expr",
"$$26 :",
"expr1 : expr EQ $$26 expr",
"$$27 :",
"expr1 : expr NE $$27 expr",
"$$28 :",
"expr1 : expr '<' $$28 expr",
"$$29 :",
"expr1 : expr LE $$29 expr",
"$$30 :",
"expr1 : expr '>' $$30 expr",
"$$31 :",
"expr1 : expr GE $$31 expr",
"$$32 :",
"expr1 : expr '&' $$32 expr",
"$$33 :",
"expr1 : expr AND $$33 expr",
"$$34 :",
"expr1 : expr '|' $$34 expr",
"$$35 :",
"expr1 : expr OR $$35 expr",
"expr1 : '!' expr",
"expr1 : transpexpr",
"$$36 :",
"expandedmacro : macro parenlist $$36 macrobody",
"missingrparen : '(' ENDOFL",
"missingrparen : '(' expr1 ENDOFL",
"missingrparen : '(' SEMI1",
"missingrparen : '(' ';'",
"missingrparen : '(' expr1 SEMI1",
"missingrparen : '(' expr1 ';'",
"expr : expr1",
"expr : component",
"expr : assgn",
"expr : ifstart",
"$$37 :",
"expr : ifstart ELSE $$37 cmpdstatement",
"$$38 :",
"expr : WHILE parenlist $$38 cmpdstatement",
"$$39 :",
"expr : FOR parenlist $$39 cmpdstatement",
"expr : expandedmacro",
"expr : cmpdstatement",
"expr : macrobody",
"expr : subscripted",
"expr : VAR '('",
"expr : FATALERROR",
"badbatch : '-' batch",
"badbatch : '+' batch",
"badbatch : '!' batch",
"badbatch : '(' batch",
"badbatch : batch '+'",
"badbatch : batch '-'",
"badbatch : batch '*'",
"badbatch : batch MATMULT",
"badbatch : batch TRMATMULT",
"badbatch : batch MATMULTTR",
"badbatch : batch MATDIV",
"badbatch : batch DIVMAT",
"badbatch : batch '/'",
"badbatch : batch MOD",
"badbatch : batch POW",
"badbatch : batch EQ",
"badbatch : batch NE",
"badbatch : batch '<'",
"badbatch : batch LE",
"badbatch : batch '>'",
"badbatch : batch GE",
"badbatch : batch '&'",
"badbatch : batch AND",
"badbatch : batch '|'",
"badbatch : batch OR",
"badbatch : batch '('",
"badbatch : batch '['",
"badbatch : batch '$'",
"badbatch : batch RIGHTBRACK2",
"badbatch : batch ASSIGN",
"subscripted : cmpdstatement bracklist",
"subscripted : '(' expr ')' bracklist",
"subscripted : component bracklist",
"subscripted : functionvalue bracklist",
"subscripted : expandedmacro bracklist",
"subscripted : macrobody bracklist",
"subscripted : VAR bracklist",
"subscripted : transpexpr bracklist",
"subscripted : subscripted bracklist",
"subscripted : byname VAR bracklist",
"$$40 :",
"ifstart : IF parenlist $$40 cmpdstatement",
"$$41 :",
"$$42 :",
"ifstart : ifstart ELSEIF $$41 parenlist $$42 cmpdstatement",
"ifstart : ifstart ERROR",
"macro : MACROTOKEN",
"macro : byname MACROTOKEN",
"compname : VAR",
"compname : byname VAR",
"byname : LEFTANGLE expr RIGHTANGLE",
"byname : LEFTANGLE expr",
"listelement : expr",
"listelement : keyword",
"list : ','",
"list : listelement ','",
"list : list listelement ','",
"list : list ','",
"completelist : listelement",
"completelist : list",
"completelist : list listelement",
"parenlist : '(' ')'",
"parenlist : '(' completelist ')'",
"parenlist : '(' completelist ENDOFL",
"parenlist : '(' completelist SEMI1",
"parenlist : '(' completelist ';'",
"parenlist : '(' ENDOFL",
"parenlist : '(' SEMI1",
"parenlist : '(' ';'",
"bracklist : '[' ']'",
"bracklist : '[' RIGHTBRACK2",
"bracklist : '[' completelist ']'",
"bracklist : '[' completelist RIGHTBRACK2",
"bracklist : '[' SEMI1",
"bracklist : '[' ';'",
"$$43 :",
"bracklist : '[' ENDOFL $$43 ERROR",
"brack2list : LEFTBRACK2 '[' expr RIGHTBRACK2 ']'",
"brack2list : LEFTBRACK2 '[' expr RIGHTBRACK2 RIGHTBRACK2",
"brack2list : LEFTBRACK2 '[' RIGHTBRACK2 ']'",
"brack2list : LEFTBRACK2 '[' SEMI1",
"brack2list : LEFTBRACK2 '[' ';'",
"brack2list : LEFTBRACK2 '[' ENDOFL",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
#if (0) /*inserted as local variables for re-entrancy by mainpars.sed*/
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
#endif /*0*/ /*yylval must be global*/
YYSTYPE yylval;
#if (0) /*inserted as local variables for re-entrancy by mainpars.sed*/
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#endif /*0*/
#define yystacksize YYSTACKSIZE
static int          SeenError = 0;
/*
  970619 modified output when INPUTLEVEL > 0
  990205 modified output when ACTIVEMACROS > 0
  010810 Added argument to inWhichMacro()
  010811 Added traceback under control of option traceback
*/
void yyerror(char * s)
{
	/*  output error message */
	unsigned char   c = '\0', *inputString = *INPUTSTRING;
	int             start = 0;
	int             iswarning = (strncmp(WarningStart, s, 8) == 0);
	WHERE("yyerror");

	if (!SeenError && (PRINTWARNINGS || !iswarning))
	{
		int          length = strlen(s);
		char         msg[70];

		msg[0] = '\0';
		
		myprint(s);

		if (INPUTLEVEL > 0 || ACTIVEMACROS == 1 || !TRACEBACK)
		{
			int         inEvaluate =
			  (INPUTLEVEL > 0 && istempname(ThisInputname));
		
			if (inEvaluate)
			{
				strcpy(msg, " in evaluation string");
			}
			if (!TRACEBACK || ACTIVEMACROS == 1)
			{
				strcpy(msg, inWhichMacro(0));
			}
		} /*if (INPUTLEVEL > 0 || ACTIVEMACROS > 0)*/
		
		strcat(msg, " near ");
		length += strlen(msg);
		myprint(msg);
		
		if(length + ISTRCHAR > SCREENWIDTH)
		{
			myeol();
		}
		
		if(ISTRCHAR > SCREENWIDTH && !(GUBED & 2))
		{
			start = ISTRCHAR - (SCREENWIDTH - 5);
			start = (start >= 0) ? start : 0;
			myprint(". . .");
		}

		c = inputString[ISTRCHAR];
		inputString[ISTRCHAR] = '\0';
		mymultiprint((char *) inputString + start, STDOUT, 1);
		inputString[ISTRCHAR] = c;
		if (TRACEBACK && ACTIVEMACROS > 1)
		{
			int          i;
			
			for (i = 0; i < ACTIVEMACROS; i++)
			{
				myprint(inWhichMacro(i));
				myeol();
			}
		}
		SeenError = !iswarning;
	} /*if (!SeenError && (PRINTWARNINGS || !iswarning))*/
	
	if(s == OUTSTR)
	{
		OUTSTR[0] = '\0';
	}
} /*yyerror()*/

/*
   tell yylex to report either ';for()' or ';while(' to parser
*/
static int fakefortokens[] = {(int) ';', FOR, (int) '(', (int) ')', 0 };
static int fakewhiletokens[] = {(int) ';', WHILE, (int) '(', 0 };

static void setupfaketokens(int which)
{
	int    i;
	int   *tokens = (which == FOR) ? fakefortokens : fakewhiletokens;
	WHERE("setupfaketokens");
	
	for(i=0;tokens[i];i++)
	{
		ALTINPUTTOKENS[i] = tokens[i];
	 }
	ALTINPUTTOKENS[i] = 0;
	ALTTOKENPTR = ALTINPUTTOKENS;
	ISTRCHAR = WHILESTARTS[WDEPTH-1];
	LASTCH = '\0';
} /*setupfaketokens()*/

static void notfunction(Symbolhandle symh)
{
	if(isscratch(NAME(symh)))
	{
		yyerror("ERROR: problem with input");
	}
	else
	{
		sprintf(OUTSTR,"ERROR: %s is not function or macro",NAME(symh));
		yyerror(OUTSTR);
	}
}

/*
   Clean up looping related globals
*/
static void cleanLoops(long level1, long level2)
{
	int      i;
	
	for(i=level1;i<level2;i++)
	{
		WHILECONDITIONS[i] = 0;
		WHILELIMITS[i] = MAXWHILE;
		mydisphandle((char **) FORVECTORS[i]);
		FORVECTORS[i] = (double **) 0;
	}
} /*cleanLoops()*/

static Symbolhandle runCommand(Symbolhandle func, Symbolhandle list)
{
	Symbolhandle      result;
	Symbolhandle      (*f) (Symbolhandle) = FPTR(func);

	strcpy(FUNCNAME,NAME(func));
	OUTSTR[0] = '\0';
	clearNproducts();
	result = (*f)(list);

	clearNproducts();
#ifdef SEGMENTED
	if (f != elapsedTime && EVALDEPTH == 0)
	{
		UNLOADSEG(*f);
	}
#endif /*SEGMENTED*/
	Removelist(list);
	return (result);
} /*runCommand()*/

/*
  Function to start (add == 1) or add to list encapsulating structure
  component specification.

  When add == 0, symhStr is the putative structure (not checked here),
  BuildCompInfo returns LIST(symhStr, idType, symhID)
  where idType is a REAL scalar with value named (0 if component
  specified by [[J]], and 1 if specified by $name).

  When add != 0, symhStr is a component specification list.  
  depth = NCOMPS(symhStr) - 2 is the current nesting depth.  symhID is
  added to the list and COMPVALUE(symhStr, 1) increased by (2^depth)*named

  Thus COMPVALUE(result, 1) is a bit string encoded how each component
  is specified, by name (named != 0) or by number [[J]] (named == 0)
  New 020703

  020708 Modified to handle chains such as a$b$c, a[[1]]$b, ..
  
*/
enum buildCompInfoConstants
{
	startCompInfo   = 0,
	addCompInfo,
	namedComp,
	numberedComp
};

static Symbolhandle BuildCompInfo(Symbolhandle symhStr, Symbolhandle symhID,
								  int named, int doWhat)
{
	Symbolhandle              result, idType;
	double                    namedBit;
	int                       depth;

	if (doWhat == startCompInfo)
	{
		/* Start the list */
		result = Addlist(Makelist(), symhStr);

		if (result != SymbolError)
		{
			idType = Install(SCRATCH, SHORTREAL);

			if (idType == SymbolError)
			{
				goto errorExit;
			}
			result = Addlist(Growlist(result), idType);
			TMPHANDLE = mygethandle(sizeof(double));
			setDATA(idType, (double **) TMPHANDLE);

			if (TMPHANDLE == (char **) 0)
			{
				goto errorExit;
			}
			DATAVALUE(idType, 0) = 0.0;
		} /*if (result != SymbolError)*/
	}
	else
	{
		/* doWhat == addCompInfo*/
		idType = COMPVALUE(symhStr, 1);
		result = symhStr;
	}
	depth = NCOMPS(result) - 2;
	
	if (depth >= MAXDIMS)
	{
		yyerror("ERROR: too deep nesting of component specification");
		goto errorExit;
	}
	
	result = Addlist(Growlist(result), symhID);
	
	if (result == SymbolError)
	{
		goto errorExit;
	}

	namedBit = (double) ((named == namedComp) ? (1 << depth) : 0);
	
	DATAVALUE(idType, 0) += namedBit;

	return (result);

  errorExit:
	Removelist(result);
	return(SymbolError);

} /*BuildCompInfo()*/

/*
   If symh is a scratch symbol, return it; otherwise return a scratch
   copy of symh
   950907 removed all external calls from initial testing
*/

#if (0)  /* on HPPA use of macro lengthened code by 4K, slowed down*/
#define parserCopy(symh) ((symh == SymbolZero ||\
						  isscratch(NAME(symh)) || \
						  (Type__ = TYPE(symh), Type__ == UNDEF) ||\
						  Type__ == ASSIGNED ||	Type__ == BLTIN ||\
						  DIMVAL(symh, 1) == 0 || Type__ == LIST) ?\
							symh : doParserCopy(symh))
#endif /*0*/

#ifdef parserCopy
static long Type__;
#else /*parserCopy*/
#define doParserCopy  parserCopy
#endif /*parserCopy*/
/*
  970612 now copies non-scratch invisible symbols to invisible scratch
         symbols
*/
static Symbolhandle doParserCopy(Symbolhandle symh)
{
	Symbolhandle     symhCopy;
	long             type;
	
#ifndef parserCopy
	if (symh == SymbolZero || isscratch(NAME(symh)) ||
		(type = TYPE(symh)) == UNDEF || type == ASSIGNED ||
		type == BLTIN || DIMVAL(symh, 1) == 0 ||
		type == LIST )
	{
		return (symh);
	}
#else /*parserCopy*/
	type = TYPE(symh);
#endif /*parserCopy*/
	symhCopy = Makesymbol(type);
	if (symhCopy != SymbolError && Copy(symh, symhCopy))
	{
		setNAME(symhCopy, (invisname(NAME(symh))) ? INVISSCRATCH : SCRATCH);
		Addsymbol(symhCopy);
	} /*if (symhCopy != SymbolError && Copy(symh, symhCopy))*/
	else
	{
		/* couldn't  make copy; return original */
		Delete(symhCopy);
		symhCopy = symh;
	}
	return (symhCopy);
} /*doParserCopy()*/

/*
  Called from main before every invocation of getinput.
  It needs to be here because it resets PARSEARGS, ALTTOKENPTR, and
  ALTINPUTTOKENS which are defined only here and in yylex.c
  It also resets static variable SeenError
*/

/*
   950811 memoryUsage() moved to unxHandl.c and macHandle.c
   970305 cleanitup() no longer resets NLINES
   970619 resets PARSERVALUE and INPUTLEVEL
   970620 cleans out inputstrings from INPUTSTACK
   970714 pops input levels all the way down
   971125 clears new global RUNNINGGLM
   990204 resets new globals ACTIVEMACROS and MACROINFO
   990420 moved the popInputlevel() loop earlier in the function
   990824 added call to setEcho() when TEK is defined
   001025 added call to freeLINE() to dispose of LINE
   001027 dispose of DlogLineBuffer
   010617 clears new global RUNNINGHELP
   020320 empties stack of models unless GUBED & 8192 != 0
*/
void cleanitup(void)
{
	WHERE("cleanitup");

	if (GUBED & 4096)
	{
		memoryUsage(NAMEFORWHERE);
	}

	if (!(GUBED & 8192) && ModelStackDepth > 1)
	{
		/* clear out model information stack at prompt */
		doPopModelInfo(1);
	}
	
	/* Get back to prompt input level if necessary */
	while (INPUTLEVEL > 0)
	{
		popInputlevel();
	}

	SeenError = 0; /* flag for yyerror()*/

	Unscratch(); /* clears scratch symbol table (SCRATCH, keywords, UNDEF's)*/

	RemoveUndef(); /* clears ASSIGNED && temp variables from symbol table */

	cleanAssignedStack(); /*clears stack of pending assignments*/

	INTERRUPT = INTNOTSET;

	OUTSTR[0] = '\0';

	clearNproducts();
	
	if((ISATTY & ITTYIN) && BDEPTH == 0 && MAXERRORS == 0)
	{
		NERRORS = 0;
	}

	restoreFormat(); /* restore current default format */
	freeLINE();      /* release memory used by LINE */

#if defined(MACINTOSH) || defined(WXWIN)
	mydisphandle((char **) DlogLineBuffer); /*DlogLineBuffer used in fillFromDialog()*/
	DlogLineBuffer = (unsigned char **) 0;
	DlogLineBufferPlace = -1;
#endif /*MACINTOSH || WXWIN*/

	ClearYylexGlobals();
	ClearSyntaxGlobals();

	PARSERVALUE = SymbolZero;

	RUNNINGGLM = (char *) 0; /*means GLM function not running */
	RUNNINGHELP = (char *) 0; /*means help functions not running */
	
	/*
	  Clear out stack of macro info
	*/
	while (ACTIVEMACROS > 0)
	{
		ThisMacroName[0] = '\0';
		ACTIVEMACROS--;
	}
	
	/*
	  Dispose of inputStrings in INPUTSTACK
	*/
	cleanInputlevels(1);
	cleanLoops(0, MAXWDEPTH);

#ifdef TEK
#define ONECHO 1
	setEcho(ONECHO); /*in case of interrupt while reading Tek cross hairs*/
#endif /*TEK*/

#ifdef READLINE
	rlpauseCleanup();
#endif /*READLINE*/

} /*cleanitup()*/


#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
/*
  Variables yynerrs, yyerrflag, yychar, yyssp, yyvsp, yyval, yyss and yyvs are
  globals in byacc output;  they are inserted here by post-processing
  by mainpars.sed.byacc so to allow re-entrancy
*/
	int yynerrs;
	int yyerrflag;
	int yychar;
	short *yyssp;
	YYSTYPE *yyvsp;
	YYSTYPE yyval;
	short yyss[YYSTACKSIZE];
	YYSTYPE yyvs[YYSTACKSIZE];
/*ParseArgs, Op and AssignOp were formally static of file scope*/
	long         ParseArgs;
	int          Op, AssignOp;
#ifdef MACINTOSH
/* replacements for global arrays initialized from Macintosh resources*/
	register short *yylhs = Pyylhs;
	register short *yylen = Pyylen;
	register short *yydefred = Pyydefred;
	register short *yydgoto = Pyydgoto;
	register short *yysindex = Pyysindex;
	register short *yyrindex = Pyyrindex;
	register short *yygindex = Pyygindex;
	register short *yytable = Pyytable;
	register short *yycheck = Pyycheck;
#endif /*MACINTOSH*/
	WHERE("yyparse");
#if YYDEBUG
    register char *yys;

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            (sprintf(OUTSTR,"%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys), myprint(OUTSTR));
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            (sprintf(OUTSTR,"%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]), myprint(OUTSTR));
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("ERROR: problem with input");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    (sprintf(OUTSTR,"%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]), myprint(OUTSTR));
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    (sprintf(OUTSTR,"%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp), myprint(OUTSTR));
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            (sprintf(OUTSTR,"%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys), myprint(OUTSTR));
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        (sprintf(OUTSTR,"%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]), myprint(OUTSTR));
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
		/*Folding 6 cases into 1*/
case 2:
case 3:
case 4:
case 5:
case 6:
{yyval = yyvsp[0];}
break;
case 7:
{/*yylex ensures '}' preceded by ';'*/
									yyval = yyvsp[-1];
								}
break;
case 8:
{
		/*
		yylex returns EVALHEAD when it sees header of string being
		evaluated.
		*/
						yyval = parserCopy(yyvsp[-1]);
					}
break;
case 9:
{
		/*
		yylex returns INLINEHEAD when it sees header of inline macro
		It also increments MLEVEL.  On a macro expansion, this
		occurs after the macro is expanded.  Macroset() uses
		MLEVEL as the value of '$$'
		parserCopy() ensures the result is a scratch variable
		*/
						MLEVEL--;
						PopMacroInfo();

						yyval = parserCopy(yyvsp[-1]);
						goto setScrName2;
					}
break;
case 10:
{
		/*
		yylex returns OUTLINEHEAD when it sees header of an out-of-line macro
		It also increments MDEPTH.  On a macro expansion, this
		occurs after the macro is expanded.  Macroset() uses
		MDEPTH as the value of '$$'
		parserCopy() ensures the result is a scratch variable
		*/
						MDEPTH--;
						PopMacroInfo();
						
						yyval = parserCopy(yyvsp[-1]);
						goto setScrName2;
					}
break;
case 11:
{
						yyval = NULLSYMBOL;
					  lev0Return:
						if(BRACKETLEV == 0)
						{
							YYACCEPT;
						}
					}
break;
case 12:
{ /* BRACKETLEV must be > 0 */
						yyval = NULLSYMBOL;
					}
break;
case 13:
{
					yyval = NULLSYMBOL;
				  lev0Unscratch:
					
					if(BRACKETLEV == 0 && INPUTLEVEL == 0)
					{
						Unscratch();
					}
				}
break;
case 14:
{
						yyval = yyvsp[-1];
						goto lev0Return;
					}
break;
case 15:
{
						yyval = yyvsp[-1];
						goto lev0Unscratch;
					}
break;
case 16:
{ /* BRACKETLEV must be > 0 */
						yyval = NULLSYMBOL;
						if (yyvsp[-1] != SymbolZero && isscratch(NAME(yyvsp[-1])))
						{
							Removesymbol(yyvsp[-1]);
						}
					}
break;
case 17:
		/*Folding 3 cases into 1*/
case 18:
case 19:
{
					  dobatch:
						if (runCommand(Lookup("batch"), yyvsp[-1]) == SymbolError)
						{
							YYABORT;
						}
						else
						{
							YYACCEPT; /* terminate parse */
						}
					}
break;
case 20:
{
									PARSERVALUE = yyval = yyvsp[-1];
									YYACCEPT;
								}
break;
case 21:
{
						yyval = yyvsp[-1];
						
						if(BRACKETLEV == 0)
						{
							if (yyvsp[-1] != SymbolZero &&
								!invisname(NAME(yyvsp[-1])) && INPUTLEVEL == 0)
							{
								prexpr(yyvsp[-1]);
							}
							YYACCEPT;
						}
					}
break;
case 22:
{
						yyval = yyvsp[-1];
						if(BRACKETLEV == 0)
						{
							if (yyvsp[-1] != SymbolZero && !invisname(NAME(yyvsp[-1])))
							{
								prexpr(yyvsp[-1]);
							}
							if (INPUTLEVEL == 0)
							{
								Unscratch();
							}
						}
					}
break;
case 23:
{ /* BRACKETLEV must be > 0 */
						yyval = NULLSYMBOL;
						if(yyvsp[-1] != SymbolZero && isscratch(NAME(yyvsp[-1])))
						{
							Removesymbol(yyvsp[-1]);
						}
					}
break;
case 24:
{
						yyerror("ERROR: illegal use of batch()");
						Removelist(yyvsp[0]);
		  				YYABORT; /* terminate parse */
					}
break;
case 25:
		/*Folding 3 cases into 1*/
case 26:
case 27:
{yyval = SymbolZero;YYABORT;}
break;
case 28:
{ return(END); }
break;
case 29:
{  /* break, break n, breakall */
					int          targetLevel;

					if(yyvsp[0] == SymbolError)
					{
						YYABORT;
					}
					targetLevel = WDEPTH - (int) DATAVALUE(yyvsp[0],0);
					Removesymbol(yyvsp[0]);
					if(targetLevel < 0)
					{
						YYABORT;
					}
					/*
					  tell lexer to return a bunch of ';', '}' pairs
					  and to skip through INPUTSTRING to just after the
					  last '}' we want to skip.
					*/
					SetBreakTarget(targetLevel);
					cleanLoops(targetLevel,WDEPTH);
				}
break;
case 30:
{
					yyval = NULLSYMBOL;
				}
break;
case 31:
{
					int          targetLevel;

					if(yyvsp[0] == SymbolError)
					{
						YYABORT;
					}
					targetLevel = WDEPTH - (int) DATAVALUE(yyvsp[0],0);
					Removesymbol(yyvsp[0]);
					if(targetLevel < 0)
					{
						YYABORT;
					}
					SetNextTarget(targetLevel);
					cleanLoops(targetLevel + 1,WDEPTH);
				}
break;
case 32:
{
					yyval = NULLSYMBOL;
				}
break;
case 33:
{
					goto setupReturn;
				}
break;
case 34:
{
					/* Should be propagated to be macro return value */ 
					yyval = NULLSYMBOL;
				}
break;
case 35:
{
				  setupReturn:
					{
						int          targetLevel;

						/*
						  Find out how many loops need to be terminated
						*/
						for (targetLevel = WDEPTH-1;
							 targetLevel >= 0 &&
							 WHILEBRACKETLEV[targetLevel] > ThisMacroBracketlev;
							 targetLevel--)
						{
							;
						}
						/*
						  Send message to lexer as to how many ';}' pairs to return
						*/
						SetReturnTarget(ThisMacroBracketlev);
						cleanLoops(targetLevel + 1,WDEPTH);
					}
				}
break;
case 36:
{
					/* Should be propagated to be macro return value */ 
					yyval = yyvsp[-3];
				}
break;
case 37:
{
							yyval = Assign(yyvsp[-1],SymbolZero,LEFTHANDSIDE);
							if(yyval == SymbolError)
							{
								YYABORT;
							}
						}
break;
case 38:
{
							yyval = Assign(yyvsp[-3],yyvsp[0],RIGHTHANDSIDE);
						  checkResult:
							if(yyval == SymbolError)
							{
								YYABORT;
							}
						}
break;
case 39:
{
#if (0) /*code previous to 020702 */
							yyerror("ERROR: illegal assignment to structure component");
							YYABORT;
#else /*0*/
							yyval = AssignComp(yyvsp[-1], SymbolZero, LEFTHANDSIDE);
							if (yyval == SymbolError)
							{
								YYABORT;
							}
						}
break;
case 40:
{
							yyval = AssignComp(yyvsp[-3], yyvsp[0], RIGHTHANDSIDE);
							/* 031214 changed Removesymbol() to Removelist()*/
							Removelist(yyvsp[-3]);
							if (yyval == (SymbolError))
							{
								YYABORT;
							}
#endif /*0*/
						}
break;
case 41:
{
							yyerror("ERROR: Str$name[j] <- x or Str[[i]][j] <- x is illegal");
							Removelist(yyvsp[-2]);
							Removelist(yyvsp[-1]);
							YYABORT;
						}
break;
case 42:
{
							  subassigncheck2:
								yyval = Subassign(yyvsp[-2],yyvsp[-1],SymbolZero,
											   LEFTHANDSIDE);
								if(yyval == SymbolError)
								{
									YYABORT;
								}
							}
break;
case 43:
{
							  subassign5:
								yyval = Subassign(yyvsp[-4],yyvsp[-3],yyvsp[0],RIGHTHANDSIDE);
								Removelist(yyvsp[-3]);
								if(yyval == SymbolError)
								{
									YYABORT;
								}
							}
break;
case 44:
{
								yyval = Subassign(yyvsp[-3],yyvsp[-1],SymbolZero,
											   LEFTHANDSIDE);
								if(yyval == SymbolError)
								{
									YYABORT;
								}
							}
break;
case 45:
{
								yyval = Subassign(yyvsp[-5],yyvsp[-3],yyvsp[0],RIGHTHANDSIDE);
								Removelist(yyvsp[-3]);
								if(yyval == SymbolError)
								{
									YYABORT;
								}
							}
break;
case 46:
{
								goto subassigncheck2;
							}
break;
case 47:
{
								goto subassign5;
							}
break;
case 48:
{
							  subassigncheck3:
								yyval = Subassign(yyvsp[-3],yyvsp[-1],SymbolZero,LEFTHANDSIDE);
								if(yyval == SymbolError)
								{
									YYABORT;
								}
							}
break;
case 49:
{
							  subassign6:
								yyval = Subassign(yyvsp[-5],yyvsp[-3],yyvsp[0],RIGHTHANDSIDE);
								Removelist(yyvsp[-3]);
								if(yyval == SymbolError)
								{
									YYABORT;
								}
							}
break;
case 50:
{
								Op = ADD;
							  doassignop:
								yyval = Assign(yyvsp[-2],SymbolZero,-Op);
								if(yyval == SymbolError)
								{
									YYABORT;
								}
								yyval = Arith(yyvsp[-2], yyvsp[0], Op);
								UNLOADSEG(Arith);
								if(yyval != SymbolError)
								{
									yyval = Assign(yyvsp[-2],yyval,RIGHTHANDSIDE);
								}
								goto checkResult;
							}
break;
case 51:
{
								Op = SUB;
								goto doassignop;
							}
break;
case 52:
{
								Op = MULT;
								goto doassignop;
							}
break;
case 53:
{
								Op = DIV ;
								goto doassignop;
							}
break;
case 54:
{
								Op = MOD;
								goto doassignop;
							}
break;
case 55:
{
								Op = EXP;
								goto doassignop;
							}
break;
case 56:
		/*Folding 4 cases into 1*/
case 57:
case 58:
case 59:
{
									AssignOp = LONGDATAVALUE(yyvsp[0],1);
								  assignoperror:
									sprintf(OUTSTR,
											"ERROR: illegal left side of %s",
											opName(AssignOp));
									yyerror(OUTSTR);
									YYABORT;
								}
break;
case 60:
{
	 						Op = ADD;
							AssignOp = ASSIGNADD;
						  setassignOp:
							{
								Symbolhandle symhOp = LongInstall(SCRATCH, 2);
								if(symhOp == SymbolError)
								{
									YYABORT;
								}
								LONGDATAVALUE(symhOp,0) = (long) Op;
								LONGDATAVALUE(symhOp,1) = (long) AssignOp;
								yyval = symhOp;
							}
						}
break;
case 61:
{Op = SUB;AssignOp = ASSIGNSUB;goto setassignOp;}
break;
case 62:
{Op = MULT;AssignOp = ASSIGNMULT;goto setassignOp;}
break;
case 63:
{Op = DIV;AssignOp = ASSIGNDIV;goto setassignOp;}
break;
case 64:
{Op = MOD;AssignOp = ASSIGNMOD;goto setassignOp;}
break;
case 65:
{Op = EXP;AssignOp = ASSIGNPOW;goto setassignOp;}
break;
case 66:
{
							yyval = yyvsp[0];
						}
break;
case 67:
{
									yyval = yyvsp[0];
				 				}
break;
case 68:
{
								yyval = Assign(yyvsp[-2],yyvsp[0], KEYWORDASSIGN);

								goto checkResult;
							}
break;
case 69:
{yyval = yyvsp[0];}
break;
case 70:
{
								yyval = yyvsp[-1];
								PARSEARGS = ParseArgs;
							}
break;
case 71:
{
										yyval = runCommand(yyvsp[-1], yyvsp[0]);
									  setScrName1:
										OUTSTR[0] = '\0';
										if(yyval == SymbolError)
										{
											YYABORT;
										}
										setScratchName(yyval);
										CHECKINTERRUPT;
									}
break;
case 72:
{

	/*
	  020702 no longer calls Extract().  Instead it creates
             LIST(expr, 1, compname) using BuildCompInfo()
             Extract() is called elsewhere when the component is anything but
             the l.h.s. of an assignment
      020708 Changed order to LIST(expr, 1, compname);
	*/
#if (0)
									yyval = Extract(yyvsp[-2], yyvsp[0], 1);
#else /*0*/
									yyval = BuildCompInfo(yyvsp[-2], yyvsp[0], namedComp,
													   startCompInfo);
#endif /*0*/							
								  setScrName2:
									OUTSTR[0] = '\0';
									if(yyval == SymbolError)
									{
										YYABORT;
									}
									setScratchName(yyval);
								}
break;
case 73:
{
							/*
							  020708 adds compname to component (a LIST) and
							  updates COMPVALUE(component, 1) to specify
							  component specified by name
							*/
							yyval = BuildCompInfo(yyvsp[-2], yyvsp[0], namedComp, addCompInfo);

							if (yyval == SymbolError)
							{
								YYABORT;
							}
						}
break;
case 74:
{
	/*
      020708 Creates LIST(expr, brack2list, 0)
	*/
#if (0)
							yyval = Extract(yyvsp[-1], yyvsp[0], 0);
#else /*0*/
							yyval = BuildCompInfo(yyvsp[-1], yyvsp[0], numberedComp,
											   startCompInfo);
#endif /*0*/
							goto setScrName2;
						}
break;
case 75:
{
							/*
							  020708 adds compname to component (a LIST) and
							  updates COMPVALUE(component, 1) to specify
							  component specified by number
							*/
							yyval = BuildCompInfo(yyvsp[-1], yyvsp[0], numberedComp,
											   addCompInfo);
							goto setScrName2;
						}
break;
case 76:
{
							Symbolhandle list = Addlist( Makelist(), yyvsp[-1] );
							FunctionSymbol   prime, *primeP = &prime;
							Symbolhandle     primeH = (Symbolhandle) &primeP;
							
							if(list == SymbolError)
							{
								YYABORT;
							}
							markFakeSymbol(primeH);
							setNDIMS(primeH, 1);
							setDIM(primeH, 1,1);
							setPREV(primeH, SymbolZero);
							setNEXT(primeH, SymbolZero);
							setTYPE(primeH, BLTIN);
							setFPTR(primeH, transpose);
							setNAME(primeH, "prime");
							yyval = runCommand(primeH, list);
							goto setScrName1;
				  		}
break;
case 77:
{yyval = NULLSYMBOL;}
break;
case 78:
{yyval = yyvsp[0];}
break;
case 79:
{
						YYABORT;
					}
break;
case 80:
{yyval = yyvsp[0];}
break;
case 81:
{yyval = yyvsp[-1];}
break;
case 82:
{yyval = yyvsp[0];}
break;
case 83:
{
						  copy1AndCheck:
							BlockBatch();
							yyvsp[-1] = parserCopy(yyvsp[-1]);
							if (yyvsp[-1] == SymbolError) YYABORT;
						}
break;
case 84:
{
							Op = ADD;
						  arith:
							UnBlockBatch();
							clearNproducts();
							yyval = Arith(yyvsp[-3],yyvsp[0],Op);
							/* Arith() removes SCRATCH unconsumed args */
							UNLOADSEG(Arith);
							goto setScrName1;
						 }
break;
case 85:
{goto copy1AndCheck;}
break;
case 86:
{ Op = SUB;goto arith; }
break;
case 87:
{goto copy1AndCheck;}
break;
case 88:
{ Op = MULT;goto arith; }
break;
case 89:
{goto copy1AndCheck;}
break;
case 90:
{ Op = MATMULT;goto arith; }
break;
case 91:
{goto copy1AndCheck;}
break;
case 92:
{ Op = TRMATMULT;goto arith; }
break;
case 93:
{goto copy1AndCheck;}
break;
case 94:
{ Op = MATMULTTR;goto arith; }
break;
case 95:
{goto copy1AndCheck;}
break;
case 96:
{ Op = MATDIV;goto arith; }
break;
case 97:
{goto copy1AndCheck;}
break;
case 98:
{ Op = DIVMAT;goto arith; }
break;
case 99:
{goto copy1AndCheck;}
break;
case 100:
{ Op = DIV;goto arith; }
break;
case 101:
{goto copy1AndCheck;}
break;
case 102:
{ Op = MOD;goto arith; }
break;
case 103:
{goto copy1AndCheck;}
break;
case 104:
{ Op = EXP;goto arith; }
break;
case 105:
{goto copy1AndCheck;}
break;
case 106:
{ Op = BITOR;goto arith; }
break;
case 107:
{goto copy1AndCheck;}
break;
case 108:
{ Op = BITXOR;goto arith; }
break;
case 109:
{goto copy1AndCheck;}
break;
case 110:
{ Op = BITAND;goto arith; }
break;
case 111:
{yyval = parserCopy(yyvsp[-1]);}
break;
case 112:
{
									Op = '-';
								  unary:
									yyval = Unary(yyvsp[0],Op);
									/*Unary() reuses space if arg is SCRATCH */
									UNLOADSEG(Unary);
									goto setScrName1;
								}
break;
case 113:
{
									Op = '+';
									goto unary;
								}
break;
case 114:
{
									Op = BITNOT;
									goto unary;
								}
break;
case 115:
{goto copy1AndCheck;}
break;
case 116:
{
						Op = EQ;
					  logic:
						UnBlockBatch();
						clearNproducts();
						yyval = Logic(yyvsp[-3],yyvsp[0],Op);
						/*Logic() removes unconsumed scratch args */
						UNLOADSEG(Logic);
						goto setScrName1;
					}
break;
case 117:
{goto copy1AndCheck;}
break;
case 118:
{ Op = EQ; goto logic; }
break;
case 119:
{goto copy1AndCheck;}
break;
case 120:
{ Op = NE; goto logic; }
break;
case 121:
{goto copy1AndCheck;}
break;
case 122:
{ Op = LT; goto logic; }
break;
case 123:
{goto copy1AndCheck;}
break;
case 124:
{ Op = LE; goto logic; }
break;
case 125:
{goto copy1AndCheck;}
break;
case 126:
{ Op = GT; goto logic; }
break;
case 127:
{goto copy1AndCheck;}
break;
case 128:
{ Op = GE; goto logic; }
break;
case 129:
{goto copy1AndCheck;}
break;
case 130:
{ Op = AND; goto logic; }
break;
case 131:
{goto copy1AndCheck;}
break;
case 132:
{ Op = AND; goto logic; }
break;
case 133:
{goto copy1AndCheck;}
break;
case 134:
{ Op = OR; goto logic; }
break;
case 135:
{goto copy1AndCheck;}
break;
case 136:
{ Op = OR; goto logic; }
break;
case 137:
{
							yyval = Logic(yyvsp[0],yyvsp[0],NOT);
							UNLOADSEG(Unary);
							goto setScrName1;
						}
break;
case 138:
{ yyval = yyvsp[0]; }
break;
case 139:
{
							long reply = Macrosetup(yyvsp[-1],yyvsp[0]);

							Removelist(yyvsp[0]);
							if(!reply)
							{
								YYABORT;
							}
						}
break;
case 140:
{
							yyval = yyvsp[0];
						}
break;
case 141:
		/*Folding 6 cases into 1*/
case 142:
case 143:
case 144:
case 145:
case 146:
{
								  missingRparen:
									yyval = 0;
									yyerror("ERROR: missing ')'");
									YYABORT;
								}
break;
case 147:
{yyval = yyvsp[0];}
break;
case 148:
{
	/*
	  020702 component is now LIST(str, name, 1) for str$name
             or LIST(str,subscript,0) for str[[subscript]]
	*/
#if (0)
						yyval = yyvsp[0];
#else /*0*/
						yyval = Extract(yyvsp[0], SymbolZero, 0);
						Removelist(yyvsp[0]);
#endif /*0*/
					}
break;
case 149:
{yyval = yyvsp[0];}
break;
case 150:
{
					IDEPTH--;
					yyval = yyvsp[0];
				}
break;
case 151:
{
						if(IFCONDITIONS[IDEPTH-1] > 0)
						{
							 yyval = yyvsp[-1];
							 SkipBracketBlock();
						}
						CHECKINTERRUPT;
						if(!Ifsetup(SymbolZero, ELSE))
						{
							yyval = 0;
							YYABORT;
						}
					}
break;
case 152:
{
						if(IFCONDITIONS[IDEPTH-1] == 0)
						{
							 yyval = yyvsp[0];
						}
						IDEPTH--;
					}
break;
case 153:
{
							int    ifOK;

							CHECKINTERRUPT;
							ifOK = Ifsetup(yyvsp[0], WHILE);
							Removelist(yyvsp[0]);
							if(!ifOK)
							{
								yyval = 0;
								YYABORT;
							}
							if(WHILECONDITIONS[WDEPTH-1] == 0)
							{
								SkipBracketBlock();
							}
							else if(WHILELIMITS[WDEPTH-1] <= 0)
							{ /* too many reps */
								YYABORT ;
							}
						}
break;
case 154:
{ /* post WHILE checking */
							if(WHILECONDITIONS[WDEPTH-1])
							{
								setupfaketokens(WHILE);
								if(yyvsp[0] != SymbolZero && BRACKETLEV > 0 &&
									 isscratch(NAME(yyvsp[0])))
								{
									Removesymbol(yyvsp[0]);
									yyvsp[0] = NULLSYMBOL;
								}
							}
							else
							{
								WHILELIMITS[WDEPTH-1] = MAXWHILE;
							}
							WDEPTH--;
							yyval = yyvsp[0];
						}
break;
case 155:
{
							int   ifOK;

							CHECKINTERRUPT;
							ifOK = Ifsetup(yyvsp[0], FOR);
							Removelist(yyvsp[0]);
							if(!ifOK)
							{
								yyval = 0;
								YYABORT;
							}
							if (ifOK < 0)
							{
								SkipBracketBlock();
							}
						 }
break;
case 156:
{
							if(WHILECONDITIONS[WDEPTH-1] &&
								 --WHILELIMITS[WDEPTH-1] > 0)
							{
								setupfaketokens(FOR);
								if(yyvsp[0] != SymbolZero && BRACKETLEV > 0 &&
									 isscratch(NAME(yyvsp[0])))
								{
									Removesymbol(yyvsp[0]);
									yyvsp[0] = NULLSYMBOL;
								}
							}
							else
							{
								WHILELIMITS[WDEPTH-1] = MAXWHILE;
							}
							WDEPTH--;
							yyval = yyvsp[0];
						}
break;
case 157:
{yyval = yyvsp[0]; goto setScrName2;}
break;
case 158:
		/*Folding 3 cases into 1*/
case 159:
case 160:
{yyval = yyvsp[0];}
break;
case 161:
{
						notfunction(yyvsp[-1]);
						yyval = 0;
						YYABORT;
					}
break;
case 162:
{
						return (FATALERROR);
					}
break;
case 163:
		/*Folding 4 cases into 1*/
case 164:
case 165:
case 166:
{yyval = yyvsp[0];}
break;
case 167:
		/*Folding 26 cases into 1*/
case 168:
case 169:
case 170:
case 171:
case 172:
case 173:
case 174:
case 175:
case 176:
case 177:
case 178:
case 179:
case 180:
case 181:
case 182:
case 183:
case 184:
case 185:
case 186:
case 187:
case 188:
case 189:
case 190:
case 191:
case 192:
{yyval = yyvsp[-1];}
break;
case 193:
{
									yyval = Element(yyvsp[-1],yyvsp[0]);
									Removelist(yyvsp[0]);
									goto setScrName2;
								}
break;
case 194:
{
								  bracklist4:
									yyval = Element(yyvsp[-2],yyvsp[0]);
									Removelist(yyvsp[0]);
									goto setScrName2;
								}
break;
case 195:
{ 
		/*
		  020702 modified for component being a list
				 Previously just went to bracklist2
		  031105 added check of return value of Extract() to avoid crash
                 on structure(a:1,b:2)$c[1] or structure(a:1)[[2]][1], e.g.
		*/
									Symbolhandle  temp;
									
									temp = Extract(yyvsp[-1], SymbolZero, 0);

									Removelist(yyvsp[-1]);
									if (temp == SymbolError)
									{
										YYABORT;
									}
									yyvsp[-1] = temp;
									goto bracklist2;
								}
break;
case 196:
		/*Folding 6 cases into 1*/
case 197:
case 198:
case 199:
case 200:
case 201:
{
							  bracklist2:
								yyval = Element(yyvsp[-1],yyvsp[0]);
								Removelist(yyvsp[0]);
								goto setScrName2;
							}
break;
case 202:
{
								yyval = Element(yyvsp[-2],yyvsp[0]);
								Removelist(yyvsp[0]);
								goto setScrName2;
							}
break;
case 203:
{
							int    ifOK;

							CHECKINTERRUPT;

							ifOK = Ifsetup(yyvsp[0], IF);
							Removelist(yyvsp[0]);
							if(!ifOK)
							{
								yyval = 0;
								YYABORT;
							}
							if(IFCONDITIONS[IDEPTH-1] == 0)
							{
								SkipBracketBlock();
							}
						}
break;
case 204:
{ /* post IF checking */
							yyval = (IFCONDITIONS[IDEPTH-1] ) ? yyvsp[0] : NULLSYMBOL;
						}
break;
case 205:
{
							if(IFCONDITIONS[IDEPTH-1] > 0)
							{
								SkipParenBlock();
							}
						}
break;
case 206:
{
							int    ifOK;

							if(IFCONDITIONS[IDEPTH-1] > 0)
							{
								SkipBracketBlock();
								Removelist(yyvsp[0]);
								yyvsp[0] = SymbolZero;
							}
							CHECKINTERRUPT;

							ifOK = Ifsetup(yyvsp[0], ELSEIF);

							if(yyvsp[0] != SymbolZero)
							{
								Removelist(yyvsp[0]);
							}
							if(!ifOK)
							{
								yyval = 0;
								YYABORT;
							}
							if(IFCONDITIONS[IDEPTH-1] == 0)
							{
								SkipBracketBlock();
							}
						}
break;
case 207:
{
							if(yyvsp[-2] == SymbolZero)
							{
								yyval = yyvsp[-5];
							}
							else if(IFCONDITIONS[IDEPTH-1] > 0)
							{
								yyval = yyvsp[0];
							}
							else
							{
								yyval = NULLSYMBOL;
							}
						}
break;
case 208:
{ yyval = 0 ; YYABORT;}
break;
case 209:
{yyval = yyvsp[0];}
break;
case 210:
{
								yyval = yyvsp[-1];
								PARSEARGS = ParseArgs;
							}
break;
case 211:
{yyval = yyvsp[0];}
break;
case 212:
{yyval = yyvsp[-1];}
break;
case 213:
{
						long      bynameType = 1;
						
						yyval = Byname(yyvsp[-1],&bynameType,&ParseArgs);
						if (isscratch(NAME(yyvsp[-1])))
						{
							Removesymbol(yyvsp[-1]);
						}
						
						if(yyval == SymbolError)
						{
							YYABORT;
						}
						else
						{
							SetNextChar(bynameType);
						}
					}
break;
case 214:
{
							yyval = 0;
							yyerror("ERROR: missing '>>'");
							YYABORT;
						}
break;
case 215:
{yyval = yyvsp[0];}
break;
case 216:
{yyval = yyvsp[0];}
break;
case 217:
{
							  growMake:
								yyval = Growlist(Makelist());
								goto checkResult;
							}
break;
case 218:
{
							  growAddMake:
								yyval = Growlist(Addlist(Makelist(),yyvsp[-1]));
								goto checkResult;
							}
break;
case 219:
{
							  growAdd:
								yyval = Growlist(Addlist(yyvsp[-2],yyvsp[-1]));
								goto checkResult;
							}
break;
case 220:
{
								yyval = Growlist(yyvsp[-1]);
								goto checkResult;
							}
break;
case 221:
{
							  addMake:
								yyval = Addlist( Makelist(), yyvsp[0] );
								goto checkResult;
							}
break;
case 222:
{
								yyval = yyvsp[0];
								goto checkResult;
							}
break;
case 223:
{
							  addlist:
								yyval = Addlist( yyvsp[-1], yyvsp[0]);
								goto checkResult;
							}
break;
case 224:
{
									  makelist:
										yyval = Makelist();
										goto checkResult;
									}
break;
case 225:
{
									yyval = yyvsp[-1];
								}
break;
case 226:
		/*Folding 6 cases into 1*/
case 227:
case 228:
case 229:
case 230:
case 231:
{goto missingRparen;}
break;
case 232:
		/*Folding 2 cases into 1*/
case 233:
{goto makelist;}
break;
case 234:
		/*Folding 2 cases into 1*/
case 235:
{ yyval = yyvsp[-1]; goto checkResult;}
break;
case 236:
		/*Folding 3 cases into 1*/
case 237:
case 238:
{
					  missingRbracket:
						yyerror("ERROR: missing ']'");
						yyval = 0;
						YYABORT;
					}
break;
case 240:
		/*Folding 2 cases into 1*/
case 241:
{ yyval = yyvsp[-2]; goto checkResult;}
break;
case 242:
{ yyval = SymbolZero; }
break;
case 243:
		/*Folding 3 cases into 1*/
case 244:
case 245:
{
								  missingRbrack2:
									yyerror("ERROR: missing ']]'");
									yyval = 0;
									YYABORT;
								}
break;
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            (sprintf(OUTSTR,"%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL), myprint(OUTSTR));
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                (sprintf(OUTSTR,"%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys), myprint(OUTSTR));
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        (sprintf(OUTSTR,"%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate), myprint(OUTSTR));
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("ERROR: Parser stack overflow; probably too deep macro recursion");
yyabort:
    return (1);
yyaccept:
    return (0);
}
