/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.36 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/


#ifdef SEGMENTED
#if defined(MPW) || defined(MW_CW)
#pragma segment Utils
#endif /*MPW||MW_CW*/
#endif /*SEGMENTED*/


#include "globals.h"
#include "macIface.h" /* defines SFReply Reply as global*/

/*
   960502 added parameters fileName and vRefNum
          Moved check for fileName[0] == '\0' here
		  readWrite shoule be either READIT or WRITEIT

   960503 changed name of macOpen() to macFindFile(); changed name
          of file to macFindFile.c
*/
static char       FileName[64]; /* macFindFile() returns address of FileName */

char *macFindFile(char *fileName, Str255 message, Str255 defaultname,
			  Integer readWrite, Integer ntypes, OSType * types, 
			  Integer * volume) 
{
	SFTypeList      myTypes;
	Point           p;
	Integer         numTypes;
	Integer         vRefNum = (volume != (Integer *) 0) ? *volume : 0;
	int             i;

	if (fileName[0] == '\0')
	{
		/* Use standard file dialog box */
		SetPt(&p, 82, 90);
	
		DeactivateWindow();		/*unhighlight front window*/

		if(readWrite == WRITEIT)
		{						/* write */
			DialogEdit = true;
			NDialogButtons = 2;
			ButtonChars[0] = 's';
			ButtonChars[1] = 'n';
			SFPPutFile(p, message, defaultname, NullDialogHookPtr, &Reply,
					   putDlgID, MyDialogFilterPtr);
		}
		else
		{/* read */
			if(ntypes == 0)
			{
				numTypes = 1;
				myTypes[0] = 'TEXT';
				if(types != (OSType *) 0)
				{
					myTypes[1] = types[0];
					numTypes++;
				}
			}
			else
			{
				numTypes = ntypes;
				for(i = 0;i < ntypes; i++)
				{
					myTypes[i] = types[i];
				}
			}
			DialogEdit = false;
			NDialogButtons = 2;
			ButtonChars[0] = 'o'; /* Open */
			ButtonChars[1] = 'n'; /* Cancel */
			SFPGetFile(p, message, NullFileFilterPtr,	
					   numTypes, myTypes, NullDialogHookPtr, &Reply,
					   getDlgID, MyDialogFilterPtr);
		}
		macUpdate((WindowPtr) 0);
	
		if (!Reply.good)
		{ /* cancelled */
			return (0);
		}
		vRefNum = Reply.vRefNum;

		if (volume != (Integer *) 0)
		{
			*volume = vRefNum;
		}
	
		PtoCstr((char *) Reply.fName);
		strcpy(FileName, (char *) Reply.fName);
		CtoPstr((char *) Reply.fName);
		fileName = FileName;
	} /*if (fileName[0] == '\0')*/
	if (vRefNum != 0)
	{
		SetVol(0L, vRefNum);
	}
	
	return (fileName);

} /*macFindFile()*/

void macSetInfo(Integer vRefNum,char * fName,OSType type,OSType creator)
{
	FInfo       finder_stuff;
	Str63       fileName;

	strncpy((char *) fileName, fName, 63);
	fileName[63] = '\0';
	CtoPstr(fileName);

	GetFInfo(fileName, vRefNum, &finder_stuff);
	finder_stuff.fdType = type;
	finder_stuff.fdCreator = creator;
	SetFInfo(fileName, vRefNum, &finder_stuff);
}
