/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.36 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/
/* resource version of macros in iniMacro.c */

/*
	each resource must be of the form 
resource 'wstr' (100xx, "_MV_Macroname", nonpurgeable)
{
	"first line of macro text\n"
	"second line of macro text\n"
	. . . . .
	"last line of macro text\n"
};
 */


resource 'wstr' (10001, "_MV_redo", nonpurgeable)  /* redo() or redo(charVariable) or redo(macrovariable) */
{
	"REDO<-macro({if($N==0){LASTLINE}else{$1}})\n"
	"REDO()"
};

resource 'wstr' (10002, "_MV_readcols", nonpurgeable)  /* readcols(filename,name1,...,namek [,echo:T or F]) */
{
	"# readcols(filename,name1,...,namek [,echo:T or F]), only filename quoted\n"
	"if($v < 2){\n"
	"\terror(\"ERROR: too few arguments for $S\")\n"
	"}\n"
	"@file$$<-$1\n"
	"if(!ischar(@file$$) || !isscalar(@file$$)){\n"
	"\terror(\"ERROR: $1 not quoted string or CHARACTER scalar\")\n"
	"}\n"
	"@names$$ <- if($v == 2){\n"
	"\tif(ischar($2)){$2}else{\"$2\"}\n"
	"}else{$A[-1]}\n"
	"@n$$ <- if($v == 2){length(@names$$)}else{$v-1}\n"
	"@data$$<-if($k==0){vecread($1)}else{vecread($1,$K)}\n"
	"@data$$<-matrix(@data$$,@n$$)\n"
	"for(@i$$,run(@n$$)){\n"
	"\t<<@names$$[@i$$]>> <- cat(@data$$[@i$$,]);;\n"
	"}"
};

resource 'wstr' (10003, "_MV_twotailt", nonpurgeable) 
{
	"# usage: twotailt(tval, df)\n"
	"@tval$$<-abs($1);@df$$<-$2\n"
	"if(!isscalar(@tval$$) && !isscalar(@df$$) && length(@tval$$)!=length(@df$$)){\n"
	"\terror(\"ERROR: lengths of $S arguments don't match\");\n"
	"}\n"
	"2*(1-cumstu(@tval$$,@df$$))"
};

resource 'wstr' (10004, "_MV_resvsrankits", nonpurgeable) 
{
	"#resvsrankits([jvar [,char]] [,title:\"Your title\"])\n"
	"if(!isdefined(DF) || !isdefined(SS) ||\\\n"
	"!isdefined(RESIDUALS) || !isdefined(HII)){\n"
	"\terror(\"ERROR: Apparently no linear model has been fitted\")\n"
	"}\n"
	"@m$$ <- length(DF)\n"
	"if (DF[@m$$] == 0){\n"
	"\terror(\"ERROR: no degrees of freedom for error; can't studentize\")}\n"
	"@w$$<-getoptions()\n"
	"setoptions(warnings:F)\n"
	"@chars$$<-\"*\"\n"
	"if($v==2){\n"
	"\t@chars$$<-$2\n"
	"\tif(isreal(@chars$$) && isscalar(@chars$$)){\n"
	"\t\tif(@chars$$==0){\n"
	"\t\t\t@chars$$<-run(nrows(RESIDUALS))\n"
	"\t\t}\n"
	"\t}\n"
	"}\n"
	"@i$$<-if($v==0){1}else{$1}\n"
	"@r$$ <- if(isdefined(WTDRESIDUALS)){WTDRESIDUALS[,@i$$]}else{RESIDUALS[,@i$$]}\n"
	"@r$$ <- @r$$/sqrt((SS[@m$$,@i$$,@i$$]/DF[@m$$])*(1 - HII))\n"
	"chplot(Rankits:rankits(@r$$),@r$$,@chars$$,DD:0,$K,ylab:\"Studentized Resids\")\n"
	"setoptions(@w$$)\n"
	"delete(@m$$,@w$$,@i$$,@r$$,@chars$$)"
};

resource 'wstr' (10005, "_MV_resvsyhat", nonpurgeable) 
{
	"#resvsyhat([jvar [,char]] [,title:\"Your title\"])\n"
	"if(!isdefined(DF) || !isdefined(SS) ||\\\n"
	"!isdefined(RESIDUALS) || !isdefined(HII)){\n"
	"\terror(\"ERROR: Apparently no linear model has been fitted\")\n"
	"}\n"
	"@m$$ <- length(DF)\n"
	"if (DF[@m$$] == 0){\n"
	"\terror(\"ERROR: no degrees of freedom for error; can't studentize\")}\n"
	"@w$$<-getoptions()\n"
	"setoptions(warnings:F)\n"
	"@chars$$<-\"*\"\n"
	"if($v==2){\n"
	"\t@chars$$<-$2\n"
	"\tif(isreal(@chars$$) && isscalar(@chars$$)){\n"
	"\t\tif(@chars$$==0){\n"
	"\t\t\t@chars$$<-run(nrows(RESIDUALS))\n"
	"\t\t}\n"
	"\t}\n"
	"}\n"
	"@i$$ <- if($v==0){1}else{$1}\n"
	"@r$$ <- if(isdefined(WTDRESIDUALS)){WTDRESIDUALS[,@i$$]}else{RESIDUALS[,@i$$]}\n"
	"@r$$ <- @r$$/sqrt((SS[@m$$,@i$$,@i$$]/DF[@m$$])*(1 - HII))\n"
	"chplot(Yhat:modelvars(y:T)[,@i$$]-RESIDUALS[,@i$$],@r$$,@chars$$,DD:0,$K,\\\n"
	"\tylab:\"Studentized Resids\")\n"
	"setoptions(@w$$)\n"
	"delete(@m$$,@w$$,@i$$,@r$$)"
};

resource 'wstr' (10006, "_MV_resvsindex", nonpurgeable) 
{
	"#resvsindex([jvar [,char]] [,title:\"Your title\"])\n"
	"if(!isdefined(DF) || !isdefined(SS) ||\\\n"
	"!isdefined(RESIDUALS) || !isdefined(HII)){\n"
	"\terror(\"ERROR: Apparently no linear model has been fitted\")\n"
	"}\n"
	"@m$$ <- length(DF)\n"
	"if (DF[@m$$] == 0){\n"
	"\terror(\"ERROR: no degrees of freedom for error; can't studentize\")}\n"
	"@chars$$<-\"*\"\n"
	"if($v==2){\n"
	"\t@chars$$<-$2\n"
	"\tif(isreal(@chars$$) && isscalar(@chars$$)){\n"
	"\t\tif(@chars$$==0){\n"
	"\t\t\t@chars$$<-run(nrows(RESIDUALS))\n"
	"\t\t}\n"
	"\t}\n"
	"}\n"
	"@w$$<-getoptions()\n"
	"setoptions(warnings:F)\n"
	"@i$$ <- if($v==0){1}else{$1}\n"
	"@r$$ <- if(isdefined(WTDRESIDUALS)){WTDRESIDUALS[,@i$$]}else{RESIDUALS[,@i$$]}\n"
	"@r$$ <- @r$$/sqrt((SS[@m$$,@i$$,@i$$]/DF[@m$$])*(1 - HII))\n"
	"setoptions(@w$$)\n"
	"chplot(1,@r$$,@chars$$,DD:0,$K,xlab:\"Case Number\",\\\n"
	"ylab:\"Studentized Resids\")\n"
	"delete(@m$$,@w$$,@i$$,@r$$)"
};

resource 'wstr' (10007, "_MV_hist", nonpurgeable) 
{
	"# usage: hist(x), hist(x,nbins), or hist(x,binvec)\n"
	"if($v < 1 || $v > 2){\n"
	"\terror(\"ERROR: usage is $S(x), $S(x,nbins) or $S(x,binvec)\")\n"
	"}\n"
	"@x$$<-$1\n"
	"if(!isvector(@x$$)||!isreal(@x$$)){error(\"ERROR: $1 is not a REAL vector\")}\n"
	"if(anymissing(@x$$)){@x$$<-@x$$[!ismissing(@x$$)]}\n"
	"if($v == 2){\n"
	"\t@bins$$<-$2\n"
	"\tif(!isvector(@bins$$)||!isreal(@bins$$)){\n"
	"\t\terror(\"ERROR: $2 is not a REAL scalar or vector\")\n"
	"\t}\n"
	"}else{\n"
	"\t@bins$$ <- floor(log(length(@x$$))/log(2)) + 1\n"
	"}\n"
	"@nbins$$ <- if(isscalar(@bins$$)){@bins$$}else{length(@bins$$)-1}\n"
	"if(@nbins$$ <= 0 || @nbins$$ != floor(@nbins$$)){\n"
	"\terror(\"ERROR: $2 is not positive integer\")\n"
	"}\n"
	"if(isscalar(@bins$$)){\n"
	"\t@min$$ <- 1.05*min(@x$$) - .05*max(@x$$)\n"
	"\t@max$$ <- 1.05*max(@x$$) - .05*min(@x$$)\n"
	"\t@widths$$ <- (@max$$ - @min$$)/@nbins$$\n"
	"\t@bins$$ <- run(@min$$,@max$$+.1*@widths$$,@widths$$)\n"
	"} else {\n"
	"\tif(min(@x$$) <=min(@bins$$) || max(@x$$) > max(@bins$$)){\n"
	"\t\terror(\"ERROR: minimum or maximum of data outside of bins\")\n"
	"\t}\n"
	"}\n"
	"@widths$$ <- movavg(1,@bins$$)[-1]\n"
	"if(min(@widths$$) < 0){\n"
	"\terror(\"ERROR: bin boundaries are not monotonic\")\n"
	"}\n"
	"@hts$$ <- bin(@x$$, @bins$$)$counts/@widths$$\n"
	"@xpts$$ <- cat(hconcat(@bins$$,@bins$$,@bins$$)')[-1]\n"
	"@ypts$$ <- cat(0,hconcat(@hts$$,@hts$$,rep(0,length(@hts$$)))',0)/length(@x$$)\n"
	"lineplot(@xpts$$,@ypts$$,$K,xlab:\"$1\",ylab:\"Density\",\\\n"
	"\tyaxis:F,title:\"Histogram of $1 with total area 1\")\n"
	"delete(@x$$,@bins$$,@nbins$$,@hts$$,@xpts$$,@ypts$$,@widths$$)"
};

resource 'wstr' (10008, "_MV_boxcox", nonpurgeable) 
{
	"# usage: boxcox(x,power), x a vector or matrix, power a scalar\n"
	"@x$$<-$1;@power$$<-$2\n"
	"if(!isscalar(@power$$)){\n"
	"\terror(\"ERROR: $S power not a scalar\");\n"
	"}\n"
	"@gm$$ <- exp(describe(log(@x$$),mean:T))'\n"
	"if ( @power$$ == 0 ) {\n"
	"\t@ans$$ <- @gm$$ * log(@x$$)\n"
	"} else {\n"
	"\t@ans$$ <- (@x$$^@power$$ - 1)/(@power$$*@gm$$^(@power$$-1))\n"
	"}\n"
	"array(@ans$$,dim(@x$$))"
};

resource 'wstr' (10009, "_MV_makefactor", nonpurgeable) 
{
	"# makefactor(values) where values either REAL or CHAR\n"
	"if($N != 1){\n"
	"\terror(\"ERROR: $S requires one argument\")\n"
	"}\n"
	"@values$$ <- $1\n"
	"if(!isvector(@values$$)){\n"
	"\terror(\"ERROR: argument to $S must be vector\")\n"
	"}\n"
	"if(ischar(@values$$)){\n"
	"\tfactor(match(@values$$,unique(@values$$)))\n"
	"}else{\n"
	"\tfactor(match(@values$$,unique(sort(@values$$))))\n"
	"}"
};

resource 'wstr' (10010, "_MV_resid", nonpurgeable) 
{
	"# resid() or resid(model) or resid(model,T), where model is a linear model\n"
	"if($N > 2){\n"
	"\terror(\"ERROR: usage is $S() or $S(model) or $S(model,T)\")\n"
	"}\n"
	"@reg$$ <- if($N<=1){F}else{$2}#T forces regress()\n"
	"if(!isscalar(@reg$$) || !islogic(@reg$$)){\n"
	"\terror(\"ERROR: argument 2 to $S not T or F\")\n"
	"}\n"
	"if($N >= 1){\n"
	"\t@model$$ <- $1\n"
	"\tif(@reg$$){regress(@model$$,silent:T)}else{manova(@model$$,silent:T)}\n"
	"\tdelete(@model$$)\n"
	"}\n"
	"if(!isdefined(RESIDUALS)||!isdefined(SS)||!isdefined(HII)||!isdefined(DF)){\n"
	"\terror(\"ERROR: no active model; try $S(model)\")\n"
	"}\n"
	"@m$$<-dim(SS)[1]\n"
	"if (DF[@m$$] == 0){\n"
	"\terror(\"ERROR: no degrees of freedom for error; can't studentize\")}\n"
	"@w$$<-getoptions()\n"
	"setoptions(warnings:F)\n"
	"@r$$ <- if(isdefined(WTDRESIDUALS)){WTDRESIDUALS}else{RESIDUALS}\n"
	"@r$$ <- @r$$/sqrt((1-HII)*(diag(SS[@m$$,,])'/DF[@m$$]))\n"
	"@o$$ <- hconcat(\\\n"
	"\tmodelvars(0),\\\n"
	"\t@r$$,\\\n"
	"\tHII,\\\n"
	"\t@r$$^2*HII/((1-HII)*sum(DF[-@m$$])),\\\n"
	"\t@r$$*sqrt((DF[@m$$]-1)/(DF[@m$$]-@r$$^2))\\\n"
	")\n"
	"setoptions(@w$$)\n"
	"delete(@w$$,@r$$,@m$$)\n"
	"@o$$"
};

resource 'wstr' (10011, "_MV_yhat", nonpurgeable) 
{
	"# yhat() or yhat(model) or yhat(model,T), where model is a linear model\n"
	"if($N > 2){\n"
	"\terror(\"ERROR: usage is $S() or $S(model) or $S(model,T)\")\n"
	"}\n"
	"@reg$$ <- if($N<=1){F}else{$2}\n"
	"if(!isscalar(@reg$$) || !islogic(@reg$$)){\n"
	"\terror(\"ERROR: argument 2 to $S not T or F\")\n"
	"}\n"
	"if($N >= 1){\n"
	"\t@model$$ <- $1\n"
	"\tif(@reg$$){regress(@model$$,silent:T)}else{manova(@model$$,silent:T)}\n"
	"\tdelete(@model$$)\n"
	"}\n"
	"if(!isdefined(RESIDUALS) || !isdefined(SS) ||\\\n"
	"\t!isdefined(HII) || !isdefined(DF)){\n"
	"\terror(\"ERROR: apparently no active linear model; try $S(model)\")\n"
	"}\n"
	"@m$$<-dim(SS)[1]\n"
	"if (DF[@m$$] == 0){\n"
	"\terror(\"ERROR: no degrees of freedom for error; can't studentize\")}\n"
	"@w$$<-getoptions()\n"
	"setoptions(warnings:F)\n"
	"@wts$$ <- if(isdefined(WTDRESIDUALS)){\n"
	"\tmodelinfo(weights:T)}else{rep(1,nrows(RESIDUALS))}\n"
	"@mse$$<-diag(SS[@m$$,,])'/DF[@m$$]\n"
	"@depvar$$<-modelvars(0)\n"
	"delete(@reg$$, @m$$)\n"
	"@o$$ <- hconcat(\\\n"
	"\t@depvar$$ ,\\\n"
	"\t@depvar$$-RESIDUALS,\\\n"
	"\tRESIDUALS/(1-HII),\\\n"
	"\tsqrt(HII*@mse$$/@wts$$),\\\n"
	"\tsqrt((1+HII/@wts$$)*@mse$$)\\\n"
	")\n"
	"setoptions(@w$$)\n"
	"delete(@w$$,@wts$$,@depvar$$,@mse$$)\n"
	"@o$$"
};

resource 'wstr' (10012, "_MV_anovapred", nonpurgeable) 
{
	"# anovapred(a,b,...) , where a, b, ..., are all the factors in the model\n"
	"if($v == 0){\n"
	"\terror(\"ERROR: usage is $S(a,b,...) where a,b,... are all the factors in model\")\n"
	"}\n"
	"if(!isdefined(DEPVNAME) || !isdefined(RESIDUALS)||\\\n"
	"\t !isdefined(HII) || !isdefined(DF)){\n"
	"\terror(\"ERROR: $S: apparently no active linear model\")\n"
	"}\n"
	"@error$$<-dim(SS)[1]\n"
	"@mse$$<-diag(SS[@error$$,,])'/DF[@error$$]\n"
	"makestr(estimate:tabs(<<DEPVNAME>>-RESIDUALS,$V,mean:T),\\\n"
	"SEest:sqrt(tabs(@mse$$*HII,$V,mean:T)),\\\n"
	"SEpred:sqrt(tabs(@mse$$*(1+HII),$V,mean:T)))"
};

resource 'wstr' (10013, "_MV_makecols", nonpurgeable) 
{
	"# makecols(y,name1,name2,...,namek), y a matrix, name1,... unquoted names\n"
	"if($v < 2){\n"
	"\terror(\"ERROR: too few arguments for $S\")\n"
	"}\n"
	"@data$$<-$1\n"
	"if(!isreal(@data$$) || !ismatrix(@data$$)){\n"
	"\terror(\"ERROR: $1 not REAL matrix scalar\")\n"
	"}\n"
	"@data$$<-matrix(@data$$,nrows(@data$$))\n"
	"@names$$ <- if($v == 2){\n"
	"\tif(ischar($2)){$2}else{\"$2\"}\n"
	"}else{$A[-1]}\n"
	"@n$$ <- min(length(@names$$),ncols(@data$$))\n"
	"for(@i$$,run(@n$$)){\n"
	"\t<<@names$$[@i$$]>> <- cat(@data$$[,@i$$]);;\n"
	"}"
};

resource 'wstr' (10014, "_MV_colplot", nonpurgeable) 
{
	"#colplot(y [,title:\"Title of your choice\")\n"
	"if($N<1){error(\"ERROR: $S needs at least 1 argument\")}\n"
	"chplot(1,$1,lines:T,$K,xlab:\"Row Number\")"
};

resource 'wstr' (10015, "_MV_rowplot", nonpurgeable) 
{
	"#rowplot(y [,title:\"Title of your choice\")\n"
	"if($N<1){error(\"ERROR: $S needs at least 1 argument\")}\n"
	"chplot(1,y:($1)',lines:T,$K,xlab:\"Column Number\")"
};

resource 'wstr' (10016, "_MV_fcolplot", nonpurgeable) 
{
	"#fcolplot(fileName, y [,title:\"Title of your choice\")\n"
	"if($N<2){error(\"ERROR: $S needs at least 2 arguments\")}\n"
	"chplot(1,$2,lines:T,file:$1,$K,xlab:\"Row Number\")"
};

resource 'wstr' (10017, "_MV_frowplot", nonpurgeable) 
{
	"#frowplot(fileName, y [,title:\"Title of your choice\")\n"
	"if($N<2){error(\"ERROR: $S needs at least 2 arguments\")}\n"
	"chplot(1,y:($2)',lines:T,file:$1,$K,xlab:\"Column Number\")"
};

resource 'wstr' (10018, "_MV_regs", nonpurgeable) 
{
	"#regs(x,y),matrix or vector y, matrix x\n"
	"@Xvars$$<-$1\n"
	"@Y<-$2\n"
	"if(!ismatrix(@Xvars$$)||!ismatrix(@Y)){\n"
	"\terror(\"ERROR: usage: $S(x,y), matrix x, vector or matrix y\")\n"
	"}\n"
	"@p$$<-length(@Xvars$$)/dim(@Xvars$$)[1]\n"
	"@X1<-@Xvars$$[,1]\n"
	"STRMODEL<-\"@Y=@X1\"\n"
	"if(@p$$>1){\n"
	"\tfor(@i$$,run(2,@p$$)){\n"
	"\t\t<<paste(\"@X\",@i$$,sep:\"\")>><-@Xvars$$[,@i$$]\n"
	"\t\tSTRMODEL<-paste(STRMODEL,\"+@X\",@i$$,sep:\"\")\n"
	"\t}\n"
	"}\n"
	"if(length(@Y)==dim(@Y)[1]){\n"
	"\tregress()\n"
	"}else{\n"
	"\tmanova()\n"
	"\tprint(\"NOTE: use secoefs() to get coefficients and standard errors.\")\n"
	"}"
};

resource 'wstr' (10019, "_MV_breakif", nonpurgeable) 
{
	"if($1){\n"
	"\t@depth$$ <- if($N==1){1}else{$2}\n"
	"\t@break$$ <- macro(paste(\"delete(@depth$$);break \",@depth$$,\";\"))\n"
	"\t@break$$()\n"
	"}"
};

resource 'wstr' (10020, "_MV_alltrue", nonpurgeable) 
{
	"# usage: alltrue(logic1,logic2,...,logicm) computes logic1 && ... && logicm\n"
	"if($N == 0 || $k > 0)\\\n"
	"  {error(\"ERROR: '$S' must at least 1 argument with no keywords\")}\n"
	"@ck$$ <- macro(\"@log$$<-\\$1;if(!isscalar(@log$$) || !islogic(@log$$)){\n"
	"\terror(\\\"ERROR: argument \\$2 to $S is not LOGICAL scalar\\\")}\n"
	"\t@log$$\")\n"
	"if($N==1){@reply$$<-@ck$$($1,1)}elseif($N==2)\\\n"
	"  {@reply$$<-if(!@ck$$($1,1)){F}else{@ck$$($2,2)}}else{\n"
	"\t@args$$ <- $A\n"
	"\t@eval$$ <- paste(\"if(!@ck$$($1,1)){F}\",sep:\"\")\n"
	"\tfor(@i$$,run(2,$N-1)){\n"
	"\t\t@eval$$<-paste(@eval$$,\"elseif(!@ck$$(\",@args$$[@i$$],\",\",@i$$,\")){F}\",sep:\"\")\n"
	"\t}\n"
	"\t@eval$$<-macro(paste(@eval$$,\"else{@ck$$(\",@args$$[$N],\")}\",sep:\"\"))\n"
	"\t@reply$$<-@eval$$()\n"
	"\tdelete(@args$$,@eval$$,@i$$)\n"
	"}\n"
	"delete(@ck$$,@log$$)\n"
	"@reply$$"
};

resource 'wstr' (10021, "_MV_anytrue", nonpurgeable) 
{
	"# usage: anytrue(logic1,logic2,...,logicm) computes logic1 || ... || logicm\n"
	"if($N == 0 || $k > 0)\\\n"
	"  {error(\"ERROR: '$S' must at least 1 argument with no keywords\")}\n"
	"@ck$$ <- macro(\"@log$$<-\\$1;if(!isscalar(@log$$) || !islogic(@log$$)){\n"
	"\terror(\\\"ERROR: argument \\$2 to $S is not LOGICAL scalar\\\")}\n"
	"\t@log$$\")\n"
	"if($N==1){@reply$$<-@ck$$($1,1)}elseif($N==2)\\\n"
	"  {@reply$$<-if(@ck$$($1,1)){T}else{@ck$$($2,2)}}else{\n"
	"\t@args$$ <- $A\n"
	"\t@eval$$ <- paste(\"if(@ck$$($1,1)){T}\",sep:\"\")\n"
	"\tfor(@i$$,run(2,$N-1)){\n"
	"\t\t@eval$$<-paste(@eval$$,\"elseif(@ck$$(\",@args$$[@i$$],\",\",@i$$,\")){T}\",sep:\"\")\n"
	"\t}\n"
	"\t@eval$$<-macro(paste(@eval$$,\"else{@ck$$(\",@args$$[$N],\")}\",sep:\"\"))\n"
	"\t@reply$$<-@eval$$()\n"
	"\tdelete(@args$$,@eval$$,@i$$)\n"
	"}\n"
	"delete(@ck$$,@log$$)\n"
	"@reply$$"
};

resource 'wstr' (10022, "_MV_console", nonpurgeable) 
{
	"# usage: y <- console() reads from keyboard or following lines in batch file\n"
	"if($k==0){vecread(CONSOLE)}else{vecread(CONSOLE,$K)}"
};

resource 'wstr' (10023, "_MV_fromclip", nonpurgeable) 
{
	"# usage: x <- fromclip()  or  x <- fromclip(ncols)\n"
	"if($v==0){\n"
	"\tvecread(string:CLIPBOARD)\n"
	"}else{\n"
	"\t@n$$<-$1\n"
	"\tif(if(!isscalar(@n$$)||!isreal(@n$$)){T}\\\n"
	"\t\t\telseif(@n$$<0||@n$$!=floor(@n$$)){T}else{F}){\n"
	"\t\terror(\"ERROR: $1 not positive integer\")\n"
	"\t}\n"
	"\tmatrix(vecread(string:CLIPBOARD),@n$$)'\n"
	"}"
};

resource 'wstr' (10024, "_MV_toclip", nonpurgeable) 
{
	"#usage: toclip(x)  or (e.g.)  toclip(x,format:\"6.3f\",missing:\"NA\",linesep:\";\")\n"
	"if($v != 1){error(\"ERROR: usage is $S(x [,keyword phrases])\")}\n"
	"CLIPBOARD <- if($k == 0){$1}else{\n"
	"\tpaste($1,multiline:T,sep:\"\\t\",$K,\\\n"
	"\t\tformat:\".17g\",missing:\"?\",linesep:\"\\n\")\n"
	"};;"
};

resource 'wstr' (10025, "_MV_enter", nonpurgeable) 
{
	"# usage: x <- enter(3.1 2.75 3.12 4.5) (no commas needed)\n"
	"vecread(string:\"$0\")"
};

resource 'wstr' (10026, "_MV_model", nonpurgeable) 
{
	"#model(y=a+b), e.g., sets STRMODEL to \"y=a+b\"\n"
	"STRMODEL <- \"$1\";;"
};

resource 'wstr' (10027, "_MV_getmacros", nonpurgeable) 
{
	"#getmacros(macro1,macro2,...[,quiet:T]) retrieves macros from MACROFILE\n"
	"if($v==0){error(\"ERROR: must specify at least one macro name for $S\")}\n"
	"if(!isdefined(MACROFILE)){\n"
	"\terror(\"ERROR: CHARACTER variable MACROFILE does not exist\")}\n"
	"@args$$<-$A\n"
	"for(@i$$,run($v)){\n"
	"\t@macname$$<-@args$$[@i$$]\n"
	"\t<<@macname$$>> <- if($k==0){\n"
	"\t\tmacroread(MACROFILE,@macname$$)\n"
	"\t}else{\n"
	"\t\tmacroread(MACROFILE,@macname$$,$K)\n"
	"\t}\n"
	"};;"
};

resource 'wstr' (10028, "_MV_getdata", nonpurgeable) 
{
	"# y <- getdata(datasetName [,quiet:T]) retrieves data set from DATAFILE\n"
	"if($v>1){\n"
	"\terror(\"ERROR: too many arguments for $S\")\n"
	"}\n"
	"if($v==1){\n"
	"\tif($k==0){matread(DATAFILE,\"$1\")}else{matread(DATAFILE,\"$1\",$K)}\n"
	"}else{\n"
	"\tif($k==0){matread(DATAFILE)}else{matread(DATAFILE,$K)}\n"
	"}"
};

resource 'wstr' (10029, "_MV__END_", nonpurgeable)
{
	""
};
