/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 4.13 or later
*(C)*
*(C)* Copyright (c) 2002 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

/* Codes used in communiation between parser and yylex()*/
enum parseSkipCodes
{
	SKIPBRACKETBLOCK = 3,
	SKIPPARENBLOCK   = 4
};

/* 
   Codes used in communication of parser with Assign() in Symbol.c
   and Subassign() in Subassig.c.
   They allow checking of validity of left side of assignment before right
   side is evaluated.

   Added as defines 950808
*/
enum parseAssignCodes
{
	LEFTHANDSIDE    = 1,
	RIGHTHANDSIDE   = 2,
	KEYWORDASSIGN   = 3
};


/*
  Variables for communicating between parser and yylex()
*/
#ifdef MAINPARS_Y
long    PARSEARGS = 0; /*formerly PARSEMACROARGS*/
long    YYLEXMESSAGE = 0;
long    LASTCH = '\0';
long    BATCHBLOCKCOUNT = 0;
int     ALTINPUTTOKENS[5*MAXWDEPTH] = {0};
int    *ALTTOKENPTR = (int *) 0;
#else /*MAINPARS_Y*/
extern long     PARSEARGS;
extern long     YYLEXMESSAGE ;
extern long     LASTCH;
extern long     BATCHBLOCKCOUNT;
extern int      ALTINPUTTOKENS[];
extern int     *ALTTOKENPTR;
#endif /*MAINPARS_Y*/

#ifdef YYLEX_C
/*
  yylval is defined in mainpars.c
*/
#define Yylval       yylval
extern Symbolhandle  Yylval;  /*Symbol returned to parser*/
#endif /*YYLEX_C*/

/*
  The following are used in yylex.c and Macroset.c
  Added 030911; macroHeaderLength replaces HEADLENGTH
*/
enum macroHeaderCodes
{
	notAHeaderCode         = 0,
	inlineMacroHeaderCode  = ')',
	outlineMacroHeaderCode = ']',
	evaluationHeaderCode   = '}',
	headerChar2Code        = '#',
	headerChar4Code        = '#',
	macroHeaderLength      = 4
};

#ifdef MACROSET_C
char    INLINEMACROHEAD[macroHeaderLength + 1] =
{
	'{', headerChar2Code, (char) inlineMacroHeaderCode,  headerChar4Code, '\0'
};

char    OUTLINEMACROHEAD[macroHeaderLength + 1] =
{
	'{', headerChar2Code, (char) outlineMacroHeaderCode,  headerChar4Code, '\0'
};

char    EVALUATIONHEAD[macroHeaderLength + 1] =
{
	'{', headerChar2Code, (char) evaluationHeaderCode,  headerChar4Code, '\0'
};
#else /*MACROSET_C*/
extern  char INLINEMACROHEAD[];   /*"{#)#"*/
extern  char OUTLINEMACROHEAD[];  /*"{#]#"*/
extern  char EVALUATIONHEAD[];    /*"{#}#"*/
#endif /*MACROSET_C*/

/*
  The following are used in communicating between Byname() in Symbol.c
  and the parser
*/
enum parseArgsCodes
{
	normalParse = 0,
	quoteArgPunct,
	quoteArg
};
