/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 4.13 or later
*(C)*
*(C)* Copyright (c) 2003 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

/*
  This file defines constants used by functions in utils.c.

  030708 created by moving definitions from globdefs.h
*/

#ifndef UTILSH__
#define UTILSH__

/*
  Codes and defines used by scanPat(), matchName() in utils.c
  help(), list(), match(), keyvalue()
  030708 moved to mvutils.h from globdefs.h
*/
enum matchSymbolCodes
{
	WILDCARD   = '*',
	ANYCHAR    = '?'
};

/* 990528 added MATCHIGNORECASE to matchTypeCodes */
enum matchTypeCodes
{
	STARTMATCH      = 0x01,
	ENDMATCH        = 0x02,
	MIDDLEMATCH     = (STARTMATCH | ENDMATCH),
	EXACTMATCH      = 0x04,
	FOUNDANYCHAR    = 0x08,
	ANYMATCH        = 0x10,
	PATTERNTOOLONG  = 0x20,
	MATCHIGNORECASE = 0x40,
	MATCHTYPEOFFSET = 2*MATCHIGNORECASE
};

enum matchOpCodes
{
	noNameCheck =  0,
	topicNameCheck,
	variableNameCheck
};

/*
  opcodes for isInteger
  030708 moved to mvutils.h from globdefs.h
*/
enum isIntegerCodes
{
	ANYVALUE = 0,
	NEGATIVEVALUE,
	NONNEGATIVEVALUE,
	POSITIVEVALUE
};

/*
  010323 Codes for use with countArgs() in utils.c
  010516 moved to globdefs.h from globkb.h
  030708 moved to mvutils.h from globdefs.h
*/
enum argCountCodes
{
	nonKeywordArgCount = 0,
	keywordArgCount,
	nArgCountCodes
};

#endif /*UTILSH__*/
