/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 4.12 or later
*(C)*
*(C)* Copyright (c) 2001 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

/*
	Defines for MPW SC Compiler versions on Macintosh
	000510 now defines LESSTHANOREQUALTO, MORETHANOREQUALTO, NOTEQUALTO
	       LEFTSPECIALQUOTE and RIGHTSPECIALQUOTE
	010814 Added aditional compatible platforms
*/

#undef BASE_MACINTOSH
#define BASE_MACINTOSH

#undef OS_MACOS
#define OS_MACOS

#undef SKEL_TRANSKEL
#define SKEL_TRANSKEL

#undef COMP_MPWSC
#define COMP_MPWSC

#undef PROC_POWERPC
#define PROC_POWERPC


#define PLATFORM       PLATFORM_SC
#define PLATFORM_ALT1  PLATFORM_CW
#define PLATFORM_ALT2  PLATFORM_MPW
#define PLATFORM_ALT3  PLATFORM_MRC
#define PLATFORM_ALT4  PLATFORM_MAC
#define PLATFORM_ALT5  PLATFORM_CARBON
#define PLATFORM_ALT6  PLATFORM_COCOA

#define MACINTOSH
#define NOVALUESH          /* no useful values.h available*/
#define MAXINTEGER 4503599627370496.0 /*2^52*/
#define NOLGAMMA           /* no function lgamma() */

/* no distinction between binary and text files, e.g., Unix*/
#define TEXTREADMODE     "r"
#define BINARYREADMODE   "r"

#define TEXTWRITEMODE    "w"
#define BINARYWRITEMODE  "w"

#define TEXTAPPENDMODE   "a"
#define BINARYAPPENDMODE "a"

/*
	SEGMENTED not defined here; must have '-d SEGMENTED' as C compile option
	in Makefile if compiling under MPW or '#define SEGMENTED' in
	ProjectDefines.pch if compiline under IDE
*/
#define NPRODUCTS   50000  /*number of products between interrupt checks*/
#define CANSETFONTS        /*options 'font' and 'fontsize' meaningful*/
#define HASCLIPBOARD       /*CLIPBOARD "connected" to clipboard*/
#define MULTIPLOTWINDOWS   /* several plotting windows available */
#define EPSFPLOTSOK  1     /* make EPSF plots using quickdraw for preview */
#define SCREENDUMP         /*screendump implemented for plotting commands*/
#define SCROLLABLEWINDOW   /* output window is scrollable */
#define DEFAULTPLOTPAUSE  0 /* default is not pause after high resolution plot */
#define HASFINDFILE       /* has find file dialog box */
#define HASCONSOLEDIALOG  /* console input in dialog box */
#define HASDYNLOAD        /*has capability of dynamic loading*/
#define SIZEINTEGER  short /* used in typedef SIZEINTEGER Integer */
#define SIZELONGINT  long  /* used in typedef SIZELONGINT LongInt */
#define BDOUBLEHILOW
#define HASINFINITY
#define HASNAN
#define SAVEHISTORY
#define DEFAULTHISTORYLENGTH  100 /*980824 changed from 50*/
#ifndef MACANOVAINI
#define MACANOVAINI  "MacAnova.ini"
#endif /*MACANOVAINI*/

#define LESSTHANOREQUALTO  0xb2 /* Macintosh <= */
#define MORETHANOREQUALTO  0xb3 /* Macintosh >= */
#define NOTEQUALTO         0xad /* Macintosh != */
#define LEFTSPECIALQUOTE   0xc7 /* Macintosh << */
#define RIGHTSPECIALQUOTE  0xc8 /* Macintosh >> */

#define isNewline(C) ((C) == '\n' || (C) == '\r')

