/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 5.03 or later
*(C)*
*(C)* Copyright (c) 2006 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifndef TSERPROTH__
#define TSERPROTH__
/* Prototypes for FFT functions and other time series related functions */
/*
   960716 changed types Long, Double to long and double
   981213 dropped unused 5th argument n1 to qonerg()
   010109 removed doTserOps(), realft(), onecft(), onehft(), siprp(),
          srfp(), ssymrp(), rftkd(), r2ftk(), r4ftk(), r5ftk(),
          r8ftk(), rprftk()
   030305 added qxdiv()
   030317 changed protoType for qonerg(), qtworg(), qxprd() and qxdiv()
   060808 argument units added qrect()
*/

/* qft.c */
long qft(double * /*a*/, double * /*b*/, long /*m*/, long /*n*/,
		 long /*divByT*/, long /*iop*/);

/* tsersubs.c */
void qonerg(double * /*a*/, double * /*b*/, long /*dims*/ [2], long /*iop*/);
void qtworg(double * /*a*/, double * /*b*/, double * /*c*/, long /*dims1*/ [2],
			long /*dims2*/ [2], long /*iop*/);
void qconj(double * /*a*/, double * /*b*/, long /*m*/, long /*n*/,
		   long /*iop*/);
unsigned long qxprd(double * /*a*/, double * /*b*/, double * /*c*/,
					long /*dims1*/ [2], long /*dims2*/ [2], long /*iop*/);
unsigned long qxdiv(double * /*a*/, double * /*b*/, double * /*c*/,
					long /*dims1*/ [2], long /*dims2*/ [2], long /*iop*/);
void qconv(double * /*a*/, double * /*b*/, double * /*c*/, long /*m1*/,
		   long /*m2*/, long /*n*/, long /*decimate*/, long /*reverse*/);
void qreal(double * /*a*/, double * /*b*/, long /*m*/, long /*n*/,
		   long /*iop*/);
void qcmplx(double * /*a*/, double * /*b*/, double * /*c*/, long /*m*/,
			long /*n*/);
void qrect(double * /*a*/, double * /*b*/, long /*m*/, long /*n*/,
		   long /*unwind*/, double /*crit*/, double /*units*/, long /*iop*/);
void qhcopy(double * /*a*/, double * /*b*/, long /*m*/, long /*n*/,
			long /*iop*/);
void qpadto(double * /*in*/, double * /*out*/, long /*m1*/, long /*n*/,
			long /*m2*/);
void qrota(double * /*a*/, double * /*b*/, long /*m*/, long /*n*/,
		   long /*krot*/);
void qreverse(double * /*a*/, double * /*b*/, long /*m*/, long /*n*/);
void qunwnd(double * /*phase*/, long /*m*/, double /*oneCycle*/,
			double /*crit*/, long /*iop*/);

#endif /*TSERPROTH__*/
